( BR.FTH )
( interrupthandler for int01 and int03,  CPU := 80x86 )
( register will be dumped in hex via outport          )
( resident part and transient part use and occupy     )
( for communication the int66(h).                     )
( breakpoint [ $CC ] must be set in usersourcecode.   )
( This sourcecode can be compiled with 'naxos br'.    )

( Autor: K. Peper & A.Zissis )
( 10.7.92 / Rev. 1.4 20/09/93 works now with NAXOS 2.13 )

(short)

( ***************** )
( * resident part * )
( ***************** )

const base# $66 ; ( communication int Nr. )

( adresses to patch outport : )
label    emitah ;
label    emitdl ;
label    emiti# ;

	 proc emit 
( ** send char to outport ** )
( emit will be patched by BR )
( ************************** )
( arg: AL= character to emit )
( out: -                     )
( chg: AH                    )
( ************************** )
 [ $B4 ] label emitah [ $0e ] ( mov ah,0e )
 [ $BA ] label emitdl [ *0 ]  ( mov dx,0  ) 
 [ $CD ] label emiti# [ $10 ] ( int 10    )
;

( Variables in CS-segment )
csvar id    [ 'K' 'P' ] ;   ( signature )
csvar id1   [ 'A' 'Z' ] ;   ( signature ) 
csvar text
      " >AX= BX= CX= DX= SI= DI= BP= SP= SS= DS= ES= FS= GS= FL= " 
      ;
      Csvar intext
      "    NEXT: CS= IP= :::"
      ;
csvar port    [ 0 ] ;         ( outputport )
csvar w/d     [ 0 ] ;         ( registerwidth )
csvar dumpb/w [ 1 ] ;         ( dump byte/word )
csvar segmod  [ 0 ] ;         ( dump segment )       
csvar dumpseg [ *0 ] ;        ( value segment )
csvar ofsmod  [ 0 ] ;         ( dumpofsett )
csvar dumpofs [ *0 ] ;        ( value ofsett )
csvar reg     [ *$fc04 ] ;    ( regs to dump )
csvar temp    [ *0 ] ;        ( holds temporary values )



( macros for resident part )
      macro cs:
( ** CS: prefix ** )
( **************** )
(    chg: -        )
( **************** )
[ $2e ] 
;
 
	 MACRO m>a
( ** word from mem to AX ** )
( ************************* )
( arg: SI=  word_adress     )
( out: AX=  value n         )
( chg: AX                   )
( ************************* )
[ $8B $04 ]   ( mov ax,[si] )
;

	 MACRO m>al 
( ** Byte from mem to AL ** )
( ************************* )
( arg: SI=  byte_adress     )
( out: AL=  value c         )
( chg: AL AH                )
( ************************* )
[ $8A $04 ]  ( mov  al,[si] )
[ $B4 $00 ]  ( mov  ah,0    )
;

	 MACRO m>b
( ** word from mem to BX ** )
( ************************* )
( arg: SI=  word_adress     )
( out: BX=  value n         )
( chg: BX                   )
( ************************* )
[ $8B $1C ]
;

	 MACRO m>bl 
( ** Byte from mem to BL ** )
( ************************* )
( arg: SI=  byte_adress     )
( out: BL=  value c         )
( chg: BL BH                )
( ************************* )
[ $8A $1C ]   ( mov bl,[si] )
[ $30 $FF ]   ( xor bh,bh   )
;

	 MACRO m>d 
( ** word from mem to DI ** )
( ************************* )
( arg: SI=  word_adress     )
( out: DI=  value n         )
( chg: DI                   )
( ************************* )
[ $8B $3C ] ( mov di,[si]   )
;

	 MACRO a>m 
( *** store AX to mem *** )
( *********************** )
( arg: SI   word_adress   )
(      AX   value         )
( out: -                  )
( chg: -                  )
( *********************** )
[ $89 $04 ] ( mov [si],ax )
;


( procedures )

	: cr  
( *** emit CRLF *** )
( ***************** )
( arg: -            )
( out: -            )
( chg: AX           )
( ***************** )
A= $A emit A= $D emit
;

       : nib.h
( ** emit hex value of.. )
( * lower nipple in AL * )
( ********************** )
( arg: AL= value         )
( out: -                 )
( chg: AL AH             )
( ********************** )
[ $24 $0F ]  ( and al,0F )
[ $04 $90 ]  ( add al,90 )
[ $27 ]      ( daa       )
[ $14 $40 ]  ( adc al,40 )
[ $27 ]      ( daa       )
emit 
;

       label byte.h
( ** emit BL as unsigned ** )
( hexnumber, part of u.h ** )
( ************************* ) 
( arg: BL= value            )
( out: -                    )
( chg: AX                   )
( ************************* )
;

	 : u.h  
( **  emit BX as unsigned ** )
( **      hexnumber       ** )
( ************************** )
( arg: BX   value            )
( out: -                     )
( chg: AX                    )
( ************************** )
[ $51 ]        ( push cx     )
[ $89 $d8 ]    ( mov ax,bx   )
[ $b9 $0c 00 ] ( mov cx,12   )
[ $d3 $e8 ]    ( shr ax,cl   )
nib.h          ( call nibble )
[ $89 $d8 ]    ( mov ax,bx   ) 
[ $b9 $08 00 ] ( mov cx,8    )
[ $d3 $e8 ]    ( shr ax,cl   )
nib.h          ( call nibble )
[ $59 ]        ( pop cx      )
label byte.h   ( byte entry  )
[ $51 ]        ( push cx     )
[ $89 $d8 ]    ( mov ax,bx   ) 
[ $b9 $04 00 ] ( mov cx,4    )
[ $d3 $e8 ]    ( shr ax,cl   )
nib.h          ( call nibble )
[ $89 $d8 ]    ( mov ax,bx   )
nib.h          ( call nibble )
[ $59 ]        ( pop cx      )
;

	   : dumpset
( ** prepare dumpseg and ofs ** )
( ***************************** )
( arg: -                        )
( out: ES= dumpseg              )
(      DI= dumpofs              )
( chg: ?                        )
( ***************************** )
segmod m>al
case
1 of adr $0120 cs: m>b ;;  ( CS )
2 of adr $0126 cs: m>b ;;  ( SS )
3 of adr $0122 cs: m>b ;;  ( DS )
4 of adr $0124 cs: m>b ;;  ( ES ) 
5 of     [ $F $A0 $5B ] ;; ( FS ) 
6 of     [ $F $A0 $5B ] ;; ( GS )
else adr dumpseg   m>b  ( value )    
endcase 
[ $8E $C3  ]        ( mov es,bx )
ofsmod m>al
case
1 of adr $0116 cs: m>b ;;  ( BX )
2 of adr $0114 cs: m>b ;;  ( DX )
3 of adr $011C cs: m>b ;;  ( SI )
4 of adr $011E cs: m>b ;;  ( DI )
5 of adr $0118 cs: m>b ;;  ( SP )
6 of adr $011A cs: m>b ;;  ( BP ) 
else adr dumpofs   m>b  ( value )
endcase
[ $89 $df ]         ( mov di,bx )
;

	  : dump
( ** dump memory location ** )
( ************************** )
( arg: ES:DI= location       )
( out: -                     )
( chg: AX BX                 )
( ************************** )
, 32 emit , 32 emit , 32 emit 
[ $8c $c3 ]      ( mov bx,es )
u.h , ':' emit 
[ $89 $fb ]      ( mov bx,di )
u.h , '=' emit
 8 FOR
      , 32 emit
      [ $26 $8B $1D ]     ( mov bx,es:[di] )
      dumpb/w m>al [ $39 $C0 ] if- nz u.h
	      else byte.h
	      , 32 emit 
	      [ $88 $FB ] ( mov bl,bh )
	      byte.h
	      endif 
      [ $47 ]             ( inc di )
      [ $47 ]             ( inc di )
 NEXT
;

	 : rtxt
( ***  print regname  **** )
( ************************ )
( arg: BP= pointer to text )
( out: -                   )
( chg: AX BP CX            )
( ************************ )
[ $b9 4 0 ]     ( mov cx,4 )
FOR-
  cs: [ $8A $46 0 ] ( mov al,cs:[bp+0] ) 
  [ $45 ]           ( inc bp )
  emit 
NEXT- 
;

: .rtxt. ( - )
	 ( - )
	 ( - )
( ** print conditionally registername ** )
(    arg: BP pointer to text )
(    out: -         )
(    chg: AX BP     )
 [ $D1 $26 temp ]       ( shl temp,1 )
 if
    rtxt                ( print reg  )
 else
    [ $83 $c5 4 ]       ( add bp,04 )
 endif
;


macro w/d? 
( ** carryflag set if w/d:=1 ** )
(    arg: -                 )
(    out: CF:=0 if w/D = 0  )
(         CF:=1 if w/d = 1  )
(    chg: CF                )
[ $8A $16 w/d ]    ( mov dl,w/d )
[ $D1 $FA ]        ( sar dx,1   )
;
 
proc regs.
( ** print all selected registers ** )
(    arg: -           )
(    out: -           )
(    chg: AX BP SI ?  )
cr
cs: [ $bd text ]                   ( mov bp,text )
 adr reg cs: m>a adr temp cs: a>m
( AX )
.rtxt. if w/d? if
	       [ $66 $50 $5b $5b ] ( push eax pop bx pop bx )
	       u.h
	       endif
       adr $110  m>b  u.h
       endif
( BX ) 
.rtxt. if w/d? if
	       [ $66 $53 $5b $5b ] ( push ebx pop bx pop bx )
	       u.h
	       endif
       adr $116  m>b  u.h
       endif
( CX )       
.rtxt. if w/d? if
	       [ $66 $51 $5b $5b ] ( push ecx pop bx pop bx )
	       u.h
	       endif
       adr $112  m>b  u.h
       endif
( DX )       
.rtxt. if w/d? if
	       [ $66 $52 $5b $5b ] ( push edx pop bx pop bx )
	       u.h
	       endif
       adr $114  m>b  u.h
       endif
( SI )       
.rtxt. if w/d? if
	       [ $66 $56 $5b $5b ] ( push esi pop bx pop bx )
	       u.h
	       endif
       adr $11c  m>b  u.h
       endif
( DI )      
.rtxt. if w/d? if
	       [ $66 $57 $5b $5b ] ( push edi pop bx pop bx )
	       u.h
	       endif
       adr $11E  m>b  u.h
       endif
cr
( BP )       
.rtxt. if w/d? if
	       [ $66 $55 $5b $5b ] ( push ebp pop bx pop bx )
	       u.h
	       endif
       adr $11A  m>b  u.h
       endif
( SP )       
.rtxt. if w/d? if
	       [ $66 $54 $5b $5b ] ( push esp pop bx pop bx )
	       u.h
	       endif
       adr $118  m>b  u.h
       endif
( SS )   
.rtxt. if adr $126  m>b  u.h
       endif
( DS )       
.rtxt. if adr $122  m>b  u.h
       endif
( ES )
.rtxt. if adr $124  m>b  u.h
       endif
( FS )
.rtxt. if w/d? if
	       [ $0F $A0 $5b ]     ( push fs pop bx )
	       u.h
	       else , 32 emit
	       endif
       endif
( GS )
.rtxt. if w/d? if
	       [ $0F $A8 $5b ]     ( push gs pop bx )
	       u.h
	       else , 32 emit
	       endif
       endif
( FL )
.rtxt. if adr $128   m>b
       u.h
       endif
( next: dump CS,IP )
cr cs: [ $bd intext ]              ( mov bp,intext )
   rtxt
   rtxt 
   rtxt adr $120  m>b 
	[ $8E $C3 ]                ( mov es,bx )
	u.h  
   rtxt adr $12A  m>b 
	[ $89 $DE ]                ( mov si,bx )
	u.h
   rtxt , ':' emit 
   12 FOR
	[ $26 $8a $1c ]            ( mov bl,es:[si] )
	[ $46 ]                    ( inc si )
	, 32 emit 
	byte.h 
   NEXT
cr
;


: key??
( ** wait for and analyze key ** )
(    arg: -           )
(    out: -           )
(    chg: AX BP SI ?  )
dumpset
dump cr
begin
[ $b4 $00 ]              ( mov ah,00 )
[ $CD $16 ]              ( int 16    ) ( get key )
[ $b4 $00 ]              ( mov ah,00 )
  case
  '+' of dump cr ;;
  '-' of [ $83 $ef $20 ] ( sub di,20 )   
	 dump cr ;; 
  't' of , 'T' emit
	 [ $A1 $0128 ]   ( mov ax,[128] ) ( Flag )
	 [ $0D $00 $01 ] ( or  ax,0100  ) ( TF:=1 )
	 [ $A3 $0128 ]   ( mov [128],ax ) 
	 [ $C3 ] ;;      ( exit )
  'g' of , 'G' emit               
	 [ $A1 $0128 ]   ( mov ax,[128] ) ( Flag )
	 [ $25 $FF $FE ] ( and ax,FEFF  ) ( TF:=0 )
	 [ $A3 $0128 ]   ( mov [128],ax )
	 [ $C3 ] ;;      ( exit ) 
  else , 7 emit     
  endcase
again
;


: inthandler
( handles interrupt, dumps register, waits for key ** )
(    arg: -         )
(    out: -         )
(    chg: TF        )
[ $2E $89 $16 $0114 ]   ( mov cs:[114],dx   ) ( DX )
[ $2E $8F $06 $012A ]   ( pop cs:[012A]     ) ( IP )
[ $2E $8F $06 $0120 ]   ( pop cs:[0120]     ) ( CS )
[ $2E $8F $06 $0128 ]   ( pop cs:[0128]     ) ( FL )
[ $2e $8C $16 $0126 ]   ( mov [126],ss      ) ( SS )
[ $2e $89 $26 $0118 ]   ( mov [118],sp      ) ( SP )
[ $8C $CA ]             ( mov dx,cs         )
[ $8E $D2 ]             ( mov ss,dx         ) ( SS=CS )
[ $BC $0E 1 ]           ( mov sp,10e        ) ( stackarea=FCB1 )
[ $2E $8C $1E $0122 ]   ( mov cs:[122],ds   ) ( DS )
[ $8E $DA ]             ( mov ds,dx         ) ( DS=CS )
( save registers )
[ $A3 $0110 ]           ( mov [110],ax      ) ( AX )
[ $89 $1E $0116 ]       ( mov [116],bx      ) ( BX )
[ $89 $0E $0112 ]       ( mov [112],cx      ) ( CX )
[ $89 $2E $011A ]       ( mov [11A],bp      ) ( BP )
[ $89 $36 $011C ]       ( mov [11C],si      ) ( SI )
[ $89 $3E $011E ]       ( mov [11E],di      ) ( DI )
[ $8C $06 $0124 ]       ( mov [124],es      ) ( ES )
[ $FB ]                 ( sti               )
[ $FC ]                 ( cld               )
regs.
key??
( interrupt out, restore register )
[ $A1 $10 $01 ]         ( mov ax,[$110]    ) 
[ $8B $0E $12 $01 ]     ( mov cx,[$112]    )
[ $8B $16 $14 $01 ]     ( mov dx,[$114]    ) 
[ $8B $1E $16 $01 ]     ( mov bx,[$116]    )
[ $8B $2E $1A $01 ]     ( mov bp,[$11A]    ) 
[ $8B $36 $1C $01 ]     ( mov si,[$11C]    )
[ $8B $3E $1E $01 ]     ( mov di,[$11E]    ) 
[ $8E $06 $24 $01 ]     ( mov es,[$124]    )
[ $8E $1E $22 $01 ]     ( mov ds,[$122]    )
[ $2e $8E $16 $26 $01 ] ( mov ss,cs:[$126] ) ( SS )
[ $2e $8B $26 $18 $01 ] ( mov sp,cs:[$118] ) ( SP )
[ $2E $FF $36 $0128 ]   ( push cs:[0128]   ) ( FL )
[ $2E $FF $36 $0120 ]   ( push cs:[0120]   ) ( CS )
[ $2E $FF $36 $012A ]   ( push cs:[012A]   ) ( IP )
[ $CF ]                 ( iret             )
;

proc (res)
( ** marks end of resident part ** )
[ $90 $90 $90 $90 $90 $90 $90 $90 ]
[ $90 $90 $90 $90 $90 $90 $90 $90 ]
;



( ******************** )
( ** Transient Part ** )
( ******************** )

( ** screen-routines ** )

var v-atrib  [     7   ] ; ( video-attribut )
var v-ofs    [     *0  ] ; ( video ofset )
var v-seg    [ *$B800  ] ; ( video-segment )

:  intens   [ $80 $0E v-atrib $08 ] ( or  atr,08 ) ;
: -intens   [ $80 $26 v-atrib $F7 ] ( and atr,F7 ) ;

: bcolor 
( ** backgroundcolor n := 0 - 7 ** )
(    arg: BL color  )
(    out: -         )
(    chg: -         )
    [ $89 $DA ]             ( mov dx,bx   )
    [ $81 $E2 7 0 ]         ( and dx,07   )  
    [ $80 $26 v-atrib $8F ] ( and atr,8F  )
    [ $D1 $E2 ]             ( shl dx,1    )
    [ $D1 $E2 ]             ( shl dx,1    )
    [ $D1 $E2 ]             ( shl dx,1    )
    [ $D1 $E2 ]             ( shl dx,1    )
    [ $08 $16 v-atrib ]     ( or  atr,dl  )
;

: fcolor 
( ** foregroundcolor n := 0 - 7 ** )
(    arg: BL color  )
(    out: -         )
(    chg: -         )
    [ $89 $DA ]             ( mov dx,bx   )
    [ $81 $E2 7 0 ]         ( and dx,07   ) 
    [ $80 $26 v-atrib $F8 ] ( and attr,F8 )
    [ $08 $16 v-atrib ]     ( or  attr,dl )
;

: color
( ** set colors ** )
(    arg: BL foreground 0 - 7 )
(         AL background 0 - 7 )
(    out: -                   )
(    chg: BL                  )
fcolor
[ $89 $C3 ]  ( mov bx,ax      )
bcolor
;

: v-xy  ( col,row => ? )
( ** calc sreenadr from row & column ** )
( ** adr := 160*row + 2*col ** )
( ** adr stored in v-ofs    ** )
(    arg: BL column (x)        )
(         AL row (y)           )
(    out: -                    )
(    chg: AX BX                )
( ax *10 )
[ $D1 $E0 ]    ( shl ax,1  )
[ $89 $C2 ]    ( mov dx,ax )
[ $D1 $E0 ]    ( shl ax,1  )
[ $D1 $E0 ]    ( shl ax,1  )
[ $01 $D0 ]    ( add ax,dx )
( ax *16 )
[ $D1 $E0 ]    ( shl ax,1  )
[ $D1 $E0 ]    ( shl ax,1  )
[ $D1 $E0 ]    ( shl ax,1  )
[ $D1 $E0 ]    ( shl ax,1  )
( bx *2 )
[ $D1 $E3 ]    ( shl bx,1  )
[ $01 $D8 ]    ( add ax,bx )
[ $A3 v-ofs ]  ( mov [v-ofs],ax )
;

: v-emit 
( ** send char+atr to screen ** )
( ** atr according atr-byte  ** )
(    arg: BL character )
(    out: -            )
(    chg: ES:DI AX     )
[ $8A $26 v-atrib ] ( mov ah,atr     )
[ $88 $D8 ]         ( mov al,bl      )
[ $c4 $3E v-ofs ]   ( les di,v-ofs   )
[ $26 $89 $05 ]     ( mov es:[di],ax )
[ $83 6 v-ofs 2 ]   ( add v-ofs,2    )
;

: v-emit-hor 
( ** send char+attr i times to screen ** )
(    arg: BL character )
(         AL how many? )
(    out: -            )
(    chg: ES:DI AX BH  )
[ $B4 $00 ]         ( mov ah,0       )
[ $3d 0 0 ]         ( cmp ax,0       )
[ $75 $01 ]         ( jne 01         )
[ $C3 ]             ( exit           )
[ $88 $c7 ]         ( mov bh,al      ) ( save i )
[ $51 ]             ( push cx        )
[ $89 $C1 ]         ( mov cx,ax      )
[ $8A $26 v-atrib ] ( mov ah,atr     )
[ $88 $D8 ]         ( mov al,bl      )
[ $c4 $3E v-ofs ]   ( les di,v-ofs   )
FOR-
[ $26 $89 $05 ]     ( mov es:[di],ax )
[ $47 $47 ]         ( inc di inc di  )
NEXT-
[ $89 $3E v-ofs ]   ( mov v-ofs,di   )
[ $88 $F8 ]         ( mov al,bh      ) ( restor i )
[ $59 ]             ( pop cx         )
; 

: v-emit-vert 
( ** send char+attr i times to screen ** )
(    arg: BL character )
(         AL how many? )
(    out: -            )
(    chg: ES:DI AX BH  )
[ $B4 $00 ]         ( mov ah,0       )
[ $3d 0 0 ]         ( cmp ax,0       )
[ $75 $01 ]         ( jne 01         )
[ $C3 ]             ( exit           )
[ $51 ]             ( push cx        )
[ $89 $C1 ]         ( mov cx,ax      )
[ $8A $26 v-atrib ] ( mov ah,atr     )
[ $88 $D8 ]         ( mov al,bl      )
[ $c4 $3E v-ofs ]   ( les di,v-ofs   )
FOR-
[ $26 $89 $05 ]     ( mov es:[di],ax )
[ $81 $C7 $A0 0 ]   ( add di,A0      )
NEXT-
[ $89 $3E v-ofs ]   ( mov v-ofs,di   )
[ $59 ]             ( pop cx         )
;

: v-$. 
( ** string with attributes to screen ** )
( ** string must have 0-terminator    ** )
( ** atr according to atr-byte        ** )
( ** atr-byte can be changed by...    ** )
( ** instring switches |              ** )
(    arg: SI stringadr(countbyte)  )
(    out: -                        )
(    chg: ES:DI AX BX              )
[ $c4 $3E v-ofs ]   ( les di,v-ofs     )
[ $8a $3e v-atrib ] ( mov bh,[v-atrib] )
[ $30 $E4 ]         ( xor ah,ah        )
BEGIN
  BEGIN
    [ $8A $04 ]         ( mov al,[si]      )
    [ $46 ]             ( inc si           )
    [ $08 $C0 ]         ( or al,al         ) ( terminate? )
      IF- Z
	[ $88 $3E v-atrib ] ( mov [v-atrib],bh ) ( yes  )
	[ $89 $3E v-ofs ]   ( mov [v-ofs],di   )
	[ $C3 ]             ( return           ) ( exit )
      ENDIF
    [ $3C $7C ]         ( cmp al,'|'       )  ( switch? )
  WHILE- NE
    [ $88 $C3 ]         ( mov bl,al        )
    [ $26 $89 $1D ]     ( mov es:[di],bx   )
    [ $47 $47 ]         ( inc di inc di    )
  REPEAT 
( switch: )
[ $8a $04 ]         ( mov al,[si]      )
  CASE
   'B' OF [ $80 $CF $80 ] ( or  bh,80 ) ;;
   'b' OF [ $80 $E7 $7F ] ( and bh,7F ) ;;
   'N' OF [ $B7 $07 ]     ( mov bh,07 ) ;;
   'I' OF [ $80 $CF $08 ] ( or  bh,08 ) ;;
   'i' OF [ $80 $E7 $F7 ] ( and bh,F7 ) ;;
   'R' OF [ $80 $F7 $7F ] ( xor bh,7F ) ;;
   'F' OF [ $46 ]         ( inc si       )
	  [ $8A $04 ]     ( mov al,[si]  )
	  [ $24 $07 ]     ( and al,07    )
	  [ $80 $E7 $F8 ] ( and bh,F8    )
	  [ $08 $C7 ] ;;  ( or  bh,al    ) 
   'C' OF [ $46 ]         ( inc si       )
	  [ $8A $04 ]     ( mov al,[si]  )
	  [ $24 $07 ]     ( and al,07    )
	  [ $D1 $E0 ]     ( shl ax,1     )
	  [ $D1 $E0 ]     ( shl ax,1     )
	  [ $D1 $E0 ]     ( shl ax,1     )
	  [ $D1 $E0 ]     ( shl ax,1     )                     
	  [ $80 $E7 $8F ] ( and bh,8F    )
	  [ $08 $C7 ] ;;  ( or  bh,al    )
  ENDCASE
[ $46 ]                   ( inc si       )
AGAIN
;

: v-xyl ( - )
( ** screen position left ** )
(    arg: -    )
(    out: -    )
(    chg: -    )
[ $81 $2e v-ofs 2 0 ] ( sub v-ofs,2 )
;
 
: v-xyd ( - )
( ** screenposition down ** )
(    arg: -    )
(    out: -    )
(    chg: -    )
[ $81 6 v-ofs $A0 0 ] ( add v-ofs,A0 )
;

: v-xyld ( - )
( ** screenposition left & down ** )
(    arg: -    )
(    out: -    )
(    chg: -    )
[ $81 6 v-ofs $9e 0 ] ( add v-ofs,9e )
;

: c-xy
( ** position cursor to xy ** )
(    arg: BL column (x)  )
(         AL row (y)     )
(    out: -              ) 
(    chg: ES:DI SI ?     )
[ $31 $D2 ]           ( xor dx,dx       )
[ $8E $C2 ]           ( mov es,dx       )
[ $88 $Da ]           ( mov dl,bl       )
[ $88 $c6 ]           ( mov dh,al       )
[ $26 $89 $16 $50 4 ] ( mov es:[450],dx )
[ $b4 $02 ]           ( mov ah,2        )
[ $cd $10 ]           ( int 10          )
;

: c-line
( ** cursorshape:= line ** )
(    arg: -            )
(    chg: - DI SI ?    )
[ $51 ]               ( push cx         )
[ $b5 $06 ]           ( mov ch,06       )
[ $b1 $07 ]           ( mov cl,07       )
[ $b4 $01 ]           ( mov ah,1        )
[ $cd $10 ]           ( int 10          )
[ $59 ]               ( pop cx          )
;


var (vbox) [ 0 0 ] ; ( deltay:deltax )
: v-box 
( ** draw a box with boxcharacters ** )
( ** syntax: frame to coord v-box  ** )
(    arg: DI   adr-coordinates )
(         SI   adr_boxchars    )
(    out: -                    )
(    chg: AX BX DI             )
[ $8b $1d ]       ( mov bx,[di]   ) ( y:x )
[ $88 $f8 ]       ( mov al,bh     ) ( y )
[ $b7 $00 ]       ( mov bh,00     )
[ $b4 $00 ]       ( mov ah,00     )
  v-xy
[ $ff $36 v-ofs ] ( push v-ofs    ) ( save corner )
[ $8b $45 2 ]     ( mov ax,[di+2] ) ( delta y,x ) 
[ $A3 (vbox) ]    ( mov (vbox),ax ) ( save ) 
[ $8A $5c $00 ]   ( mov bl,[si]   ) ( upperleft corner )  
  v-emit
[ $8A $5C $01 ]   ( mov bl,[si+1] ) ( upper hor char )
[ $a1 (vbox) ]    ( mov ax,(vbox) ) ( delta x )
  v-emit-hor
[ $8A $5C $02 ]   ( mov bl,[si+2] ) ( upperright corner )   
  v-emit
  v-xyld
[ $8A $5C $04 ]   ( mov bl,[si+4] ) ( right vert char )
[ $a1 (vbox) ]    ( mov ax,(vbox) )
[ $88 $e0 ]       ( mov al,ah     ) ( delta y )
  v-emit-vert
[ $8f $06 v-ofs ] ( pop v-ofs     ) ( restore corner ) 
  v-xyd 
[ $8A $5C $03 ]   ( mov bl,[si+3] ) ( left vert char )
[ $a1 (vbox) ]    ( mov ax,(vbox) )
[ $88 $e0 ]       ( mov al,ah     ) ( delta y )
  v-emit-vert
[ $8A $5C $05 ]   ( mov bl,[si+5] ) ( lowerleft corner )  
  v-emit
[ $8A $5C $06 ]   ( mov bl,[si+6] ) ( lower hor char )
[ $a1 (vbox) ]    ( mov ax,(vbox) ) ( delta x )
  v-emit-hor
[ $8A $5C $07 ]   ( mov bl,[si+7] ) ( lowerright corner )   
  v-emit
; 

: v-cls  ( char,? )
	 ( => ? ) 
	 ( - )
( ** fill videoscreen with char ** )
( ** attribut is used           ** )
(    arg: AL character   )
(    out: -              ) 
(    chg: ES:DI SI ?     )
[ $51 ]             ( push cx      )
[ $B9 $7D0 ]        ( mov cx,7d0   )
[ $8A $26 v-atrib ] ( mov ah,atr   )
[ $88 $D8 ]         ( mov al,bl    )
[ $8B $16 v-seg ]   ( mov dx,v-seg )
[ $8E $C2 ]         ( mov  es,dx   )
[ $BF 0 0 ]         ( mov  di,0    )
[ $F3 $AB ]         ( rep  stosw   )
[ $59 ]             ( pop  cx      )
0 , 0 c-xy
;
 
( ** end sreenrouts ** )


var rp        [  *0  ] ; ( cs of resident part )

( variables for status  )
var regsel    [ *$80 ] ; ( registerselect )
var dumpsegment [ *0 ] ; ( segmentvalue )
var dumpoffset  [ *0 ] ; ( offsetvalue )


: setint  
( ** Set interrupt number i  ** )
( ** with adr of a procedure ** )
(    arg: BL intnumber   )
(         ES:DI procadr  )
(    out: -              ) 
(    chg: AX             )
  [ $1E ]     ( push ds   )
  [ $8C $C0 ] ( mov ax,es )
  [ $8E $D8 ] ( mov ds,ax )
  [ $89 $FA ] ( mov dx,di )
  [ $88 $D8 ] ( mov al,bl )
  [ $B4 $25 ] ( mov ah,25 )
  [ $CD $21 ] ( int 21    )
  [ $1F ]     ( pop ds    )
;

: getint  
( ** get adr of procedure of ** )
( ** interrupt number i      ** )
(    arg: BL intnumber   )
(    out: ES:DI procadr  ) 
(    chg: ES:DI AX       )
  [ $88 $D8 ] ( mov al,bl  )
  [ $B4 $35 ] ( mov ah,#35 )
  [ $CD $21 ] ( int 21     )
  [ $89 $DF ] ( mov di,bx  ) 
;

: .t386. 
( ** is processor = 386 ? **  )
(    arg: -        )
(    out: CF:=0 if cpu<=286   )
(         CF:=1 if cpu>=386   ) 
(    chg: CF                  )
[ $31 $C0 ]     ( xor ax,ax   )
[ $50 ]         ( push ax     )
[ $9D ]         ( popf        )
[ $9C ]         ( pushf       )
[ $58 ]         ( pop ax      )
[ $25 $00 $F0 ] ( and ax,f000 )
[ $3D $00 $F0 ] ( cmp ax,f000 )
[ $74 $0F ]     ( je no       )
[ $B8 $00 $70 ] ( mov ax,7000 )
[ $50 ]         ( push ax     )
[ $9D ]         ( popf        )
[ $9C ]         ( pushf       )
[ $58 ]         ( pop ax      )
[ $25 $00 $70 ] ( and ax,7000 )
[ $74 $03 ]     ( je no       )
[ $F9 ]         ( stc         )
[ $EB $01 ]     ( jz exit     )
( no: )
[ $F8 ]         ( clc         )
;

( further macros for transient part )

MACRO al>m 
( ** store AL at [SI]    ** )
(    arg: SI adress of byte )
(         AL byte to store  )
(    out: -                 )
(    chg: -                 )
[ $88 $04 ]  ( mov  [si],al )
;

	MACRO m-on 
( ** set byte in mem to -1 ** )
( *************************** )
( arg: SI= byte_ adress       )
( out: -                      )
( chg: -                      )
( *************************** )
[ $C6 $04 $FF ] ( mov [si],-1 )
;

	MACRO m-off 
( ** set byte in mem to 0  ** )
( *************************** )
( arg: SI= byte_adress        )
( out: -                      )
( chg: -                      )
( *************************** )
[ $C6 $04 0 ] ( mov [si],00   )
;

       MACRO bl>m 
( *** store  BL to mem *** )
( ************************ )
( arg: BL= byte to store   )
(      SI= mem_adr         )
( out: -                   )
( chg: -                   )
( ************************ )
[ $88 $1C ]  ( mov [si],bl )
;

macro rp>e
( ** move [rp] to ES ** )
(    arg: -   )
[ $8e $06 rp ] ( mov es,[rp] )
;

MACRO + 
( ** add BX to AX ** )
(    arg: AX n1      )
(         BX n2      )
(    out: AX:= n1+n2 )
(    chg: AX         )
[ $01 $D8 ] ( add ax,bx )
;

MACRO adr+ 
( ** increase SI by 1 ** )
(    arg: SI adress   )
(    out: SI adress+1 )
(    chg: SI          )
[ $46 ]  ( inc si )
;

macro es:
( ** ES-prefix ** )
(    arg: -  )
[ $26 ]
;

MACRO cs>e  ( - )
( ** move CS to ES ** )
(    arg: -    )
(    chg: ES   )
[ $8C $CA ] ( mov dx,cs )
[ $8E $C2 ] ( mov es,dx )
;


MACRO .=. 
( ** AX = BX ?? ** )
(    arg: AX n1    )
(         BX n2    )
(    out: CF:=0 if n1<>n2 )
(         CF:=1 if n1=n2  )
(    chg: CF   )
[ $39 $D8 ] ( cmp  ax,bx )
[ $F8 ]     ( clc        )
[ $75 1 ]   ( jnz  +1    )
[ $F5 ]     ( cmc        )
;

MACRO a>b 
( ** copy AX to BX ** )
(    arg: AX word n   )
(    out: BX n        )
(    chg: BX          )
[ $89 $C3 ] ( mov bx,ax )
;

MACRO b>a 
( ** copy BX to AX ** )
(    arg: BX word n   )
(    out: AX n        )
(    chg: AX          )
[ $89 $D8 ] ( mov ax,bx )
;

MACRO m>adr 
( ** ADR mit Wert aus Adresse laden ** )
( ** load SI with value at [SI] ** )
(    arg: SI  adress  )
(    out: SI  adress' )
(    chg: SI          )
[ $8B $34 ]   ( mov si,[si] )
;

MACRO B/m+ 
( ** increase byte at adr by 1 ** )
(    arg: SI byteadr  )
(    out: -           )
(    chg: -           )
[ $FE $04 ] ( inc  b/[si]  )
;

	 : modinc 
( ** increase modcounter ** )
( ** modcounter has 2 bytes:)
(  [ currentbyte,maxbyte ]  )
( if count = max, count = 0 )
(    arg: AL currentvalue   )
(         BL maxvalue       )
(    out: AL (current+1)|0  )
(    chg: AL                )
[ $8b $04 ] ( mov ax,[si] )
[ $38 $e0 ] ( cmp al,ah )
[ $72 $02 ] ( jb 02 )
[ $b0 $ff ] ( mov al,ff )
[ $fe $c0 ] ( inc al )
[ $88 $04 ] ( mov [si],al )
;


: resident  
( ** make code resident up to (res) ** )
( ** Exit to DOS transient program  ** )
(    arg: -       )
(    out: -       )
base#            ( mov bx,base# )
D= inthandler    ( mov di,inthandler )
cs>e             ( mov es,cs )
setint 
[ $ba (res) ]    ( mov dx,(res) )
[ $d1 $EA ]      ( shr dx,1    )
[ $d1 $EA ]      ( shr dx,1    )
[ $d1 $EA ]      ( shr dx,1    )
[ $d1 $EA ]      ( shr dx,1    )
[ $42 ]          ( inc dx      )
[ $B8 $00 $31 ]  ( mov ax,3100 )
[ $CD $21 ]      ( int 21      )
;

: testid
( ** test signature of resident part ** )
(    arg: -   )
(    out: CF:=0 if not there )
(         CF:=1 if present   )
(    chg: ?                  )
   base# getint
   [ $8c $06 rp ]      ( mov rp,es )
( get id of resident part and test )
   [ $26 $A1 id ]      ( mov ax,rp:id )
   [ $3d $504B  ]      ( cmp ax,'KP' )
   [ $F8 ]             ( clc )   
   [ $75 $0B ]         ( jnz ex )
   [ $26 $A1 id1 ]     ( mov ax,rp:id1 )
   [ $3d $5A41 ]       ( cmp ax,'AZ' )
   [ $F8 ]             ( clc )
   [ $75 $01 ]         ( jnz ex )
   [ $F9 ]             ( stc )
;

: .hexdigit.  ( -,c => -,n ) ( f )
	      ( - )
	      ( - )
( ** Convert Hexcharacter in number  ** )
(    arg: AL hexchar(upper|lowercase) )
(    out: AL number 0 - 15            )
(         CF:=1 if valid char         )
(         CF:=0 if not valid          )
(    chg: AL CF                       )
[ $2C $30 ]  ( sub al#,30 )
[ $72 $10 ]  ( jc ex      )
[ $3C $0A ]  ( cmp al,#0A )
[ $F5 ]      ( cmc        )
[ $73 $0B ]  ( jnc ex     )
[ $24 $5F ]  ( and al,#5F )
[ $2C $07 ]  ( sub al,#07 )
[ $3C $0A ]  ( cmp al,#0A )
[ $72 $03 ]  ( jc ex      )
[ $3C $10 ]  ( cmp al,#10 )
[ $F5 ]      ( cmc        )
[ $F5 ]      ( ex: cmc    )
;

( variables for field and item management )
var coor  [ 17 5 5 1 ] ;   ( x y lenx-1 leny-1 )
var field [ 0 5 ] ;         ( current_field, fieldmax )
var item  [ 0 0 ] ;         ( current_item , itemmax  )

var field0 [ 0 3 5 ] ;  ( current_item, itemmax, y )
var field1 [ 0 0 8 ] ; 
var field2 [ 0 1 11 ] ; 
var field3 [ 0 6 14 ] ; 
var field4 [ 0 6 17 ] ; 
var field5 [ 0 13 21 ] ; 

var itemstrt  [ 17 24 31 38 45 52 59 ] ; ( x-values )
var regstrt   [ 20 24 28 32 36 40 44 
		48 52 56 60 64 68 72 ] ; ( x-values )
var inflag    [ 0  ] ; ( indicates hexin )
var temp#     [ *0 ] ; ( hold number )                
var boxchar
[  '' '' '' 
   ''     '' 
   '' '' '' ] ;


: screencolor
( arg: -     )
( out: -     )
( chg: AL BL )
3 , 0 color ;

: framecolor
( arg: -     )
( out: -     )
( chg: AL BL )
4 , 0 color ;

: msgcolor
( arg: -     )
( out: -     )
( chg: AL BL )
6 , 0 color ;

: msg1
0 , 24 v-xy  msgcolor
"       ESC:= Exit      SPACE,TAB:= Next_item       RET:= Next_field " v-$.
screencolor ;
: msg2
0 , 24 v-xy  msgcolor
"       ESC:=Exit   TAB:=Toggle   SPACE:=Next_item   RET:=Next_field " v-$.
screencolor ;
: msg3
0 , 24 v-xy  msgcolor
"     ESC:= Exit   #:=Hex_in    SPACE:= Next_item    RET:= Next_field" v-$.
screencolor ;
: msg4
0 , 24 v-xy  msgcolor
"               Enter 4 hexdigits:    0-9    a-f    A-F              " v-$.
screencolor ;


: drawbox
( ** draw a box ** )
boxchar to coor v-box
;

: hexin# 
( ** input hexnumber ** )
(    arg: BL how many positions? )
(    out: AX number              )
(    chg: AX DI SI ?             )
D= 0
FOR
[ $b4 $00 ]              ( mov ah,00 )
[ $CD $16 ]              ( int 16    ) ( get key )
[ $b4 $00 ]              ( mov ah,00 )  
a>b
 .hexdigit. 
	  if  ( Ziffer )
	  [ $d1 $e7 ] ( shl di,1 )
	  [ $d1 $e7 ] ( shl di,1 )
	  [ $d1 $e7 ] ( shl di,1 )
	  [ $d1 $e7 ] ( shl di,1 ) ( 16* )        
	  [ $01 $c7 ] ( add di,ax )
	  b>a emit
	  else , 7 emit [ $41 ] ( inc cx )
	  endif
NEXT
, 8 emit , 8 emit , 8 emit , 8 emit
temp# 
[ $89 $3c ] ( mov [si],di )       
; 

: readargs
( ** read arguments from resident part ** )
(    arg: -        )
(    out: -        )
(    chg: ES AX SI )
rp>e
port es: m>al
field0 al>m
w/d  es: m>al
field1 al>m
dumpb/w  es: m>al
field2 al>m
segmod  es: m>al
field3 al>m
ofsmod  es: m>al
field4 al>m
dumpseg  es: m>a
dumpsegment a>m
dumpofs  es: m>a
dumpoffset a>m
reg es: m>a
regsel a>m
;

: savepar
( ** set arguments of resident part ** )
(    arg: -        )
(    out: -        )
(    chg: ES AX SI )
rp>e
field0 m>al
port es: al>m
field1 m>al
w/d  es: al>m
field2 m>al
dumpb/w es: al>m
field3 m>al
segmod es: al>m
field4 m>al
ofsmod es: al>m
dumpsegment m>a
dumpseg es: a>m
dumpoffset m>a
dumpofs es: a>m
regsel m>a
reg es: a>m
;


: 2^i  
( ** i to power of two  ** )
(   arg: BL 0 <= i <= 15   )
(   out: BX := 2^i         )
(   chg: BX                )
[ $89 $CA ]   ( mov  dx,cx )
[ $89 $d9 ]   ( mov  cx,bx )
[ $BB 1 0 ]   ( mov  bx,1  )
[ $D3 $E3 ]   ( shl  bx,cl )
[ $89 $D1 ]   ( mov  cx,dx )
;

: clrbit 
( **  clear bit i in regsel  ** )
( **    0 <= i <= 15         ** )
(    arg: BL position i )
(    out: -             )
(    chg: BX            )
2^i 
[ $f7 $d3 ]         ( not bx )
[ $21 $1e regsel ]  ( and [regsel],bx )
;

: setbit 
( **  set bit i in regsel  ** )
( **    0 <= i <= 15       ** )
(    arg: BL position i )
(    out: -             )
(    chg: BX            )
2^i
[ $09 $1e regsel ] ( or [regsel],bx ) 
;

: .bit.   ( i,- )
	      ( - )
	      ( adr )
( **  Hole Wert vom i. Bit ** )
( **      0 <= i <= 15     ** )
(    arg: BL position i  )
(         SI adr of word )
(    out: CF:=0 if bit=0 )
(         CF:=1 if bit=1 )
(    chg: CF             )
[ $51 ]       ( push cx       )
[ $89 $d9 ]   ( mov  cx,bx    )
[ $8b $14 ]   ( mov  dx,[si]  )
[ $D3 $EA ]   ( shr  dx,cl    )
[ $d1 $ea ]   ( shr  dx,1     )
[ $59 ]       ( pop  cx       ) 
;

: toggle
( ** toggle registerselect ** )
(    arg: -   )
field5 m>al       ( current reg )
[ $b4 $00 ]       ( mov ah,00 )
regstrt           ( get x-value )
[ $01 $c6 ]       ( add si,ax )
m>bl , 21 v-xy    ( set screenpos )
framecolor
field5 m>al       ( current reg )
 15 
[ $29 $c3 ]       ( sub bx,ax   ) ( bx= reg )
regsel .bit.      ( regstatus   )
IF    clrbit
      32  v-emit  v-xyl 
ELSE  setbit
      '*' v-emit  v-xyl 
ENDIF
;  

: regnext
( ** position cursor and sreenpos to next reg field ** )
(    arg: -  )
field5 modinc
[ $b4 $00 ]     ( mov ah,00 )
regstrt 
[ $01 $c6 ]     ( add si,ax )
m>bl
, 21 c-xy  v-xy 
; 

: dispregs
( ** display reg-status ** )
(    arg: -  )
regsel m>a temp# a>m
20 , 21 c-xy
14 FOR
[ $d1 $26 temp# ]   ( shl temp#,1 )
IF    , '*' emit
ELSE  , 32  emit
ENDIF
regnext
NEXT
;
 
: load5
( ** load coordinates, field5 and item ** )
(    arg: -   )
5 field bl>m
inflag m-off
D= regstrt field5
m>a adr+ adr+ m>bl
item a>m coor adr+ bl>m      ( current_item,itemmax,y )
20 coor bl>m                 ( x )
0 item bl>m
msg2
20 , 21 c-xy
20 , 21 v-xy
; 

  
: loadcoor
( ** load coordinates, field and item ** )
(    arg: -  )
field m>al
D= itemstrt
CASE
0 OF inflag m-off field0  ;;   
1 OF inflag m-off field1  ;; 
2 OF inflag m-off field2  ;; 
3 OF inflag m-on  field3  ;; 
4 OF inflag m-on  field4  ;;
ENDCASE
m>a                  ( ah:= max_item, al:= current_item ) 
adr+ adr+ m>bl       ( bl:= y )
item a>m             ( item(0):= current, item(1):= max )
coor adr+ bl>m       ( sto y )
[ $b4 $00 ]          ( mov ah,0    )
[ $01 $c7 ]          ( add di,ax   ) ( ofset into fieldx )
[ $8a $05 ]          ( mov al,[di] )
coor al>m            ( sto x )
m>bl adr+ m>al
[ $b4 $00 ] ( mov ah,0 )
[ $b7 $00 ] ( mov bh,0 )
[ $40 $43 ] ( inc ax inc bx  )
c-xy
item m>al
[ $b4 $00 ]          ( mov ah,0    )
intens
CASE
0 OF inflag m>al
     [ $b4 $00 ]     ( mov ah,0    )
     $ff .=. IF  msg3 
	     ENDIF  ;;
ELSE inflag m-off msg1
ENDCASE
; 


: nextframe
( ** erase current frame and draw next ** )
(    arg: -  )
0 , 0 color -intens drawbox
field m>al
CASE
0 OF inflag m-off field0  ;;   
1 OF inflag m-off field1  ;; 
2 OF inflag m-off field2  ;; 
3 OF inflag m-on  field3  ;; 
4 OF inflag m-on  field4  ;;
5 OF inflag m-off field5  ;;
ENDCASE
modinc 
loadcoor
framecolor intens drawbox
;

(long)
: drawscreen
( ** main screen, key analyzer ** )
(    arg: -   )
screencolor 32 v-cls intens
 1 bcolor  0 , 0 v-xy '' , 79  v-emit-hor
screencolor 10 , 0 v-xy "  'BR' Mini-debugger (c) K.Peper & A. Zissis, V1.4 20/09/93 " v-$.
screencolor
24 , 1 v-xy                 " using int01 int03 int66(h)" v-$.
17 , 2 v-xy
" keys at BR:   |F6t|F3race   |F6+|F3dump   |F6-|F3dump   |F6g|F3o" v-$.
18 , 4 v-xy " Please select:" v-$.
0 ,  6 v-xy
"    dumpport:      video   prn   com1   com2" v-$.
0 ,  9 v-xy
"    regwidth:      16bit" v-$.
.T386. if "   32bit" v-$. 1 else 0 endif field1 adr+ bl>m
0 , 12 v-xy
"        dump:      Byte   Word" v-$.
0 , 15 v-xy
"         seg:      0000    CS     SS     DS     ES     FS     GS" v-$.
0 , 18 v-xy
"         ofs:      0000    BX     DX     SI     DI     SP     BP" v-$.
0 , 21 v-xy
"      regsel:      AX|F4*|F3 BX|F4*|F3 CX|F4*|F3 DX|F4*|F3" v-$.
       "  SI|F4*|F3 DI|F4*|F3 BP|F4*|F3 SP|F4*|F3 SS|F4*|F3" v-$.
       "  DS|F4*|F3 ES|F4*|F3 FS|F4*|F3 GS|F4*|F3 FL|F4*|F3" v-$.
msg1 1 bcolor
14 , 5 v-xy '' , 18 v-emit-vert

0 field bl>m
5 FOR
loadcoor
framecolor
drawbox
field modinc
NEXT
msg1
( print values )
18 , 15 c-xy dumpsegment m>b u.h
18 , 18 c-xy dumpoffset  m>b u.h
dispregs
13 , 6 c-xy
0 field bl>m
loadcoor
( get key )
BEGIN
[ $b4 $00 ]              ( mov ah,00 )
[ $CD $16 ]              ( int 16    ) ( get key )
[ $b4 $00 ]              ( mov ah,00 )
CASE
27 OF savepar  [ $C3 ] ;;
32 OF field m>al         ( SPACE )
      [ $b4 $00 ]        ( mov ah,00 )
      5 .=.
      IF   regnext 
      ELSE nextframe 
      ENDIF ;;
09 OF field m>al         ( TAB )
      [ $b4 $00 ]        ( mov ah,00 )
      5 .=.
      IF   toggle 
      ELSE nextframe 
      ENDIF ;;
13 OF field m>al         ( RETURN )
      [ $b4 $00 ]        ( mov ah,00 )
      4 .=.
      IF load5
      ELSE 
	5 .=.
	IF    0 field bl>m
	      0 field5 bl>m
	      msg1 loadcoor
	ELSE  field modinc loadcoor 
	ENDIF
      ENDIF ;;
35 OF inflag m>al        ( # )
      [ $b4 $00 ]        ( mov ah,00 )
      0 .=. IF , 7 emit 
      ELSE msg4 4 hexin#
	 msg3
	 field m>al
	 [ $b4 $00 ]              ( mov ah,00 )
	 3 .=. IF temp# m>a dumpsegment a>m ENDIF
	 4 .=. IF temp# m>a dumpoffset  a>m ENDIF
      ENDIF ;; 
else , 7 emit
ENDCASE
AGAIN
;
(short)

: menu
( ** readargs, mainscreen, default atribut, clear screen ** )
(    arg: -  )
 readargs
 drawscreen
 7 v-atrib bl>m
 32 v-cls
 ;
  
 
: main 
( ** setup Video-Segment vor MDA or other cards ** )
  ADR $1A m>al 7 .=. IF $B000 v-seg [ $89 $1C ] ENDIF
( ** ask for resident part etc ** )
  testid  ( signature found? )
  IF      ( resident part exists )
	  menu   
  ELSE    ( resident part does not exist, make it )
	  $03 cs>e d= inthandler setint
	  $01 cs>e d= inthandler setint
	  [ $8c $0E rp ]  ( mov rp,cs )
	  menu  resident 
  ENDIF ; 
  
memsizes( 0 0 )  ( no special need for SS, DS memory )
