( *** NAXOS System-Vocabulary Version 2.1 *** )

( Name:    file.FTH      )
( Version: 2.1           )
( Datum:   21.2.92       )
( Autoren: Klaus Peper   )
(      Alexandros Zissis )
( Neu      2.6.91        )


( ********************* )
( ***** FILE.FTH: ***** )
( ********************* )

typ file    
    [ *$0      				( Handle  +$00 )
      *$0012   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0				( NamePtr +$0A )	
      *$0				( Scratch +$0E )
    ] ;


var stdin    
    [ *$0      				( Handle  +$00 )
      *$0010   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0
      *$0
    ] ;
    
var stdout
    [ *$1      				( Handle  +$00 )
      *$0011   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0
      *$0
    ] ; 	
var stderr
    [ *$2      				( Handle  +$00 )
      *$0011   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0
      *$0
    ] ;  	 
var aux
    [ *$3      				( Handle  +$00 )
      *$0012   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0
      *$0
    ] ;  
   
var prn
    [ *$4      				( Handle  +$00 )
      *$0012   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0 
      *$0 
    ] ;

const R/O *$0010 ;
const W/O *$0011 ;
const R/W *$0012 ;

var recsize  [ *$0001 ] ; 
var filemode [ R/W ] ;
var fileattr [ *$0000 ] ;

        macro ($PTR) 
( * adjust DOS_stringpointer * )
( * string must terminate 0! * )
( **************************** )
( arg: SI = string_adr         )
( out: -                       )
( chg: -                       )
( **************************** )
[ $89 $36 d.dx ] ( mov d.dx,si )
[ $8C $1E d.ds ] ( mov d.ds,ds ) 
;

( *** drive- and directory-functions *** )


          : setdrive 
( **  change actual drive   ** )
( **************************** )
( arg: BX = drive A=1 B=2 ..   )
( out: -                       )
( chg: BX                      )
( **************************** )
[ $4B ]          ( dec BX      )
[ $89 $1E d.dx ] ( mov d.dx,bx )
$0E dos intr
;


         : getdrive 
( ****  get actual drive   *** )
( **************************** )
( arg: -                       )
( out: AX = drive 1=A 2=B ..   )
( chg: AX,BX                   )
( **************************** )
$19 dos intr
[ $A1 d.ax ]     ( mov ax,d.ax )
ah0 1+ 
;


          : mkdir 
( ****  make new directory *** )
( **************************** )
( arg: SI = dirname_adr        )
( out: CF:=0 if no error       )
( chg: AX,BX,CF                )
( **************************** )
($PTR) $39 dos intr ?doserr
;


          : rmdir 
( ****  delete directory  **** )
( **************************** )
( arg: SI = dirname_adr        )
( out: CF:=0 if no error       )
( chg: AX,BX,CF                )
( **************************** )
($PTR) $3A dos intr ?doserr
;


          : chdir 
( * change current directory * )
( **************************** )
( arg: SI = dirname_adr        )
( out: CF:=0 if no error       )
( chg: AX,BX,CF                )
( **************************** )
($PTR) $3B dos intr ?doserr
;


         : path? 
( copy pathname into buffer )
( ************************* )
( arg: BX = drive           )
(           0 = current     )
(           1 = A, 2 = B    )
(      SI    = buffer_adr   )
( out: doserr               )
( chg: ?                    )
( ************************* )
  adrpush
  d.dx bl>m
  ds>a
  d.ds a>m
  apop
  d.si a>m
  $47  dos intr ?doserr
;




         : exist? 
( ***  does file exist?  *** )
( ************************** )
( arg: SI = filename_adr     )
( out: CF:= 1 if file exists )
( chg: AX,BX                 )
( ************************** )
($PTR) , 0 
[ $A3 d.ax ]  ( mov d.ax,ax  )
$3D dos intr  ( try to open  )
IF   .F.      ( not existing )
ELSE          ( yes, close   )
 [ $A1 d.ax ] ( mov ax,d.ax  )
 [ $A3 d.bx ] ( mov d.bx,ax  )
 $3E dos intr .T.
ENDIF  
;


           : ferase 
( ***  erase existing file ** )
( ************************** )
( arg: SI = filename_adr     )
( out: CF:= 0 if no error    )
( chg: AX,BX,CF              )
( ************************** )
exist?
IF
  ($PTR) $41 dos intr ?doserr
ENDIF
;


           : frename 
( *** rename existing file *** )
( **************************** )
( arg: SI = filename_adr old   )
(      DI = filename_adr new   )
( out: CF:=0 if no error       )
( chg: SI,DI,AX,BX,CF          )
( **************************** )
[ $89 $36 d.dx ] ( mov d.dx,si )
[ $89 $3E d.di ] ( mov d.di,di )
[ $8C $1E d.ds ] ( mov d.ds,ds )
[ $8C $1E d.es ] ( mov d.es,ds )
$56 dos intr ?doserr
;

            : drivespace 
( get total/remaining drive capacity  )
( *********************************** )
( arg: BX: 0= current drive 1=A 2=B.. )
( out: BX:AX = Bytes free on Volume   )	
(      ES:DI = Bytes total on Volume  )
( chg: AX,BX,DI,ES,CF                 )
( *********************************** )

[ $89 $1E d.dx ]
$36 dos intr
d.ax 
( IF- OFF .T. )
  [ $A1 d.ax ]		( mov ax,d.ax  Sec/Cluster )
  [ $8B $1E d.cx ]	( mov bx,d.cx  Byte/Sec )
  u*			( Byte / Cluster )
  apush
  [ $8B $1E d.dx ]	( mov bx,d.dx Total cluster )  
  u*
  b>e a>d
  apop
  [ $8B $1E d.bx ]	( mov bx,d.bx Free Cluster )
  u*
( ELSE .F. )
( ENDIF )
;

          : getdta 
( get adr of disk-transfer-area )
( ***************************** )
( arg: -                        )
( out: ES:DI dta_adr            )
( chg: ES,DI                    )
( ***************************** )
$2F dos intr
[ $8E $06 d.es ]  ( mov es,d.es )
[ $8B $3E d.bx ]  ( mov di,d.bx )
;




          : get-file-atr
( *****  get file atribut ***** )
( ***************************** )
( arg: SI = filename_adr        )
( out: AX = atribut             )
(         = 0: unlimited access )
(         = 8: name of volume   )
(           else BIT:           )
(           0=1: read only      )
(           1=1: hidden file    )
(           2=1: system file    )
(           4=1: subdirectory   )
(           5=1: changed        )
(      CF:=0 if no error        )
( chg: AX,BX,CF                 )
( ***************************** )
($PTR) , 0 
[ $A3 d.ax ]      ( mov d.ax,ax )
$43 dos intr ?doserr
[ $A1 d.cx ]      ( mov ax,d.cx )
;


          : set-file-atr
( *****  set file atribut ***** )
( ***************************** )
( arg: SI = filename_adr        )
(      BX = atribut             )
(         = 0: unlimited access )
(         = 8: name of volume   )
(           else BIT:           )
(           0=1: read only      )
(           1=1: hidden file    )
(           2=1: system file    )
(           4=1: subdirectory   )
( out: CF:=0 if no error        )
( chg: AX,BX,CF                 )
( ***************************** )
($PTR) 
[ $89 $1E d.cx ]  ( mov d.cx,bx ) 
, 1 
[ $A3 d.ax ]      ( mov d.ax,ax ) 
$43 dos intr ?doserr
;


( ** directory-searchfunctios ** )
var dirbuf string 66 ; ( buffer for filenames )

            : dirfirst? 
( * find first file with atr n  )
( ***************************** )
( arg: SI = searchfilename_adr  )
(           * and ? are valid   )
(      BX = atribut n           )
(         = 0: unlimited access )
(         = 8: name of volume   )
(           else BIT:           )
(           0=1: read only      )
(           1=1: hidden file    )
(           2=1: system file    )
(           4=1: subdirectory   )
(           5=1: changed        )
( out: CF:= 1 if no error       )
(      ES:DI:= found_name_adr   )
( chg: AX,BX,ES,DI              )
( ***************************** )
($PTR)   d.cx b>m   $2F dos intr
[ $8E $06 d.es ]  ( mov es,d.es )
[ $8B $3E d.bx ]  ( mov di,d.bx )
[ $83 $C7 $1E ]   ( add di,1E   )
$4E dos intr .not.

;


           : dirnext? 
( *****  find next file   ***** )
( ***************************** )
( arg: ES:DI found_name_adr     )
( out: CF:= 0 if no error       )
( chg: AX,BX,ES,DI              )
( ***************************** )
$4F dos intr .not.
;

: dirattr 
( * attribute of found file )
( ************************* )
( arg: ES:DI found_name_adr )
( out: AL:= attribute       )
( chg: AX                   )
( ************************* )
ah0
[ $26 $8A $45 $F7 ] ( mov al,es:[di-9] )
;

        : dirtime 
( **  time of found file   ** )
( *************************** )
( arg: ES:DI found_name_adr   )
( out: AX:= hour 0-24         )
(      BX:= minutes 0-59      )
(      SI:= seconds 0-59      )
( chg: -                      )
( *************************** )
[ $26 $8B $45 $F8 ] ( mov ax,es:[di-8] )
a>b a>adr cpush
[ $B1 $0B ]      ( mov cl,11  )
[ $D3 $E8 ]      ( shr ax,cl  )
[ $25 *$1F ]     ( and ax,$1f )
[ $B1 $05 ]      ( mov cl,05  )
[ $D3 $EB ]      ( shr bx,cl  )
[ $81 $E3 *$3F ] ( and bx,$3f )
[ $D1 $E6 ]      ( shl si,1   )
[ $81 $E6 *$1F ] ( and si,$1f )
cpop
;

         : dirdate 
( **  date of found file   ** )
( *************************** )
( arg: ES:DI found_name_adr   )
( out: AX:= year              )
(      BX:= month 1 - 12      )
(      SI:= day   1 - 31      )
( chg: -                      )
( *************************** )
[ $26 $8B $45 $FA ] ( mov ax,es:[di-6] )
a>b a>adr  cpush
[ $B1 $09 ]      ( mov cl,09  )
[ $D3 $E8 ]      ( shr ax,cl  )
[ $25 *$7F ]     ( and ax,$7f )
[ $05 1980 ]    ( add ax,1980 )
[ $B1 $05 ]      ( mov cl,05  )
[ $D3 $EB ]      ( shr bx,cl  )
[ $81 $E3 *$0F ] ( and bx,$0f )
[ $81 $E6 *$1F ] ( and si,$1f )
cpop
;

       : dirsize 
( ** length of found file ** )
( ************************** )
( arg: ES:DI found_name_adr  )
( out: BX:AX:= length        )
( chg: AX,BX                 )
( ************************** )
[ $26 $8B $45 $FC ] ( mov ax,es:[di-4] )
[ $26 $8B $5D $FE ] ( mov al,es:[di-9] )
;


( ** Weitere Systemfunktionen ** )

          : sysdate 
( *****  get systemdate  ***** )
( **************************** )
( arg: -                       )
( out: ES:= weekday 0 = sunday )
(      AX:= day 1 - 31         )
(      BX:= month 1 - 12       )
(      DI:= year 1980 - 2099   )
( chg: ?                       )
( **************************** )
$2a dos intr
d.cx m>d
d.ax m>a ah0 a>e
d.dx m>a split  
; 

: .date 
( **  type date  ** )
( ***************** )
( arg: -            )
( out: -            )
( chg: AX,BX,ES,DI  )
( ***************** )
sysdate dpush bpush
u.d  '.' emit
apop u.d '.' emit
apop u.d
;

: .date+ 
( type date+weekday )
( ***************** )
( arg: -            )
( out: -            )
( chg: AX,BX,ES,DI  )
( ***************** )
 sysdate apush e>a
 (long)
 case 0 of " Sunday, "    ;;
      1 of " Monday, "     ;;
      2 of " Tuesday, "   ;;
      3 of " Wednesday, "   ;;
      4 of " Thursday, " ;;
      5 of " Friday, "    ;;
      6 of " Saturday, "    ;;
  endcase $. apop .date
  (short)
; 

: .fattr
 15 tab -lead0
 dirsize  dpush d= 7  ud.r   dpop  25 tab lead0
 dirdate  
          apush bpush adr>a  2 u.r '.' emit apop  2 u.r
          '.' emit apop  2 u.r 
           36 tab 
 dirtime  bpush  2 u.r ':' emit apop  2 u.r 45 tab 
dirattr   2 u.r
;


: fassign 
( in: adr of Namestring in SI )
(     adr of file-var in DI )	
( out: - )
( chg: AX,BX )

[ $83 $C7 $0A ] ( add di,0AH )
[ $1E $07 ] ( push ds pop es )
adr>a
d>adr
a>m adr2+ e>m
filemode m>b d>adr , 2 adrn+ b>m
recsize m>b d>adr , 4 adrn+ b>m
ds>a a>b d>adr , 8  adrn+ b>m
d>a $100 + a>b d>adr , 6 adrn+ b>m
;

: fopen
( in: addr of file-var in SI )

  adrpush adr2+ m>a d.ax a>m
  ds>a d.ds a>m 
  apop apush $0A + a>adr (ptr) 
  d.ax m>a $3D dos intr ?doserr
  d.ax m>a adrpop a>m
;

: fcreate
( in: addr of file-var in SI )

  adrpush
  fileattr m>a d.cx a>m
  ds>a d.ds a>m
  apop apush
  $0A + d.dx a>m
  $3C dos intr ?doserr 
  d.ax m>a adrpop a>m
;

: fclose
( in: addr of file-var in SI )

 m>a d.bx a>m
 $3E dos intr ?doserr
;

: fseek
( in : addr of file-var in si )
(      pos in bx,ax  	      )
( out: pos in bx,ax  	      )

 m>d d.bx d>m
 d.dx a>m d.cx b>m
 $42 , 0 dos intr ?doserr
 d.dx m>b d.ax m>a 
;

: fpos
( in : addr of file-var in si )
( out: pos in bx,ax  	      )

 m>d d.bx d>m
 d.dx 0 b>m d.cx 0 b>m
 $42 , 1 dos intr ?doserr
 d.dx m>b d.ax m>a 
;

: fsize
( in : addr of file-var in si )
( out: filesize in bx,ax      )
 
 m>d d.bx d>m
 d.dx 0 b>m d.cx 0 b>m
 $42 , 2 dos intr ?doserr
 d.dx m>b d.ax m>a 
;


: fread
( in: addr of file-var in si       )
(      addr of buffer in di        )
(      nr of records to read in ax )

      adrpush   
      m>b d.bx b>m adrpop adr2+ adr2+ m>b * d.cx a>m
      ds>a d.ds a>m 
      d.dx d>m
      $3F dos intr ?doserr
      d.ax m>a 0 .=. IF " ERROR: End of file reached" $. 7 emit halt endif
;      


: fwrite
( in: addr of buffer   in si       )
(     addr of file-var in di	   )
(     nr of records to write in ax )

      dpush adr>d adrpop adrpush
      m>b d.bx b>m adrpop adr2+ adr2+ m>b * d.cx a>m
      ds>a d.ds a>m 
      d.dx d>m
      $40 dos intr ?doserr
;      


: fputw
( in: value in ax            )
(     addr of file-var in si )

      adrpush
      m>b d.bx b>m 2 d.cx b>m
      adrpop a>b , $80 adrn+ adrpush b>m
      ds>a d.ds a>m 
      d.dx apop a>m
      $40 dos intr ?doserr
;      

: fputb
( in: value in al            )
(     addr of file-var in si )

      adrpush
      m>b d.bx b>m 1 d.cx b>m
      adrpop a>b , $80 adrn+ adrpush b>m
      ds>a d.ds a>m 
      d.dx apop a>m
      $40 dos intr ?doserr
;      


: fgetw
( in: addr of file-var in si )
( out: ax )
      adrpush
      m>b d.bx b>m 2 d.cx b>m
      ds>a d.ds a>m 
      adrpop , $80 adrn+ adrpush 
      d.dx apop a>m apush
      $3F dos intr ?doserr
      d.ax m>a 0 .=. IF " ERROR: End of file reached" $. 7 emit halt endif
      adrpop m>a
;      

: fgetb
( in: addr of file-var in si )
( out: al )
      adrpush
      m>b d.bx b>m 1 d.cx b>m
      ds>a d.ds a>m 
      adrpop , $80 adrn+ adrpush 
      d.dx apop a>m apush
      $3F dos intr ?doserr
      d.ax m>a 0 .=. IF cr " ERROR: End of file reached" $. 7 emit halt endif
      adrpop m>al
;      
