	( *** Naxos System-Vocabulary Version 2.01 *** )

	( Name:     kern.fth          )
	( Version:  2.09              )
	( Revision: 7.00              )
	( Datum:    27.10.92          ) 
	( Autoren:  Klaus Peper       )
	(           Alexandros Zissis )


	( --------------------------------------- )
	( NAXOS V2.xx                             )
	( basiert auf MCC, FCC sowie NAXOS V1.xx  )
	( --------------------------------------- )

	( register_notations:                     )
	( AL=al, AH=ah, BL=bl, BH=bh              )
	( AX=a,  BX=b,  DI=d,  ES=e,  SI=adr      )
	( BX:AX=ba,     ES:DI=ed                  )

	( prefixes:                               )
	( u/  unsigned                            )
	( b/  byteoperation                       )
	( d/  doubleoperation                     )

	( c   := char,Byte        8 Bit           )
	( n   := word, signed    16 Bit           )
	( u   := word, unsigned  16 bit           )
	( i   := index, unsigned 16 bit           )
	( d   := doubleword      32 Bit           )
	( adr := adress          16 Bit           )
	( str := adr of countbyte of string       )



	(short)

	( ** Kern Version / Revision ** )

	const kernref *$020B ( Version 2 Revision 11 ) ;

	( ** Datasegment ** )

	( Registerrecord fr DOS-INTR-interface: ) 
	aconst  D.AX  $00  ( Register AX  ) ;
	aconst  D.BX  $02  ( Register BX  ) ;
	aconst  D.CX  $04  ( Register CX  ) ;
	aconst  D.DX  $06  ( Register DX  ) ;
	aconst  D.BP  $08  ( Register BP  ) ;
	aconst  D.SI  $0A  ( Register SI  ) ;
	aconst  D.DI  $0C  ( Register DI  ) ;
	aconst  D.DS  $0E  ( Register DS  ) ;
	aconst  D.ES  $10  ( Register ES  ) ;
	aconst  D.FL  $12  ( Flagregister ) ;


	( *** System-Konstanten *** )

	const bl   32  ;   ( Leerzeichen )
	const bs   8   ;   ( Backspace )


	( *** Variablen - Definitionen ** )

	typ  BYTE   [ 0 ]     ( Byte ) ;
	typ  BOOL   [ FALSE ] ( Byte 1=true 0=false ) ;
	typ  WORD   Byte 2    ( Word ) ;

	typ  FPTR   word 2    ( Farpointer ) ; 
	typ  DOUBLE word 2    ( Double ) ;
	typ  NPTR   word do:  ( Nearpointer )
	     [ $8B $34 ]      ( mov si,[si] ) ;
     
	  
	( *** System-Variablen *** )

	var VPTR    word         ( Video-ptr ofs ) ;
	var VSEG    word         ( Video-ptr seg ) ;
	var HPTR    fptr         ( Heap-ptr ) ;
	var DPTR    fptr         ( Dataseg-ptr ) ;

	( ** Handle-variablen ** )

	var  stdout#   [ 2 ]    ( outhandle ) ;
	var  stdin#    [ 0 ]    ( inhandle ) ;
	var  hold#     [ 2 ]    ( temp. handle ) ;
	var  fin#      [ 0 ]    ( Eingabe-Textdatei ) ;
	var  fout#     [ 1 ]    ( Ausgabe-Textdatei ) ;
	var  fi/o#     [ 3 ]    ( Direktzugriffsdatei ) ;

	( ---------------------------------- )

	( *** System-Vektoren *** )

	vector doserr ( Fehlervektor fr DOS-Funktionen ) ;
	vector emit   ( Zeichen ausgeben ) ;
	vector key    ( Zeichen eingeben ) ;
	vector ?key   ( Taste gedrckt ? ) ;
	vector break  ( Control-C-Handler ) ;
	vector int0   ( Division durch Null ) ;


	( ********************************* )
	( * Worte, Funktionen, Operatoren * )
	( ********************************* )


	( *** einfache Arithmetik *** )


		 : ba/d 
	( unsigned division BX:AX/DI )
	( ************************* )
	( arg: BX:AX = dividend d   )
	(      DI = divisor i       )
	( out: BX:AX:= d/i          )
	(      DI:= rest            )
	( chg: AX,BX,DI             )
	( ************************* )
	[ $83 $FF $01 ] ( cmp di,01 )
	IF- NE
	[ $93 ]      ( xchg ax,bx   ) 
	[ $31 $D2 ]  ( xor  dx,dx   ) 
	[ $F7 $F7 ]  ( div  di      ) ( (0:high)/i )
	[ $93 ]      ( xchg ax,bx   )
	[ $F7 $F7 ]  ( div  di      ) ( (rest:low)/i )
	[ $89 $D7 ]  ( mov  di,dx   ) ( rest )
	ENDIF
	;


		  : ba*d 
	(  unsigned multiply d * i  )
	( ** overflow may happen ** )
	( ************************* )
	( arg: BX:AX = ud           )
	(      DI = i               )
	( out: BX:AX:= d*i          )
	( chg: AX,BX                )
	( ************************* ) 
	[ $51 ]       ( push cx     )
	[ $F7 $E7 ]   ( mul  di     ) ( low*u )
	[ $89 $D1 ]   ( mov  cx,dx  ) ( bertrag retten )
	[ $93 ]       ( xchg ax,bx  ) 
	[ $F7 $E7 ]   ( mul  di     ) ( high*u )
	[ $93 ]       ( xchg ax,bx  )
	[ $01 $CB ]   ( add  bx,cx  ) ( +bertrag )
	[ $59 ]       ( pop  cx     ) 
	;
		  : ba*ed 
	(  unsigned multiply ud * ui )
	( ** overflow may happen ** )
	( ************************* )
	( arg: BX:AX = ud           )
	(      es:DI = ui           )
	( out: BX:AX:= d*i          )
	( chg: All regs changed     )
	( ************************* ) 
 [ $89 $DA           ( MOV    DX,BX )
   $8C $C3           ( MOV    BX,ES )
   $89 $F9           ( MOV    CX,DI )
   $8B $F0           ( MOV    SI,AX )
   $8B $FA           ( MOV    DI,DX )
   $F7 $E1           ( MUL    CX )
   $50               ( PUSH   AX )
   $52               ( PUSH   DX )
   $8B $C6           ( MOV    AX,SI )
   $F7 $E3           ( MUL    BX )
   $8B $D8           ( MOV    BX,AX )
   $8B $C7           ( MOV    AX,DI )
   $F7 $E1           ( MUL    CX )
   $8B $C8           ( MOV    CX,AX )
   $5A               ( POP    DX )
   $58               ( POP    AX )
   $03 $D3           ( ADD    DX,BX )
   $03 $D1           ( ADD    DX,CX )
   $89 $D3 ]	     ( MOV    BX,DX )		
  ;

		 : ba*10 
	( ****  double * 10  ****** )
	( ************************* )
	( arg: BX:AX = d            )
	( out: BX:AX:= d*10         )
	( chg: AX,BX                )
	( ************************* ) 
	[ $51 ]        ( push cx    )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $D1 $D3 ]    ( rcl  bx,1  )
	[ $89 $C1 ]    ( mov  cx,ax )
	[ $89 $DA ]    ( mov  dx,bx )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $D1 $D3 ]    ( rcl  bx,1  )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $D1 $D3 ]    ( rcl  bx,1  )
	[ $01 $C8 ]    ( add  ax,cx )
	[ $11 $D3 ]    ( adc  bx,dx )
	[ $59 ]        ( pop  cx    )
	;

		 : ba*16 
	( ****  double * 16  ****** )
	( ************************* )
	( arg: BX:AX = d            )
	( out: BX:AX:= d*16         )
	( chg: AX,BX                )
	( ************************* ) 
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $D3 ]     ( rcl  bx,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $D3 ]     ( rcl  bx,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $D3 ]     ( rcl  bx,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $D3 ]     ( rcl  bx,1 )
	;


	( *** Speicher-Befehle  *** )


		  : i/copy 
	( copy i bytes from mem to .. )
	( .. mem in datasegment DS ** )
	( smart: regions may overlap! )
	(   Syntax: a to b  i/copy    )
	( *************************** )
	( arg: AX = bytes_to_copy i   )
	(      SI = sourceadr a       )
	(      DI = dest_adr  b       )
	( out: -                      )
	( chg: AX,ES,SI,DI            )
	( *************************** )
	[ $91 ]          ( xchg ax,cx )
	[ $8C $DA ]      ( mov  dx,ds )
	[ $8E $C2 ]      ( mov  es,dx )
	[ $89 $F2 ]      ( mov  dx,si )
	[ $39 $F7 ]      ( cmp  di,si )
	 IF- NG
	   [ $03 $F1 ]   ( add  si,cx )
	   [ $03 $F9 ]   ( add  di,cx )
	   [ $4E ]       ( dec  si    )
	   [ $4F ]       ( dec  di    )
	   [ $FD ]       ( std        )
	 ENDIF
	[ $F3 $A4 ]      ( rep  movsb )
	[ $FC ]          ( cld        )
	[ $89 $D6 ]      ( mov  si,dx )
	[ $89 $C1 ]      ( mov cx,ax  )  
	;

		  : ^copy 
	(  copy i bytes from longmem  )
	(   to longmem via pointer    )
	(  regions must not overlap!  )
	( Syntax: aptr to bptr ^copy  )
	( *************************** )
	( arg: AX = bytes_to_copy i   )
	(      SI = source_ptr aptr   )
	(      DI = dest_ptr bptr     )
	( out: -                      )
	( chg: AX,ES,SI,DI            )
	( *************************** )
	[ $1E ]         ( push ds     )
	[ $C4 $3D ]     ( les di,[di] )
	[ $C5 $34 ]     ( lds si,[si] )
	[ $91 ]         ( xchg ax,cx  )
	[ $F3 $A4 ]     ( rep  movsb  )
	[ $89 $C1 ]     ( mov cx,ax   )
	[ $1F ]         ( pop  ds     )  
	;

		 : b/fill 
	( fill i bytes in mem with c )
	( ************************** )
	( arg: SI = mem_adr          )
	(      BL = char c           )
	(      AX = count i          )
	( out: -                     )
	( chg: ES,DI,BX,AX           )
	( ************************** )
	[ $91 ]        ( xchg cx,ax  )
	[ $93 ]        ( xchg ax,bx  )
	[ $8C $DA ]    ( mov  dx,ds  )
	[ $8E $C2 ]    ( mov  es,dx  )
	[ $89 $F7 ]    ( mov  di,si  )
	[ $F3 $AA ]    ( rep  stosb  )
	[ $89 $D9 ]    ( mov  cx,bx  )
	;

		  : fill 
	( fill i words in mem with n )
	( ************************** )
	( arg: SI = mem_adr          )
	(      BL = value n          )
	(      AX = count i <32000   )
	( out: -                     )
	( chg: ES,DI,BX,AX           )
	( ************************** )
	[ $91 ]         ( xchg cx,ax )
	[ $93 ]         ( xchg ax,bx )
	[ $8C $DA ]     ( mov  dx,ds )
	[ $8E $C2 ]     ( mov  es,dx )
	[ $89 $F7 ]     ( mov  di,si )
	[ $F3 $AB ]     ( rep  stosw )
	[ $89 $D9 ]     ( mov  cx,bx )
	;

		 MACRO erase 
	( fill i bytes in mem with 0 )
	( ************************** )
	( arg: SI = mem_adr          )
	(      AX = count i          )
	( out: -                     )
	( chg: ES,DI,BX,AX           )
	( ************************** )
	0  b/fill 
	;

		 MACRO blank 
	( fill i bytes in mem with 32 )
	( *************************** )
	( arg: SI = mem_adr           )
	(      AX = count i           )
	( out: -                      )
	( chg: ES,DI,BX,AX            )
	( *************************** )
	bl b/fill 
	;


	( *** Flag- und Vergleichs- operatoren *** )

		  : .>and.
	( *** 'AND' two carryflags *** ) 
	(  only possible after 'flag>' )
	( pops one flag from con_stack )
	( **************************** )
	( arg: CF                      )
	( out: CF:= CF AND con_stack   )
	( chg: CF                      )
	( **************************** )
	[ $D0 $D6 ]       ( rcl dh,1   )
	[ $D1 $0E $16 0 ] ( ror [16],1 )
	[ $D0 $D2 ]       ( rcl dl,1   )
	[ $20 $F2 ]       ( and dl,dh  )
	[ $D0 $CA ]       ( ror dl,1   )
	;

		   : .>or.
	( *** 'OR' two carryflags **** ) 
	(  only possible after 'flag>' )
	( pops one flag from con_stack )        
	( **************************** )
	( arg: CF                      )
	( out: CF:= CF OR con_stack    )
	( chg: CF                      )
	( **************************** )
	[ $D0 $D6 ]       ( rcl dh,1   )
	[ $D1 $0E $16 0 ] ( ror [16],1 )
	[ $D0 $D2 ]       ( rcl dl,1   )
	[ $08 $F2 ]       ( or  dl,dh  )
	[ $D0 $CA ]       ( ror dl,1   )
	;

		   : .>xor. 
	( *** 'XOR' two carryflags *** ) 
	( only possible after 'flag>'  )
	( pops one flag from con_stack )
	( **************************** )
	( arg: CF                      )
	( out: CF:= CF XOR con-stack   )
	( chg: CF                      )
	( **************************** )
	[ $D0 $D6 ]       ( rcl dh,1   )
	[ $D1 $0E $16 0 ] ( ror [16],1 )
	[ $D0 $D2 ]       ( rcl dl,1   )
	[ $30 $F2 ]       ( xor  dl,dh )
	[ $D0 $CA ]       ( ror dl,1   )
	;


		   : .>?<. 
	( check wether n is in limits )
	( SYNTAX:     5 to 9 .>?<.    )
	( *************************** )
	( arg: AX = value n           )
	(      BX = lower limit       )
	(      DI = upper limit       )
	( out: CF:= 0 if lo>=n>=hi    )
	( chg: CF                     )
	( *************************** )
	[ $31 $D2 ]       ( xor dx,dx )
	[ $39 $F8 ]       ( cmp ax,di )
	IF- NA
	   [ $39 $D8 ]    ( cmp ax,bx )
	   IF- NB
	     [ $42 ]      ( inc dx    )
	   ENDIF
	ENDIF
	[ $D1 $DA ]       ( rcr dx,1  )
	;


	( *** Funktionen *** )

		 : d/abs 
	( * absolut value of double  )
	( ************************** )
	( arg: BX:AX = double d      )
	( out: BX:AX:= abs(d)        )
	( chg: BX,AX                 )
	( ************************** )
	[ $80 $C7 0 ]   ( add bh,#00 )
	IF- S
	[ $F7 $D0 ]     ( not ax     )
	[ $F7 $D3 ]     ( not bx     )
	[ $05 $01 0 ]   ( add ax,1   )
	[ $83 $D3 0 ]   ( adc bx,0   )
	ENDIF
	;


		  : .ba>a. 
	( converts signed double to word )
	( ****************************** )
	( arg: BX:AX = double d          )
	( out: CF:= 0 if no error        )
	( chg: CF                        )
	( ****************************** )
	.neg.  flag> xab    ( ax<0 ?      )
	.-1=. .>and. flag> ( and bx=-1 ? )
	.0=.  xab  flag>   ( or bx=0 ?   )
	.neg. .not. .>and.  ( and ax>=0 ? ) 
	.>or. 
	;
  
		MACRO .uba>a. 
	( converts unsigned double to word )
	( ******************************** )
	( arg: BX:AX = double d            )
	( out: CF:= 0 if no error          )
	( chg: CF                          )
	( ******************************** )
	[ $83 $FB 0 ]       ( cmp bx,#0000 )
	.T.
	IF- Z
	    [ $F5 ]         ( cmc          )
	ENDIF
	;

	( ** Bitsteuerung: ** )

		 : 2^n 
	( ** 2 to the power of n * )
	( ************************ )
	( arg: AX = 0<=i<=15       )
	( out: AX:= 2^n            )
	( chg: AX                  )
	( ************************ ) 
	[ $89 $CA ]   ( mov  dx,cx )
	[ $89 $C1 ]   ( mov  cx,ax )
	[ $B8 1 0 ]   ( mov  ax,1  )
	[ $D3 $E0 ]   ( shl  ax,cl )
	[ $89 $D1 ]   ( mov  cx,dx )
	;

	       MACRO clrbit 
	( ** clear bit i in AX *** )
	( ************************ )
	( arg: AX = value n        )
	(      BX = 0<=i<=15       )
	( out: AX:= n'             )
	( chg: AX,BX               )
	( ************************ ) 
	xab 2^n not and 
	;

	       MACRO setbit 
	( * set bit i in AX to 1 * )
	( ************************ )
	( arg: AX = value n        )
	(      BX = 0<=i<=15       )
	( out: AX:= n'             )
	( chg: AX,BX               )
	( ************************ ) 
	xab 2^n or 
	;

	( cursorposition )

	       : c-xy?
	( ** cursorposition? ** )
	( arg: -                )
	( out: BX column (x)    )
	(      AX row (y)       ) 
	( chg: ES               )
	( ********************* )
	epush
	[ $31 $D2 ]           ( xor dx,dx       )
	[ $8E $C2 ]           ( mov es,dx       )
	[ $26 $8b $16 $50 4 ] ( mov dx,es:[450] )
	[ $88 $D3 ]           ( mov bl,dl       )
	[ $b7 $00 ]           ( mov bh,0        )
	[ $88 $f0 ]           ( mov al,dh       )
	[ $b4 $00 ]           ( mov ah,0        )
	epop
	;

		: c-xy
	( ** pos the cursor  ** )
	( arg: BX column (x)    )
	(      AX row (y)       )
	( out: -                ) 
	( chg: AH               )
	( ********************* )
	epush
	[ $31 $D2 ]           ( xor dx,dx       )
	[ $8E $C2 ]           ( mov es,dx       )
	[ $88 $Da ]           ( mov dl,bl       )
	[ $88 $c6 ]           ( mov dh,al       )
	[ $26 $89 $16 $50 4 ] ( mov es:[450],dx )
	[ $b4 $02 ]           ( mov ah,2        )
	[ $cd $10 ]           ( int 10          )
	epop
	;

		 : tab
	( ****  tabcursor  **** )
	( arg: BX column (x)    )
	( out: -                )
	( chg: -                )
	( ********************* )
	epush
	[ $31 $D2 ]           ( xor dx,dx       )
	[ $8E $C2 ]           ( mov es,dx       )
	[ $26 $8b $16 $50 4 ] ( mov dx,es:[450] )
	[ $88 $DA ]           ( mov dl,bl       )
	[ $26 $89 $16 $50 4 ] ( mov es:[450],dx )
	[ $b4 $02 ]           ( mov ah,2        )
	[ $cd $10 ]           ( int 10          )
	epop
	;



	( ***************************************** )
	( **    Interrupt Interface for DOS      ** )
	( ***************************************** )


		    proc intr 
	( ** general interrupt interface  ** )
	( ** ignores arg given back in DS ** )
	( ********************************** )
	( arg: BL=  interrupt number         )
	(      AH=  function number          )
	(      AL=  subfunction number       )
	(      record d.xx = register args   )
	( out: CF:=0 if no error             )
	(      CF:=1 if error                )
	(      record d.xx:= register args   )
	(             except DS              )
	( chg: CF                            )
	( ********************************** )
	( push Register auf Returnstack )
	  [ $06 $57 $56 $55 $51 $53 $50 $1E  ] 
	  (  ES  DI  SI  BP  CX  BX  AX  DS  )
	( Interrupt patchen )  
	  [ $2E $88 $1E pc+ $24 ]
	( Register aus Dos-Interface laden )
	  [ $8B $1E *$02 ] ( mov  bx,[02]   )
	  [ $8B $0E *$04 ] ( mov  cx,[04]   )
	  [ $8B $16 *$06 ] ( mov  dx,[06]   )
	  [ $8B $2E *$08 ] ( mov  bp,[08]   )
	  [ $8B $36 *$0A ] ( mov  si,[0A]   )
	  [ $8B $3E *$0C ] ( mov  di,[0C]   )
	  [ $8E $06 *$10 ] ( mov  es,[10]   )
	  [ $FF $36 *$0E ] ( push [0E]      ) ( get DS .. )
	  [ $1F ]           ( pop  ds        ) ( and set )
	  [ $CD $00 ]       ( gepatchten Interrupt ausfhren )
	( Register in Dos-Interface retten )
	  [ $1F ]              ( pop ds      ) ( restor old DS )
	  [ $A3 *$00 ]        ( mov [00],ax )
	  [ $89 $1E *$02 ]    ( mov [02],bx )
	  [ $89 $0E *$04 ]    ( mov [04],cx )
	  [ $89 $16 *$06 ]    ( mov [06],dx )
	  [ $89 $2E *$08 ]    ( mov [08],bp )
	  [ $89 $36 *$0A ]    ( mov [0A],si )
	  [ $89 $3E *$0C ]    ( mov [0C],di )
	  [ $8C $06 *$10 ]    ( mov [10],es )
	( pop Register von Returnstack )
	  [ $58 $5B $59 $5D $5E $5F $07 ]
	  (  AX  BX  CX  BP  SI  DI  ES )
	  [ $FC ]              ( cld    )
	;


		  : ?doserr 
	( ** possible error after intr ** )
	( arg: CF =1:error =0: no error   )
	(      AH = functionnumber        )
	(      AL = subfunctionnumber     )
	( out: CF:= 0 if error            )
	( chg: ? if error                 )
	( ******************************* )
	IF                ( error ?       )
         [ $89 $E3 ]
         apush
         [ $36 $8B $07 ] a>d
         apop
	 [ $8b $1e D.AX ] ( mov bx,[d.ax] )
	 doserr .F.
	ELSE .T.
	ENDIF
	;

		  macro getint 
	( ** int_routine for INT# i ** )
	( **************************** )
	( arg: BX = interrupt_number i )
	( out: ES:DI:= adr of int_rout )
	( chg: ES,DI,AX                )
	( **************************** )
	[ $88 $D8 ]       ( mov al,bl  )
	[ $B4 $35 ]       ( mov ah,#35 )
	[ $CD $21 ]       ( int 21     )
	[ $89 $DF ]       ( mov di,bx  ) 
	;

	: setint 
	( ** Setze Interrupt Nummer i ** )
	( load int_routine for INT# i  )
	( **************************** )
	( arg: BX = interrupt_number i )
	(      ES:DI:= adr of int_rout )
	( out: -                       )
	( chg: AX                      )
	( **************************** )
	[ $1E ]           ( push ds    )
	[ $8C $C0 ]       ( mov ax,es  )
	[ $8E $D8 ]       ( mov ds,ax  )
	[ $89 $FA ]       ( mov dx,di  )
	[ $88 $D8 ]       ( mov al,bl  )
	[ $B4 $25 ]       ( mov ah,#25 )
	[ $CD $21 ]       ( int 21     )
	[ $1F ]           ( pop ds     )
	;



	( **  character in- and output ** )


	: >con  ( - )
	( ** Ausgabe an CONSOLE ** )
	( ** - umleitbar -      ** )
	[ $c6 $06 stdout# 01 ] ( mov stdout#,#1 )
	;

	: >prn  ( - )
	( ** Ausgabe an PRINTER  ** )
	( ** - nicht umleitbar - ** )
	[ $c6 $06 stdout# 04 ] ( mov stdout#,#4 )
	;

	: >aux  ( - )
	( ** Ausgabe an RS232    ** )
	( ** - nicht umleitbar - ** )
	[ $c6 $06 stdout# 03 ] ( mov stdout#,#3 )
	;

	: >file   ( - )
	( ** Ausgabe auf handle #fout umleiten ** )
	[ $8a $16 fout# ]   ( mov dl,fout#   )
	[ $88 $16 stdout# ] ( mov stdout#,dl )
	;

	: errdev  ( - )
	( ** Ausgabe an Schirm          ** )
	( ** - nicht umleitbar -        ** )
	( ** laufendes Handle speichern ** )
	[ $8a $16 stdout# ]    ( mov dl,stdout# )
	[ $88 $16 hold# ]      ( mov hold#,dl   )
	[ $c6 $06 stdout# 02 ] ( mov stdout#,#2  )
	;

	: -errdev  ( - )
	( ** Ausgabe an voriges Handle ** )
	[ $8a $16 hold# ]   ( mov dl,hold#   )
	[ $88 $16 stdout# ] ( mov stdout#,dl )
	;

	proc (emit)  ( c,- )
		     ( - )
		     ( - ) 
	( ** Zeichen c auf Schirm ausgeben ** )
	 [ $50 ]     ( push ax    )
	 [ $88 $DA ] ( mov dl,bl  )
	 [ $B4 $02 ] ( mov ah,#02 )
	 [ $CD $21 ] ( int 21     )
	 [ $58 ]     ( pop ax     )
	;

	proc (pemit)  ( c,- )
		      ( - )
		      ( - ) 
	( ** Zeichen c auf PRN ausgeben ** )
	 [ $50 ]     ( push ax    )
	 [ $88 $DA ] ( mov dl,bl  )
	 [ $B4 $05 ] ( mov ah,#05 )
	 [ $CD $21 ] ( int 21     )
	 [ $58 ]     ( pop ax     )
	;


		   : $.
	( **** output string **** )
	( *********************** )
	( arg: SI = stringadr     )
	( out: -                  )
	( chg: SI                 )
	( *********************** )
	[ $53 ]     ( push bx     )
	BEGIN
	  m>bl 
	  [ $80 $FB 0 ] ( cmpbl,0 ) 
	WHILE- NZ
	  emit
	  adr+ 
	REPEAT
	[ $5b ]     ( pop bx      )
	;
	
		   : L/$.
	( * output longmem_string  )
	( ************************ )
	( arg: ES:DI=firstchar_adr )
	( out: -                   )
	( chg: -                   )
	( ************************ )
	dpush
	[ $53 ]           ( push bx   )
	BEGIN
	  [ $26 $8A $1D ] ( mov bl,es:[di] ) 
	  [ $80 $fb 0 ]   ( cmp bl,0  ) 
	WHILE- NZ
	  emit d+
	REPEAT
	[ $5b ]           ( pop bx    )
	dpop
	;       


	proc (stdemit)  ( hl,- )
			( - )
			( - )
	( ** Zeichen l in laufendes Handle ausgeben ** )
(       adrpush apush word b>m
	stdout# m>b 
	, 1  word write apop word m>b
	adrpop   )
	;

	proc (stdtype)  ( -,count )
			( ? )
			( adr )
	( ** String an Handle senden ** )
(       adr>d b>e stdout# m>b d>adr write e>b )
	;


	: space  ( - )
	( ** Leerzeichen ausgeben ** )
	bpush
	bl emit
	bpop 
	;


	: spaces  ( n,- => ? )
	( ** n Leerzeichen ausgeben ** )
	 FOR space NEXT
	;

	: cr  ( - )
	( ** CRLF ausgeben ** )
	bpush
	$A emit $D emit
	bpop 
	;

		proc (key) 
	( ** Taste  holen ** )
	( ************************ )
	( arg: -                   )
	( out: AL:= asci_val       )
	( chg: AX                  )
	( ************************ )             
	[ $B4 $01 ]   ( mov ah,#01 )
	[ $CD $21 ]   ( int 21     )
	[ $B4 $00 ]   ( mov ah,#00 )
	[ $C3 ]       ( ret        )
	;

		proc (key-noecho) 
	( ** Taste  holen ** )
	( ************************ )
	( arg: -                   )
	( out: AL:= asci_val       )
	( chg: AX                  )
	( ************************ )             
	[ $B4 $07 ]   ( mov ah,#07 )
	[ $CD $21 ]   ( int 21     )
	[ $B4 $00 ]   ( mov ah,#00 )
	[ $C3 ]       ( ret        )
	;

	proc (stdkey)  ( => -,c )
		       ( - )
		       ( - )
	( ** Tastatureingabe ** )
	( ** Sondertasten 256 erhht ** )
	bpush
	0 D.ax b>m
	$16 intr
	d.ax m>a
	bpop  
	[ $3C $00 ]      ( cmp al,#0   )
	[ $74 $03 ]      ( jz ew       )
	[ $30 $E4 ]      ( xor ah,ah   )
	[ $C3 ]          ( ret         )
	[ $86 $C4 ]      ( xchg al,ah  )
	[ $05 $FF $00 ]  ( add ax,#256 )
	;

	proc .?key.  ( => -,? ) ( f )
		     ( - )
		     ( - )
	( ** f:=1 : Zeichen vorhanden ** )
	[ $B4 $0B ] ( mov ah,#$B )
	[ $CD $21 ] ( int 21h    )
	[ $D0 $D8 ] ( rcr al,1   ) 

	;

        proc expect
	( ** expect string from keybord ** )
	( using DOS fct 10h, avoid ESC !   )
	( ******************************** )
	( arg: BX = maximum of input chars )
	(      SI = buffer_adr             )
	( out: -                           )
	( chg: AX                          )
	( ******************************** )
	b>a
	adrpush      ( adr retten )
	adr- adr-    ( max adr )
	1+           ( fr cr )
	[ $8A $1C ]  ( mov bl,[si] ) ( max holen )
	[ $43 ]      ( inc bx )
	[ $38 $C3 ]  ( cmp bl,al )
	IF- B
	  [ $88 $D8 ] ( mov al,bl )
	ENDIF
	[ $88 $04 ]  ( mov [si],al )
	[ $89 $F2 ]  ( mov dx,si )
	[ $B4 $0A ]  ( mov ah,0Ah )
	[ $CD $21 ]  ( int 21h )
	[ $4B ]      ( dec bx )
	[ $88 $1C ]  ( mov [si],bl : set old max )
	adr+
	[ $8A $04 ]  ( mov al,[si] : get count )
	[ $30 $E4 ]  ( xor ah,ah )
	adrn+ adr+
	[ $C6 4 0 ]  ( mov b/[si],0 : terminator )
	adrpop
	;


	: wait     ( ? )
		   ( ? )
		   ( ? )
	( **  Warte auf Taste mit Nachricht  ** )
	errdev
	"  -Mit jeder Taste weiter..!"  $.
	key -errdev
	;


		 : >default 
	( *** output to console *** )
	( ************************* )
	( arg: -                    )
	( out: -                    )
	( chg: ?                    )
	( ************************* )
	[ $c6 $06 stdout# 01 ] ( mov stdout#,1 )  
	make emit  (emit)
	make key   (key)
	make ?key  .?key.
	video-byte m>al
	 case
	 7 OF *$B000 ;;
	 else *$B800
	 endcase
	vseg b>m
	;


	( ** output numbers ** )

		      : nib.h 
	( **  hex output lower nibble of AL   ** )
	( Trick conversion from DOS-UNDOCUMENTED )
	(      Schulman: Addison-Wesley 1991     )
	( ************************************** )
	( arg: AL = value c                      )
	( out: -                                 )
	( chg: -                                 )
	( ************************************** )              
	[ $24 $0F ]                 ( and al,#0F )
	[ $04 $90 ]                 ( add al,#90 )
	[ $27 ]                     ( daa        )
	[ $14 $40 ]                 ( adc al,#40 )
	[ $27 ]                     ( daa        )
	xab emit a>b
	;

		 : byte.h 
	( ** hex output of AL ** )
	( ********************** )
	( arg: AL = value c      )
	( out: -                 )
	( chg: -                 )
	( ********************** ) 
	apush
	u/16  nib.h
	apop apush
	nib.h 
	apop
	;

		 : u.h 
	( ** hex output of AX ** )
	( ********************** )
	( arg: AX = value u      )
	( out: -                 )
	( chg: -                 )
	( ********************** ) 
	apush
	[ $88 $e0 ]  ( mov al,ah )
	byte.h
	apop
	byte.h
;

		 : (.d) 
	( ** dec output of AX ** )
	( ********************** )
	( arg: AX = value n      )
	( out: -                 )
	( chg: SI                )
	( ********************** ) 
	bpush
	dpush
	[ $51 ]         ( push cx      )
	D= $0A
	[ $31 $c9 ]     ( xor  cx,cx   )
	BEGIN
	[ $29 $d2 ]     ( sub  dx,dx   )
	[ $f7 $f7 ]     ( div  di      )
	[ $83 $c2 $30 ] ( add  di,#'0' )
	[ $52 ]         ( push dx      )
	[ $41 ]         ( inc  cx      )
	.0=.
	UNTIL
	b>a
	FOR-
	  bpop
	  emit
	NEXT-
	[ $59 ]         ( pop cx  )
	dpop bpop adr>a
	;

		: u.d 
	( ** dec output of AX ** )
	(      without sign      )
	( ********************** )
	( arg: AX = value u      )
	( out: -                 )
	( chg: SI                )
	( ********************** ) 
	bpush a>b a>adr
	.0=.
	IF '0' emit bpop exit ENDIF
	bpop
	(.d)
	;

		   : .d 
	( ** dec output of AX ** )
	(      with sign         )
	( ********************** )
	( arg: AX = value n      )
	( out: -                 )
	( chg: SI                )
	( ********************** ) 
	bpush a>b a>adr
	.0=.
	IF bl emit '0' emit bpop exit ENDIF
	.neg. if '-' emit neg else bl emit endif
	bpop
	(.d)
	;

	(long)
		  : decin# 
	( **  input decnumber    ** )
	( * no check for overflow * )
	( ************************* )
	( arg: -                    )
	( out: AX:= value n         )
	( chg: ?                    )
	( ************************* )
	D= 0
	byte m-off
	BEGIN
	  key 13 .=. .not. 
	WHILE
	  CASE
	    45   of byte m-on ;;       ( minus char )
	     8   of bl emit bs emit    ( backspace  )
		    d>a 10 / a>d ;;
	    '0' <of 7 emit bs emit bl emit bs emit ;;
	   '9' >of 7 emit bs emit bl emit bs emit ;;
	  ELSE  '0' - a>b d>a 10* + a>d    ( Ziffer )
	  ENDCASE
	REPEAT
	d>a
	byte IF- on neg ENDIF
	; 
	(short)

		  : .hexdigit.
	( ** convert hexchar in number ** )
	( ******************************* )
	( arg: AL=  hexcharacter          )
	( out: AL:= hexdigit              )
	(      CF:=1 if valid hexchar     )
	(      CF:=0 if not valid         )
	( chg: AL CF                      )
	( ******************************* )
	[ $2C $30 ]          ( sub al#,30 )
	IF- NC
	  [ $3C $0A ]        ( cmp al,#0A )
	  [ $F5 ]            ( cmc        )
	  IF- C
	    [ $24 $5F ]      ( and al,#5F )
	    [ $2C $07 ]      ( sub al,#07 )
	    [ $3C $0A ]      ( cmp al,#0A )
	    IF- NC
	      [ $3C $10 ]    ( cmp al,#10 )
	      [ $F5 ]        ( cmc        )
	    ENDIF
	  ENDIF
	ENDIF
	[ $F5 ]              ( cmc        )
	;

		   : hexin# 
	( ****  input i hexdigits  **** )
	( ***************************** )
	( arg: BL = i <= 4              )
	( out: AX:= number              )
	( chg: ?                        )
	( ***************************** )
	D= 0
	FOR
	[ $b4 $00 ]         ( mov ah,00 )
	[ $CD $16 ]         ( int 16    ) ( get key )
	[ $b4 $00 ]         ( mov ah,00 )  
	.hexdigit. 
	 if                  ( Ziffer )
	    [ $d1 $e7 ]      ( shl di,1 )
	    [ $d1 $e7 ]      ( shl di,1 )
	    [ $d1 $e7 ]      ( shl di,1 )
	    [ $d1 $e7 ]      ( shl di,1 ) ( 16* )        
	    [ $01 $c7 ]      ( add di,ax )
	    emit
	 else 
	    7 emit
	    [ $41 ]            ( inc cx )
	 endif
	NEXT
	d>a       
	; 

	( *** verschiedene Funktionen *** )

		 : min 
	( ** AX := minimum of...   )
	(    signed numbers     ** )
	( ************************ )
	( arg: AX = n1             )
	(      BX = n2             )
	( out  AX:= min(n1,n2)     )
	( chg: AX                  )
	( ************************ )
	[ $39 $D8 ]    ( cmp ax,bx )
	IF- G
	  [ $89 $D8 ]  ( mov ax,bx )
	ENDIF
	;

	: umin 
	( ** AX := minimum of...   )
	(    unsigned numbers   ** )
	( ************************ )
	( arg: AX = i1             )
	(      BX = i2             )
	( out  AX:= min(i1,i2)     )
	( chg: AX                  )
	( ************************ )
	[ $39 $D8 ]    ( cmp ax,bx )
	IF- A
	  [ $89 $D8 ]  ( mov ax,bx )
	ENDIF
	;


		  : max 
	( ** Maximum der Zahlen ** )
	( ** AX := maximum of...   )
	(    signed numbers     ** )
	( ************************ )
	( arg: AX = n1             )
	(      BX = n2             )
	( out  AX:= max(n1,n2)     )
	( chg: AX                  )
	( ************************ )
	[ $39 $D8 ]    ( cmp ax,bx )
	IF- L
	  [ $89 $D8 ]  ( mov ax,bx )
	ENDIF
	;


	       : Umax 
	( ** AX := maximum of...   )
	(    unsigned numbers   ** )
	( ************************ )
	( arg: AX = i1             )
	(      BX = i2             )
	( out  AX:= max(i1,i2)     )
	( chg: AX                  )
	( ************************ )
	[ $39 $D8 ]    ( cmp ax,bx )
	IF- B
	  [ $89 $D8 ]  ( mov ax,bx )
	ENDIF
	;




	( *** Initialisierung und Fehlerbehandlung *** )


	: halt  ( -,n => )
	( ** Programmabbruch ** )
	( ** n = 0 mit cls   ** )
	 .0=. if v-restor endif
	 exitcode
	 [ $FF $E6 ]    ( jmp si )
	;

 
	: halt"  ( -,n => )
	  ( Programmabbruch mit Meldung )
	  ( n = 0 mit cls               )
	  errdev
	  cr " Program aborted" $. cr wait
	  halt
	;

	( ** Fehlermeldungen MSDOS ** )

	(long)
		 : dosmsg 
	( ** DOS Fehlermeldungen *** )
	( arg: BX = error number     )
	(      AH = function number  )
	(      AL = subfunction#     )
	( out: ?, CF=1               )
	( chg: ?                     )
	( ************************** )
	" DOS-Funktion "  $. u.h
	" (h): " $.  
	b>a 
	     case
	     -2 of  " Datentrger voll............" $. ;;
	     -1 of  " Dateiende erreicht(EOF)....." $. ;;
	     02 of  "  2: Datei nicht gefunden...." $. ;;
	     03 of  "  3: Pfad nicht gefunden....." $. ;;
	     04 of  "  4: Zuviele Dateien geffnet" $. ;;
	     05 of  "  5: Zugriff verweigert......" $. ;;
	     06 of  "  6: Ungltige Dateinummer..." $. ;;
	     11 of  " 11: Ungltiges Format......." $. ;;
	     12 of  " 12: Ungltiger Zugriffscode." $. ;;
	     13 of  " 13: Ungltige Daten........." $. ;;
	     15 of  " 15: Ungltiges Laufwerk....." $. ;;
	     17 of  " 17: Nicht das gleiche Gert." $. ;;
	     18 of  " 18: Keine weiteren Dateien.." $. ;;
	    $50 of  " Datei bereits vorhanden....." $. ;;
	     else   " Fehler " $.  byte.h  " (h)" $.
	     endcase 
	;
	(short)


		 proc (doserrex) 
	( ** exit after dos-runtime-error ** )
	( arg: BX = doserrornumber           )
	(      AH = function#                )
	(      AL = subfunction#             )
	( out: ?                             )
	( chg: ?                             )
	( ********************************** )
	  apush bpush dpush
	  make emit (emit)
	  errdev 7 emit
	  dpop bpop apop dosmsg  
	  "  at " $. cs>a u.h ':' emit d>a u.h
	  0 halt"
	;

	proc (int0ex)  ( - )
	( ** Division durch Null ** )
	( Programmabbruch     )
	  [ $89 $E3 $36 $8B $07 ] apush
	  ds!
	  errdev
	  " Division by Zero at " $. 
	  cs>a u.h ':' emit apop u.h
	  129 halt"
	;

	proc (breakex) ( - )
	( ** Break-Handler fr ^C mit EXIT ** )
	  ds!
	  errdev
	  cr " ** USER BREAK " $. cr
	  128 halt"
	;

	     proc (breakfl) 
	( **  Set breakflag  ** )
	( interrupt $23 handler )
	( ********************* )
	( arg: -                )
	( out: -                )
	( chg: -                )
	( ********************* )
	[ $C6 6 $19 0 $FF ] ( mov [19],-1 )
	[ $CF ]             ( iret        )
	;

	    : initbreakfl 
	( ** break via flag ** )
	( ******************** )
	( arg: -               )
	( out: -               )
	( chg: -               )
	( ******************** )
	make break (breakfl)
	;

	: nxparas   ( => n )
	( ** n := Anzahl Paragraphen des Gesamtprogramms ** )
	[ $A1 HEAPSEG ] ( mov ax,:[22] : heapseg )
	[ $8C $CB ]     ( mov bx,cs    : codeseg )
	[ $29 $D8 ]     ( sub ax,bx    : minus   )
	;

	: memrelease 
	 ( => -,? )
	      ( - )
	      ( ? )
	( ** Gib Memory oberhalb von SP0 an DOS zurck ** )
	 nxparas D.bx a>m cs>a D.es a>m
	  $4A dos intr ?doserr  ( Segmentgre ndern )
	;


	     : initint 
	( ** init interrupts )
	( ****************** )
	( arg: -             )
	( out: -             )
	( chg: ?             )
	( ****************** )
	make doserr (doserrex)
	make break  (breakex)
	make int0   (int0ex)  
	$23 cs>e   ( Segment )
	d= break ( Break-vec )
	setint 
	0 cs>e     ( Segment )
	d= int0   ( Int0-vec )
	setint
	;


	       : init 
	(  initialize screen  )
	(    and interrupts   )
	( ******************* )
	( arg: -              )
	( out: -              )
	( chg: ?              )
	( ******************* )
	>default initint 
	;

	: clrscr ( ?,- )
	( - )
	( ? )
	( Bildschirm via BIOS lschen )
	$0700 d.bx b>m 0 d.cx b>m 
	$1950 d.dx b>m
	A= $0600 $10 intr
	0 d.dx b>m d.bx b>m
	A= $0200 $10 intr
	;

