( *** Naxos System-Vocabulary Version 2.01 *** )

( Name:     kern.fth          )
( Version:  2.01              )
( Revision: 1.01	      )
( Datum:    27.07.92          ) 
( Autoren:  Klaus Peper       )
(           Alexandros Zissis )


( --------------------------------------- )
( NAXOS V2.01                             )
( basiert auf MCC, FCC sowie NAXOS V1.xx  )
( --------------------------------------- )

( Darstellung der Register:               )
( BX.AX ) ( F ) ( Akkumulator; Carryflag  )
( ES.DI )       ( Hilfsakku, Zieladresse  )
   ( SI )       ( Adresse, Quelladresse   )

( c := Byte         8 Bit                 )
( h := HighByte     8 Bit                 )
( l := LowByte      8 Bit                 )
( n or i := Word   16 Bit                 )
( d := Doppelword  32 Bit                 )
( adr := Adresse   16 Bit                 )
( str := Adr countbyte einer Zeichenkette )
( Direktbezeichner 16 Bit                 )
( - := Inhalt beliebig und unverndert    )
( ? := Inhalt unbestimmt und verndert    )
( =>   Ausfhrung des Befehls             )



(short)

( ** System - Adressen ** )

( ** Codesegment ** )
aconst  entry    $102 ( Main           ) ;
aconst  DSEG     $10C ( Datensegment   ) ;
aconst  SSEG     $10E ( Stacksegment   ) ;
aconst  inreg    $110 ( Registerrecord ) ;
aconst  exitcode $187 ( Exitcodeadr    ) ;

( ** Datasegment ** )

( Registerrecord fr DOS-INTR-interface: ) 
aconst  D.AX  $00  ( Register AX  ) ;
aconst  D.BX  $02  ( Register BX  ) ;
aconst  D.CX  $04  ( Register CX  ) ;
aconst  D.DX  $06  ( Register DX  ) ;
aconst  D.BP  $08  ( Register BP  ) ;
aconst  D.SI  $0A  ( Register SI  ) ;
aconst  D.DI  $0C  ( Register DI  ) ;
aconst  D.DS  $0E  ( Register DS  ) ;
aconst  D.ES  $10  ( Register ES  ) ;
aconst  D.FL  $12  ( Flagregister ) ;
aconst  NPUSTAT $20 ( Status des Coprozessors ) ;
aconst  HEAPSEG $22 ( Heap-Segment ) ; 

( ** Weitere interne Adressen : ** )
( ** $14:    UpperLoopLimit     ** )
( ** $16:    ConditionSTack     ** )
( ** $18:    Errorexitbyte      ** )
( ** $19:    Breakbyte          ** )
( ** $1A:    Video-Byte         ** )
( ** $1B:    Mousebyte          ** )
( ** $1C-1D: Old Int0 offset    ** )
( ** $1E-1F: Old Int0 segm      ** )
( ** $20-21: NPU-Status         ** ) 
( ** $22:    HEAP-Segment       ** )
( ** $24-2F: frei               ** )

( ***************************************** )
( **    Interrupt Interface fr DOS      ** )
( * Muss vor Vektoren und Kolons stehen ! * )
( ***************************************** )

proc intr  ( i,hl ) ( f )
( ** Interrupt Nr. i, Fktn h, Unterfktn l aufrufen ** )
  ( push Register auf Returnstack )
  [ $06 $57 $56 $55 $51 $53 $50 $1E ] 
  (  ES  DI  SI  BP  CX  BX  AX  DS )

  [ $2E $88 $1E $1CA ]  ( mov cs:[1CA],bl : Interrupt patchen )

  ( Register aus Dos-Interface laden )
  [ $8B $1E $02 0 ] ( mov bx,[02] )
  [ $8B $0E $04 0 ] ( mov cx,[04] )
  [ $8B $16 $06 0 ] ( mov dx,[06] )
  [ $8B $2E $08 0 ] ( mov bp,[08] )
  [ $8B $36 $0A 0 ] ( mov si,[0A] )
  [ $8B $3E $0C 0 ] ( mov di,[0C] )
  [ $8E $06 $10 0 ] ( mov es,[10] )
  [ $FF $36 $0E 0 ] ( push   [0E] : DS holen )
  [ $1F ]           ( pop ds      : und setzen )
  [ $CD $00 ]       ( gepatchten Interrupt ausfhren )
  ( Register in Dos-Interface retten )
  [ $1F ]              ( pop ds : altes DS wiederherstellen )
  [ $A3 $00 0 ]        ( mov [00],ax )
  [ $89 $1E $02 0 ]    ( mov [02],bx )
  [ $89 $0E $04 0 ]    ( mov [04],cx )
  [ $89 $16 $06 0 ]    ( mov [06],dx )
  [ $89 $2E $08 0 ]    ( mov [08],bp )
  [ $89 $36 $0A 0 ]    ( mov [0A],si )
  [ $89 $3E $0C 0 ]    ( mov [0C],di )
  [ $8C $06 $10 0 ]    ( mov [10],es )

  ( pop Register von Returnstack )
  [ $58 $5B $59 $5D $5E $5F $07 ]
  (  AX  BX  CX  BP  SI  DI  ES )
  [ $FC ]              ( cld    )
;


( *** System-Vektoren *** )

vector doserr ( Fehlervektor fr DOS-Funktionen ) ;
vector emit   ( Zeichen ausgeben ) ;
vector key    ( Zeichen eingeben ) ;
vector ?key   ( Taste gedrckt ? ) ;
vector break  ( Control-C-Handler ) ;
vector int0   ( Division durch Null ) ;


( *** System-Konstanten *** )

const bl   32  ;   ( Leerzeichen )
const bs   8   ;   ( Backspace )


( *** Variablen - Definitionen ** )

typ  BYTE   [ 0 , ]  ( Byte ) ;
typ  WORD   Byte 2    ( Word ) ;

typ  FPTR   word 2    ( Farpointer ) ; 
typ  DOUBLE word 2    ( Double ) ;
typ  NPTR   word do:  ( Nearpointer )
     [ $8B $34 ]      ( mov si,[si] ) ;
     
          
( *** System-Variablen *** )
var VPTR    fptr         ( Video-ptr ) ;
var HPTR    fptr         ( Heap-ptr ) ;
var DPTR    fptr         ( Dataseg-ptr ) ;

( ** Handle-variablen ** )

var  stdout#   [ 2 , ]    ( outhandle ) ;
var  stdin#    [ 0 , ]    ( inhandle ) ;
var  hold#     [ 2 , ]    ( temp. handle ) ;
var  fin#      [ 0 , ]    ( Eingabe-Textdatei ) ;
var  fout#     [ 1 , ]    ( Ausgabe-Textdatei ) ;
var  fi/o#     [ 3 , ]    ( Direktzugriffsdatei ) ;




( ********************************* )
( * Worte, Funktionen, Operatoren * )
( ********************************* )


MACRO ###  ( - )
( **    Setze Breakpoint    ** )
( BR-Routine vorher aktivieren )
  [ $CC ]
;


( *** Registerbefehle *** )


( *** Kopierbefehle *** )

MACRO a>b  ( -,n => n,n )
           ( - )
           ( - )
( ** AX nach BX kopieren ** )
[ $89 $C3 ] ( mov bx,ax )
;

MACRO a>d  ( -,n )
           ( => -,n )
           ( - )
( ** AX nach DI kopieren ** )
[ $89 $C7 ] ( mov di,ax )
;

MACRO a>e  ( -,n )
           ( => n,- )
           ( - )
( ** AX nach ES kopieren ** )
[ $8E $C0 ] ( mov es,ax )
;

MACRO a>adr  ( -,adr )
             ( - )
             ( => adr )
( ** AX nach SI kopieren ** )
[ $89 $C6 ] ( mov si,ax )
;

MACRO b>a  ( n,- => n,n )
       ( - )
       ( - )
( ** BX nach AX kopieren ** )
[ $89 $D8 ] ( mov ax,bx )
;

MACRO b>d  ( n,- )
       ( => -,n )
       ( - )
( ** BX nach DI kopieren ** )
[ $89 $DF ] ( mov di,bx )
;

MACRO b>e  ( n,- )
       ( => n,- )
       ( - )
( ** BX nach ES kopieren ** )
[ $8E $C3 ]  ( mov es,bx )
;

MACRO b>adr  ( adr,- )
             ( - )
             ( => adr )
( ** BX nach SI kopieren ** )
[ $89 $DE ]  ( mov si,bx )
;

MACRO d>a  ( => -,n )
       ( -,n )
       ( - )
( ** DI nach AX kopieren ** )
[ $89 $F8 ]  ( mov ax,di )
;

MACRO d>b  ( => n,- )
       ( -,n )
       ( - )
( ** DI nach BX kopieren ** )
[ $89 $FB ]  ( mov bx,di )
;

MACRO d>e  ( - )
       ( -,n => n,n )
       ( - )
( ** DI nach ES kopieren ** )
[ $8E $C7 ]  ( mov es,di )
;

MACRO d>adr  ( - )
             ( -,adr )
             ( => adr )
( ** DI nach SI kopieren ** )
[ $89 $FE ]  ( mov si,di )
;

MACRO e>a  ( => -,n )
       ( n,- )
       ( - )
( ** ES nach AX kopieren ** )
[ $8C $C0 ]  ( mov ax,es )
;

MACRO e>b  ( => n,- )
       ( n,- )
       ( - )
( ** ES nach BX kopieren ** )
[ $8C $C3 ]  ( mov bx,es )
;

MACRO e>d  ( - )
           ( n,- => n,n )
           ( - )
( ** ES nach DI kopieren ** )
[ $8C $C7 ]  ( mov di,es )
;

MACRO e>adr  ( - )
             ( adr,- )
             ( => adr )
( ** ES nach SI kopieren ** )
[ $8C $C6 ]  ( mov si,es )
;

MACRO adr>a  ( => -,adr )
             ( - )
             ( adr )
( ** ADR nach AX kopieren ** )
[ $89 $F0 ]  ( mov ax,si )
;

MACRO adr>b  ( => adr,- )
         ( - )
         ( adr )
( ** ADR nach BX kopieren ** )
[ $89 $F3 ]  ( mov bx,si )
;

MACRO adr>d  ( - )
         ( => -,adr )
         ( adr )
( ** SI nach DI kopieren ** )
[ $89 $F7 ]  ( mov di,si )
;

MACRO adr>e  ( - )
         ( => adr,- )
         ( adr )
( ** ADR nach ES kopieren ** )
[ $8E $C6 ]  ( mov es,si )
;

MACRO d:a>d  ( d )
             ( => d )
             ( - )
( ** BX:AX nach ES:DI kopieren ** )
[ $89 $C7 ] ( mov di,ax )
[ $8E $C3 ] ( mov es,bx )
;

MACRO d:d>a  ( => d )
             ( d )
             ( - )
( ** ES:DI nach BX:AX kopieren ** )
[ $89 $F8 ] ( mov ax,di )
[ $8C $C3 ] ( mov bx,es )
;

 
MACRO apush  ( -,n )
         ( - )
         ( - )
( ** AX auf Stack ** )
[ $50 ]  ( push ax )
;
 
MACRO bpush  ( n,- )
         ( - )
         ( - )
( ** BX auf Stack ** )
[ $53 ]  ( push bx )
;
 
MACRO dpush  ( - )
         ( -,n )
         ( - )
( ** DI auf Stack ** )
[ $57 ]  ( push di )
;
 
MACRO epush  ( - )
         ( n,- )
         ( - )
( ** ES auf Stack ** )
[ $06 ]  ( push es )
;
 
MACRO adrpush  ( - )
           ( - )
           ( adr )
( ** ADR auf Stack ** )
[ $56 ]  ( push si )
;

MACRO d:push ( d )
         ( - )
         ( - )
( ** B,A auf stack ** )
apush bpush
;
 
MACRO apop  ( => -,n )
        ( - )
        ( - )
( ** Stack nach AX ** )
[ $58 ]  ( pop ax )
;
 
MACRO bpop  ( => n,- )
        ( - )
        ( - )
( ** Stack nach BX ** )
[ $5B ]  ( pop bx )
;
 
MACRO dpop  ( - )
        ( => -,n )
        ( - )
( ** Stack nach DI ** )
[ $5F ]  ( pop di )
;
 
MACRO epop  ( - )
        ( => n,- )
        ( - )
( ** Stack nach ES ** )
[ $07 ]  ( pop es )
;
 
MACRO adrpop  ( - )
          ( - )
          ( => adr )
( ** Stack nach ADR ** )
[ $5E ]  ( pop si )
;

MACRO d:pop  ( => d )
         ( - )
         ( - )
( ** B,A von Stack holen ** )
bpop apop
;

MACRO adr+a  ( -,n => -,n+adr )
         ( - )
         ( adr )
( ** Addiere Adresse zu n ** )
[ $01 $F0 ] ( add ax,si )
;

MACRO 1+  ( -,n => -,n+1 )
      ( - )
      ( - )
( ** Inkrement AX ** )
[ $40 ]  ( inc ax )
;

MACRO 2+  ( -,n => -,n+2 )
      ( - )
      ( - )
( ** Inkrement AX um 2 ** )
[ $40 $40 ]  ( inc ax inc ax )
;

MACRO b+  ( - )
      ( - )
      ( adr => adr+1 )
( ** Inkrement BX um 1 ** )
[ $43 ]  ( inc bx )
;

MACRO d+  ( n,- => n+1,- )
      ( - )
      ( - )
( ** Inkrement DI ** )
[ $47 ] ( inc di )
;

MACRO adr+ ( - )
       ( - )
       ( adr => adr+1 )
( ** Inkrement ADR ** )
[ $46 ]  ( inc si )
;

MACRO adr++  ( - )
         ( - )
         ( adr => adr+2 )
( ** ADR um 2 erhhen ** )
[ $46 $46 ] ( inc si inc si )
;

MACRO adrn+  ( -,n )
         ( - )
         ( adr => adr+n )
( ** ndere ADR um n ** )
[ $01 $C6 ] ( add si,ax )
;

MACRO 1-  ( -,n => -,n-1 )
      ( - )
      ( - )
( ** Dekrement AX ** )
[ $48 ]  ( dec ax )
;

MACRO 2-  ( -,n => -,n-2 )
      ( - )
      ( - )
( ** Dekrement AX um 2 ** )
[ $48 $48 ]  ( dec ax dec ax )
;

MACRO b-  ( - )
      ( - )
      ( adr => adr-1 )
( ** Dekrement BX ** )
[ $4B ] ( dec bx )
;

MACRO d-  ( n,- => n-1,- )
      ( - )
      ( - )
( ** Dekrement DI ** )
[ $4F ] ( dec di )
;

MACRO adr-  ( - )
        ( - )
        ( adr => adr-1 )
( ** Dekrement ADR ** )
[ $4E ] ( dec si )
;

MACRO adr--  ( - )
         ( - )
         ( adr => adr-2 )
( ** ADR um 2 erniedrigen ** )
[ $4E $4E ] ( dec si dec si )
;

MACRO a<>b  ( n1,n2 => n2,n1 )
        ( - )
        ( - )
( ** AX und BX tauschen ** )
[ $93 ] ( xchg ax,bx )
;

MACRO a<>d  ( -,n1 => -,n2 )
        ( -,n2 => -,n1 )
        ( - )
( ** Exchange AX mit DI ** )
[ $97 ] ( xchg ax,di )
;

MACRO ds>e  ( - )
        ( => ds,- )
        ( - )
( ** Setze ES gleich DS ** )
[ $8C $DA ] ( mov dx,ds )
[ $8E $C2 ] ( mov es,dx )
;

MACRO cs>e  ( - )
        ( => cs,- )
        ( - )
( ** Setze ES gleich CS ** )
[ $8C $CA ] ( mov dx,cs )
[ $8E $C2 ] ( mov es,dx )
;



( *** einfache Arithmetik *** )


MACRO +   ( n2,n1 => n2,n' )
      ( - )
      ( - )
( ** Summe n':= n2 + n1 ** )
[ $01 $D8 ] ( add ax,bx )
;


MACRO -   ( n1,n = n2,n' )
      ( - )
      ( - )
( ** Differenz n':= n - n1 ** )
[ $29 $D8 ] ( sub ax,bx )
;


MACRO *   ( n1,n => d )
      ( - )
      ( - )
( ** Produkt d := n1*n  ** )
[ $F7 $EB ] ( imul bx )
[ $89 $D3 ] ( mov bx,dx )
;

MACRO 2*  ( -,n => -,2n )
      ( - )
      ( - )
( ** Multiplikation mit 2 ** )
[ $01 $C0 ] ( add ax,ax )
;

MACRO 10*  ( -,n => -,10n )
       ( - )
       ( - )
( ** Schnelle Multiplikation mit 10 ** )
[ $D1 $E0 ]  ( shl ax,1 )
[ $89 $C2 ]  ( mov dx,ax )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $E0 ]  ( shl ax,1 )
[ $01 $D0 ]  ( add ax,dx )
;

MACRO 16* ( -,n => -,16n )
          ( - )
          ( - )
( ** Schnelle Multiplikation mit 16 ** )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $E0 ]  ( shl ax,1 )
;

MACRO /  ( n1,n => r,q )
     ( - )
     ( - )
( ** Quotient q := n/n1, Rest r ** )
[ $99 ]     ( cwd        )
[ $F7 $FB ] ( idiv bx    )
[ $89 $D3 ] ( mov bx,dx  )
;

MACRO u2/  ( -,u => -,u/2 )
           ( - )
           ( - )
( ** Division durch 2     ** )
( ** Schnelle Skalierung  ** )
[ $D1 $E8 ] ( shr ax,1 )
;

MACRO u16/  ( -,u => -,u/16 )
            ( - )
            ( - )
( ** Division durch 16 ** )
[ $D1 $E8 ] ( shr ax,1 )
[ $D1 $E8 ] ( shr ax,1 )
[ $D1 $E8 ] ( shr ax,1 )
[ $D1 $E8 ] ( shr ax,1 )
;

: d:/  ( ud => ud' ) 
       ( -,n => -,r )
       ( - )
( ** Qotient ud':= ud/n, Rest r  ** )
[ $83 $FF $01 ] ( cmp di,#01 )
[ $74 $0F ]     ( je exit      )
[ $93 ]         ( xchg ax,bx   ) 
[ $31 $D2 ]     ( xor  dx,dx   ) 
[ $F7 $F7 ]     ( div  di      ) ( (0:high)/u )
[ $93 ]         ( xchg ax,bx   )
[ $F7 $F7 ]     ( div  di      ) ( (rest:low)/u )
[ $89 $D7 ]     ( mov  di,dx   ) ( rest' )
;


MACRO */  ( n1,n => r,n' )
      ( -,n2 )
      ( - )
( * Skalierung ber doppeltgenaues Produkt  * )      
( *  n' := n*n1/n2, r := rest               * )
[ $F7 $EB ] ( imul bx )
[ $F7 $FF ] ( idiv di )
;


MACRO d:n>  ( -,n => d )
        ( - )
        ( - )
( ** einfache Zahl -> doppelt genau ** )
[ $99 ]     ( cwd  )
[ $89 $D3 ] ( mov bx,dx )
;

MACRO u>d  ( -,u => d )
       ( - )
       ( - )
( ** Einfache Zahl ohne Vorzeichen in Doppelzahl ** )
[ $31 $DB ]  ( xor bx,bx )
;

MACRO d:neg  ( d => -d )
         ( - )
         ( - )
( ** Vorzeichenwechsel ** )
[ $F7 $D0 ]   ( not ax    )
[ $F7 $D3 ]   ( not bx    )
[ $05 1 0 ]   ( add ax,#1 )
[ $83 $D3 0 ] ( adc bx,#0 )
;

MACRO d:+  ( d => d' )
       ( d1 )
       ( - )
( ** Summe d':= d + d1 ** )
[ $8C $C2 ]  ( mov dx,es )
[ $01 $F8 ]  ( add ax,di ) 
[ $11 $D3 ]  ( adc bx,dx ) 
;

: d:u*  ( ud => ud' ) 
        ( -:u )
        ( - )
( ** Doppelwort mit u multiplizieren ** )
( ** Keine Sicherung gegen berlauf ** )
[ $51 ]      ( push cx     )
[ $F7 $E7 ]  ( mul  di     ) ( low*u )
[ $89 $D1 ]  ( mov  cx,dx  ) ( bertrag retten )
[ $93 ]      ( xchg ax,bx  ) 
[ $F7 $E7 ]  ( mul  di     ) ( high*u )
[ $93 ]      ( xchg ax,bx  )
[ $01 $CB ]  ( add  bx,cx  ) ( +bertrag )
[ $59 ]      ( pop  cx     ) 
;

MACRO d:2*  ( ud => 2*ud )
        ( - )
        ( - )
( ** Doppelwort shift left ** )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $D3 ]  ( rcl bx,1 )
;

: d:10*  ( d => 10d )
         ( - )
         ( - )
( Doppelwort mal 10 ** )
[ $51 ]      ( push cx   )
[ $D1 $E0 ]  ( shl ax,1  )
[ $D1 $D3 ]  ( rcl bx,1  )
[ $89 $C1 ]  ( mov cx,ax )
[ $89 $DA ]  ( mov dx,bx )
[ $D1 $E0 ]  ( shl ax,1  )
[ $D1 $D3 ]  ( rcl bx,1  )
[ $D1 $E0 ]  ( shl ax,1  )
[ $D1 $D3 ]  ( rcl bx,1  )
[ $01 $C8 ]  ( add ax,cx )
[ $11 $D3 ]  ( adc bx,dx )
[ $59 ]      ( pop cx    )
;

: d:16*  ( d => 16d )
         ( - )
         ( - )
( ** Doppelwort mal 16 ** )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $D3 ]  ( rcl bx,1 )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $D3 ]  ( rcl bx,1 )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $D3 ]  ( rcl bx,1 )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $D3 ]  ( rcl bx,1 )
;

MACRO and ( n1,n => n1,n' )
      ( - )
      ( - )
( ** n':= n AND n1 ** )
[ $21 $D8 ] ( and ax,bx )
;

MACRO or  ( n1,n => n1,n' )
      ( - )
      ( - )
( **  n':= n OR n1  ** )
[ $09 $D8 ] ( or ax,bx )
;

MACRO xor ( n1,n => n1,n' )
      ( - )
      ( - )
( **  n':= n XOR n1  ** )
[ $31 $D8 ] ( xor ax,bx )
;


MACRO neg  ( -,n => -,n' )
       ( - )
       ( - )
( ** Vorzeichenwechsel ** )
[ $F7 $D8 ] ( neg  ax )
;


MACRO not  ( -,n => -,n' )
       ( - )
       ( - )
( **  Komplement bilden ** )
[ $F7 $D0 ] ( not  ax )
;


( *** Speicher-Befehle *** )

( *** Prefix bytes *** )

MACRO CS: [ $2E ] ;
MACRO DS: [ $3E ] ;
MACRO SS: [ $36 ] ;
MACRO ES: [ $26 ] ;

MACRO val>a  ( => -,n )
	 ( - )
	 ( adr )
( ** Word aus Adresse nach AX ** )
[ $8B $04 ] ( mov ax,[si] )
;

MACRO B/val>a  ( => -,c )
	   ( - )
	   ( adr )
( ** Byte aus Adresse nach AX ** )
[ $8A $04 ] ( mov  al,[si] )
[ $B4 $00 ] ( mov  ah,#0   )
;

MACRO d:val>a  ( => d )
	   ( - )
	   ( adr )
( ** Doppelword aus Adresse nach BX:AX ** )
[ $8B $5C 2 ] ( mov bx,[si+2] )
[ $8B $04   ] ( mov ax,[si]   )
;

MACRO ival>a  ( i.- => 2i.n )
          ( - )
          ( adr )
( ** Indiziertes Wort nach AX ** )
[ $D1 $E3 ]  ( shl bx,1       )
[ $8B $00 ]  ( mov ax,[si+bx] )
;

MACRO B/ival>a  ( i.- => i.c )
            ( - )
            ( adr )
( ** Indiziertes Byte nach AX ** )
[ $B4 $00 ]  ( mov ah,00      )
[ $8A $00 ]  ( mov al,[si+bx] )
;
 
 
MACRO val>adr  ( - )
	       ( - )
	       ( adr => adr' )
( ** ADR mit Wert aus Adresse laden ** )
[ $8B $34 ]   ( mov si,[si] )
;

MACRO val>b  ( => n,- )
	     ( - )
	     ( adr )
( ** Word von Adresse nach BX ** )
[ $8B $1C ] ( mov bx,[si] )
;

MACRO B/val>b  ( => c,- )
	   ( - )
	   ( adr )
( ** Byte von Adresse nach BX ** )
[ $8A $1C ]  ( mov bl,[si] )
[ $30 $FF ]  ( xor bh,bh   )
;

MACRO val>d  ( - )
	 ( => -,n )
	 ( adr )
( ** Word von Adresse nach DI ** )
[ $8B $3C ] ( mov di,[si]   )
;

MACRO B/val>d  ( - )
	   ( => -,c )
	   ( adr )
( ** Byte aus Adresse nach DI ** )
[ $8A $14 ] ( mov dl,[si] )
[ $30 $F6 ] ( xor dh,dh   )
[ $89 $D7 ] ( mov di,dl   )
;

MACRO d:val>d  ( - )
	   ( => d )
	   ( adr )
( ** Doppelword von Adresse nach ES:DI ** )
[ $C4 $3C ] ( les di,[si] )
;

MACRO val>e  ( - )
	 ( => n,- )
	 ( adr )
( ** Word von Adresse nach ES ** )
[ $8B $14 ] ( mov dx,[si] )
[ $8E $C2 ] ( mov es,dx   )
;

MACRO B/val>e  ( - )
	   ( => c,- )
	   ( adr )
( ** Byte von Adresse nach ES laden ** )
[ $8A $14 ] ( mov dl,[si] )
[ $30 $F6 ] ( xor dh,dh   )
[ $8E $C2 ] ( mov es,dx   )
;

MACRO sto  ( -:n )
	   ( seg:adr )
	   ( - )
 ( ** AX nach ES:DI speichern )
 ( ** DI um 2 erhhen         )
 [ $AB ] ( STOSW )
;	 

MACRO B/sto  ( -:c )
	     ( seg:adr )
	     ( - )
 ( ** AL nach ES:DI speichern )
 ( ** DI um 1 erhhen         )
 [ $AA ] ( STOSB )
;	 

MACRO lod  ( => -,n )
           ( - )
           ( ds:adr )
( ** AX aus ds:si laden ** )
( ** SI um 2 erhhen    ** )
[ $ad ] ( LODSW )
;

MACRO B/lod  ( => -,c )
             ( - )
             ( ds:adr )
( ** AL aus ds:si laden ** )
( ** SI um 1 erhhen    ** )
[ $ac ] ( LODSB )
;

MACRO ! ( -,n )
    ( - )
    ( adr )
( ** Word aus AX in Adresse speichern ** )
[ $89 $04 ] ( mov  [si],ax )
;

MACRO B/!  ( -,c )
       ( - )
       ( adr )
( ** Byte aus AL in Adresse speichern ** )
[ $88 $04 ] ( mov  [si],al )
;

MACRO d:!  ( d )
       ( - )
       ( adr )
( ** Doppelwort BX:AX speichern ** )
[ $89 $04 ]    ( mov [si],ax   )
[ $89 $5C 2 ]  ( mov [si+2],bx )
;

MACRO i!  ( i,n => 2i,n )
      ( - )
      ( adr )
( ** Word indiziert speichern ** )
[ $D1 $E3 ]  ( shl bx,1 )
[ $89 $00 ]  ( mov [si+bx],ax )
;

MACRO B/i!  ( i.c )
        ( - )
        ( adr )
( ** Byte indiziert speichern ** )
[ $88 $00 ]  ( mov [si+bx],al )
;

MACRO b!  ( n,- )
      ( - )
      ( adr )
( ** Word aus BX in Adresse speichern ** )
[ $89 $1C ] ( mov [si],bx )
;

MACRO B/b!  ( c,- )
	( - )
	( adr )
( ** Byte aus BL in Adresse speichern ** )
[ $88 $1C ] ( mov [si],bl )
;

MACRO d! ( - )
     ( - ,n )
     ( adr )
( ** Wort aus DI in Adresse speichern ** )
[ $89 $3C ] ( mov [si],di )
;

MACRO B/d! ( - )
       ( -,c )
       ( adr )
( ** Byte aus DI speichern ** )
[ $89 $FA ] ( mov dx,di )
[ $88 $14 ] ( mov [si],dl )
;

MACRO d:d!  ( - )
	( d )
	( adr )
( ** Doppelwort ES.DI speichern ** )
[ $8C $C2 ]    ( mov dx,es     )
[ $89 $3C ]    ( mov [si],di   )
[ $89 $54 2 ]  ( mov [si+2],dx )
;
 
MACRO e!  ( - )
      ( n,- )
      ( adr )
( ** Word aus ES in Adresse speichern ** )
[ $8C $C2 ]  ( mov dx,es   )
[ $89 $14 ]  ( mov [si],dx )
;

MACRO B/e!  ( - )
	( c,- )
	( adr )
( ** Byte aus ES speichern ** )
[ $8C $C2 ]  ( mov dx,es )
[ $88 $14 ]  ( mov [si],dl )
;


MACRO (adr)n+  ( -,n )
	       ( - )
	       ( adr )
( ** Word in (adr) um n verndern ** )
[ $01 $04 ] ( add  [si],ax )
;

MACRO B/(adr)n+  ( -,c )
	     ( - )
	     ( adr )
( ** Byte in (adr) um c verndern ** )
[ $00 $04 ] ( add [si],al ) 
;

MACRO inc  ( - )
       ( - )
       ( adr )
( ** Word in adr um 1 erhhen ** )
[ $FF $04 ] ( inc  [si]  )
;

MACRO B/inc  ( - )
         ( - )
         ( adr )
( ** Byte in adr um 1 erhhen ** )
[ $FE $04 ] ( inc  b/[si]  )
;

MACRO dec  ( - )
       ( - )
       ( adr )
( ** Word in adr um 1 erniedrigen ** )
[ $FF $0C ] ( dec  [si]  )
;

MACRO B/dec  ( - )
         ( - )
         ( adr )
( ** Byte in adr um 1 erniedrigen ** )
[ $FE $0C ] ( dec  b/[si]  )
;


MACRO d:copy ( - )
	     ( -,nachadr )
	     ( vonadr )
( ** Doppelword kopieren  ** )
( Syntax: a to b  d:copy     )
[ $8B $14 ]   ( mov dx,[si]  )
[ $89 $15 ]   ( mov [di],dx  )
[ $8B $54 2 ] ( mov dx,[si]2 )
[ $89 $55 2 ] ( mov [di]2,dx )
;

: imove  ( -,i => -,? )
	 ( -,nachadr => ? )
	 ( vonadr )
( ** i Bytes im Memory verschieben ** )
( Verschieben nur im aktuellen DS !   )
( Bereiche drfen berlappen !        )
( Syntax: a to b  cmove               )
[ $91 ]       ( xchg ax,cx )
[ $8C $DA ]   ( mov  dx,ds )
[ $8E $C2 ]   ( mov  es,dx )
[ $89 $F2 ]   ( mov  dx,si )
[ $39 $F7 ]   ( cmp  di,si )
[ $7E 7   ]   ( jg   +7    ) 
[ $03 $F1 ]   ( add  si,cx )
[ $03 $F9 ]   ( add  di,cx )
[ $4E ]       ( dec  si    )
[ $4F ]       ( dec  di    )
[ $FD ]       ( std        )
[ $F3 $A4 ]   ( rep  movsb )
[ $FC ]       ( cld        )
[ $89 $D6 ]   ( mov  si,dx )
[ $89 $C1 ]   ( mov  cx,ax )  
;

: $:move  ( => -,? )
	  ( -,zieladr )
	  ( quelladr )
( ** String in DS kopieren ** )
( Syntax: a to b $:move )
( a, b sind Stringadressen )
( ist len(a)>len(b), so wird )
( nur len(b) bertragen )
[ $8A $04 ]       ( mov al,[si]   : Quellcount )
[ $8A $65 $FF ]   ( mov ah,[di]-1 : Zielcount  )
[ $38 $E0 ]       ( cmp al,ah )
[ $72 $08 ]       ( jb +8 )
[ $88 $25 ]       ( mov [di],ah   : countmax   )
[ $46 $47 ]       ( inc si inc di )
[ $88 $E0 ]       ( mov al,ah )
[ $48 $48 ]       ( dec ax dec ax )
[ $30 $E4 ]       ( xor ah,ah )
[ $40 $40 ]       ( inc ax inc ax )
imove
;

: $:del  ( i,- => ?,? )
	 ( => ?,? )
	 ( adr => ?)
( ** Delete i. char im String ** )
[ $8C $DA ]  ( mov dx,ds   )
[ $8E $C2 ]  ( mov es,dx   )
[ $8A $14 ]  ( mov dl,[si] )
[ $30 $F6 ]  ( xor dh,dh   )
[ $38 $F3 ]  ( cmp bl,dh   )
[ $74 $14 ]  ( jz  ex      )
[ $39 $D3 ]  ( cmp bx,dx   )
[ $77 $10 ]  ( ja  ex      )
[ $FE $0C ]  ( dec b/[si]  )
[ $01 $DE ]  ( add si,bx   )
[ $89 $F7 ]  ( mov di,si   )
[ $46 ]      ( inc si      )
[ $29 $DA ]  ( sub dx,bx   )
[ $87 $CA ]  ( xchg cx,dx  )
[ $41 ]      ( inc cx      )
[ $F3 $A4 ]  ( rep movsb   )
[ $89 $D1 ]  ( mov cx,dx   )
;


: cfill  ( c,i => ? )
	 ( => ? )
	 ( adr )
( ** i Bytes ab adr mit char c fllen ** )
[ $91 ]       ( xchg cx,ax  )
[ $93 ]       ( xchg ax,bx  )
[ $8C $DA ]   ( mov  dx,ds  )
[ $8E $C2 ]   ( mov  es,dx  )
[ $89 $F7 ]   ( mov  di,si  )
[ $F3 $AA ]   ( rep  stosb  )
[ $89 $D9 ]   ( mov  cx,bx  )
;

: fill  ( n,i => ? )
	( => ? ) 
	( adr )
( ** i Worte ab adr mit n fllen ** )
( ** u ist maximal 32k           ** )
[ $91 ]       ( xchg cx,ax )
[ $93 ]       ( xchg ax,bx )
[ $8C $DA ]   ( mov  dx,ds )
[ $8E $C2 ]   ( mov  es,dx )
[ $89 $F7 ]   ( mov  di,si )
[ $F3 $AB ]   ( rep  stosw )
[ $89 $D9 ]   ( mov  cx,bx )
;

MACRO erase  ( -,i => ? )
	 ( => ? )
	 ( adr )
( ** ab adr i Bytes auf 0 setzen ** )
0  cfill 
;

MACRO blank  ( -,i => ? )
	 ( => ? )
	 ( adr )
( ** ab adr i Bytes auf 32 setzen ** )
bl cfill 
;

MACRO on  ( - )
      ( - )
      ( adr )
( ** Word in mem auf -1 setzen ** )
[ $C7 $04 $FF $FF ] ( mov [si],#-1 )
;

MACRO off  ( - )
       ( - )
       ( adr )
( ** Word in mem auf 0 setzen ** )
[ $C7 $04 $00 $00 ] ( mov [si],#0 )
;

MACRO B/on  ( - )
	( - )
	( adr )
( ** Byte in mem auf -1 setzen ** )
[ $C6 $04 $FF ] ( mov [si],#-1 )
;

MACRO B/off  ( - )
	 ( - )
	 ( adr )
( ** Byte in mem auf 0 setzen ** )
[ $C6 $04 0 ] ( mov [si],#0 )
;

MACRO sp@  ( => -,adr )
       ( - )
       ( - )
( ** Hole Returnpointer ** )
[ $89 $E0 ] ( mov ax,sp )
;

MACRO sp!  ( -,adr )
       ( - )
       ( - )
( ** Setze Returnpointer ** )
[ $89 $C4 ] ( mov sp,ax )
;


( *** Untersttzung strukturierter Befehle *** )


MACRO i  ( => -,index )
     ( - )
     ( - )
( ** Schleifenindex nach AX kopieren ** )
[ $89 $C8 ] ( mov ax,cx )
;

MACRO i>adr  ( - )
	 ( - )
	 ( => index )
( ** Schleifenindex nach SI kopieren ** )
[ $89 $CE ] ( mov si,cx )
;

MACRO i>b  ( => index,- )
       ( - )
       ( - )
( ** Schleifenindex nach BX kopieren ** )
[ $89 $CB ]  ( mov bx,cx )
;

MACRO j  ( => -,index )
     ( - )
     ( - )
( ** ueren Schleifenindex kopieren ** )
[ $58 $50 ] ( pop ax push ax )
;

MACRO j>adr  ( - )
	 ( - )
	 ( => index )
( ** ueren Schleifenindex kopieren ** )
[ $5B $53 ]  ( pop si push si )
;

MACRO leave  ( - )
( ** Befehle bis LOOP bearbeiten ** )
( ** und dann Schleife verlassen ** )
[ $89 $0E 0 1 ] ( mov [100],cx )
;

MACRO exit  ( - )
( ** Wort abbrechen,                ** )
( ** wirkt wie Sprung auf Semikolon ** )
[ $C3 ] ( ret )
;



( *** Flag- und Vergleichs- operatoren *** )

MACRO .T.   ( - ) ( true )
( ** Flag True ** )
[ $F9 ] ( stc )
;

MACRO .F.   ( - ) ( false )
( ** Flag False ** )
[ $F8 ] ( clc )
;

MACRO .not. ( - ) ( f )
( ** Flag Komplement ** )
[ $F5 ] ( cmc )
;

MACRO flag>  ( - ) ( f )
( ** Park ConditionFlag ** )
[ $D1 $16 $16 0 ]  ( rcl [16],1 )
;

: .>and.  ( - ) ( f => f' )
( ** f' := f1 and Parkflag ** )
( ! nur nach flag> mglich ! )
[ $D0 $D6 ]            ( rcl dh,1   )
[ $D1 $0E $16 0 ]      ( ror [16],1 )
[ $D0 $D2 ]            ( rcl dl,1   )
[ $20 $F2 ]            ( and dl,dh  )
[ $D0 $CA ]            ( ror dl,1   )
;

: .>or.  ( - ) ( f => f' )
( ** f' := f1 and Parkflag ** )
( ! nur nach flag> mglich ! )
[ $D0 $D6 ]            ( rcl dh,1      )
[ $D1 $0E $16 0 ]      ( ror b/[102],1 )
[ $D0 $D2 ]            ( rcl dl,1      )
[ $08 $F2 ]            ( or  dl,dh     )
[ $D0 $CA ]            ( ror dl,1      )
;

: .>xor.  ( - ) ( f => f' )
( ** f' := f1 and Parkflag ** )
( ! nur nach flag> mglich ! )
[ $D0 $D6 ]            ( rcl dh,1      )
[ $D1 $0E &16 0 ]      ( ror b/[102],1 )
[ $D0 $D2 ]            ( rcl dl,1      )
[ $30 $F2 ]            ( xor  dl,dh    )
[ $D0 $CA ]            ( ror dl,1      )
;

MACRO .odd.  ( -,n ) ( f )
( ** f := .T. wenn n ungerade ** )
[ $D1 $D8 ] ( rcr ax,1 )
[ $D1 $D0 ] ( rcl ax,1 )
;

MACRO .even.  ( -,n ) ( f )
( ** f := .T. wenn n gerade ** )
[ $D1 $D8 ] ( rcr ax,1 )
[ $D1 $D0 ] ( rcl ax,1 )
[ $F5 ]     ( cmc      )
; 

MACRO .0=.  ( -,n ) ( f )
( ** f:=.T. if n=0 ** )
[ $3D 0 0 ] ( test ax,ax )
[ $75 1 ]   ( jnz  +1    )
[ $F5 ]     ( cmc        )
;

MACRO .1=.  ( -,n ) ( f )
( ** f:=.T. if n=1 ** )
[ $3D 1 0 ] ( cmp  ax,#1 )
[ $F8 ]     ( clc        )
[ $75 1 ]   ( jnz  +1    )
[ $F5 ]     ( cmc        )
;


MACRO .-1=.  ( -,n ) ( f )
( ** f:=.T. if n=-1 ** )
[ $3D $FF $FF ] ( cmp  ax,#-1  )
[ $F8 ]         ( clc        )
[ $75 1 ]       ( jnz  +1    )
[ $F5 ]         ( cmc        )
;


MACRO .0<.  ( -,n ) ( f )
( ** f:=.T. if n<0 ** )
[ $3D 0 0 ] ( cmp  ax,#0 )
[ $F8 ]     ( clc        )
[ $7D 1 ]   ( jge  +1    )
[ $F5 ]     ( cmc        )
;


MACRO .0>.  ( -,n ) ( f )
( ** f:=.T. if n>0 ** )
[ $3D 0 0 ] ( cmp  ax,#0 )
[ $F8 ]     ( clc        )
[ $7E 1 ]   ( jle  +1    )
[ $F5 ]     ( cmc        )
;

  
MACRO .0<>.  ( -,n ) ( f )
( ** f=.T. if n <> 0 ** )
.0=. .not. [ $F5 ] ( cmc )
;

MACRO .=.   ( n1,n2 ) ( f )
( ** f:=.T. if n1 = n2 ** )
[ $39 $D8 ] ( cmp  ax,bx )
[ $F8 ]     ( clc        )
[ $75 1 ]   ( jnz  +1    )
[ $F5 ]     ( cmc        )
;

MACRO .>.  ( n1,n ) ( f )
( ** f=.T. if n > n1 ** )
[ $39 $C3 ]  ( cmp bx,ax )
[ $F8 ]      ( clc       )
[ $7D $01 ]  ( jge +1    )
[ $F5 ]      ( cmc       )
;


MACRO .<.  ( n1,n ) ( f )
( ** f=.T. if n < n1 ** )
[ $39 $C3 ]  ( cmp bx,ax )
[ $F8 ]      ( clc       )
[ $7E $01 ]  ( jle +1    )
[ $F5 ]      ( cmc       ) 
;

MACRO .<>.  ( n1,n2 ) ( f )
( ** f=-1 if n1 <> n2 ** )
.=. .not.
;


MACRO .u>.  ( um,u ) ( f ) 
( ** f= .T. if u > um  ** )
[ $39 $C3 ]     ( cmp  bx,ax )
;

MACRO .u<.  ( um,u ) ( f ) 
( ** f= .T. if u < um ** )
[ $39 $C3 ]     ( cmp  bx,ax )
;

: .>?<.   ( low,n ) ( f )
	  ( -,high )
	  ( - )
( ** f=.T. if low <= n <= high ** )
( SYNTAX:     5 to 9 .>?<.     ** )
[ $31 $D2 ]  (     xor dx,dx )
[ $39 $F8 ]  (     cmp ax,di )
[ $77 $05 ]  (     ja  ex    )
[ $39 $D8 ]  (     cmp ax,bx )
[ $72 $01 ]  (     jb  ex    )
[ $42 ]      (     inc dx    )
[ $D1 $DA ]  ( ex: rcr dx,1  )
;

MACRO .d0=.  ( d => d ) ( f )
	 ( => )
( ** f := .T. wenn d gleich Null ** )
[ $89 $DA ]  ( mov dx,bx )
[ $09 $C2 ]  ( or  dx,ax )
[ $F8 ]      ( clc       )
[ $75 $01 ]  ( jnz +1    )
[ $F9 ]      ( stc       )
;


( *** Funktionen *** )

MACRO abs  ( -,n => -,n' )
( ** n':= Absolutwert ** )
[ $3D 0 0 ]  ( cmp ax,#0 )
[ $7d 2   ]  ( jge +2    )
[ $F7 $D8 ]  ( minus ax  )
;

: d:abs ( d => d' )
( ** d' := Absolutwert ** )
[ $80 $C7 0 ]   ( add bh,#00 )
[ $79 $0A ]     ( jns ex     )
[ $F7 $D0 ]     ( not ax     )
[ $F7 $D3 ]     ( not bx     )
[ $05 $01 0 ]   ( add ax,1   )
[ $83 $D3 0 ]   ( adc bx,0   )
;


MACRO shr  ( i,n => ?,n')
       ( => )
( ** Shift n rechts um i Stellen ** )
[ $89 $CA ] ( mov dx,cx )
[ $89 $D9 ] ( mov cx,bx )
[ $D3 $E8 ] ( shr ax,cl )
[ $89 $D1 ] ( mov cx,dx )
;

MACRO shl  ( i,n => ?,n')
       ( => )
( ** Shift n links um i Stellen ** )
[ $89 $CA ] ( mov dx,cx )
[ $89 $D9 ] ( mov cx,x )
[ $D3 $E0 ] ( shl ax,cl )
[ $89 $D1 ] ( mov cx,dx )
;

: .d:>n.  ( d ) ( f )
          ( - )
          ( - )
( ** Doppelzahl in einfache mit Vorzeichen  ** )
( f:=.F. wenn Bereich einf. Zahl berschritten )
  .0<.  flag>               ( ax kleiner 0 ? )
  a<>b .-1=.  .>and. flag>  ( and bx = -1 ?  )
  .0=.  a<>b  flag>         ( oder bx = 0 ?  )
  .0<. .not. .>and.         ( and ax nicht negativ? ) 
  .>or. 
;
  
MACRO .d:>u.  ( d ) ( f )
          ( - )
          ( - )
( ** Doppelzahl in einfache ohne Vorzeichen ** )
( f:=.F. wenn Bereich einf. Zahl berschritten )
[ $83 $FB 0 ] ( cmp bx,#0000 )
[ $75 $01 ]   ( jnz 01       )
[ $F5 ]       ( cmc          )
;


( *** einfache Ein-/Ausgabe *** )

MACRO a>port  ( -,n )
   	      ( - )
	      ( adr )
( ** gib n an Portadresse aus ** )
[ $89 $F2 ] ( mov dx,si )
[ $EF ]     ( out dx,ax )
;

MACRO port>a  ( => -,n )
	      ( - )
	      ( adr )
( ** Hole Wort vom Port ** )
[ $89 $F2 ] ( mov dx,si )
[ $ED ]     ( in  ax,dx )
;

MACRO B/a>port   ( => -,c )
	         ( - )
	         ( adr )
( **  Gib Byte an portadr aus  ** )
[ $89 $D8 ] ( mov ax,bx )
[ $89 $F2 ] ( mov dx,si )
[ $EE ]     ( out dx,al )
;

MACRO B/port>a ( => -,c )
	       ( - )
	       ( adr )
( **  Hole Byte von portadr  ** )
[ $89 $F2 ]  ( mov dx,si  )
[ $EC ]      ( in al,dx   )
[ $B4 $00 ]  ( mov ah,#0  )
;


( ** Weitere Funktionen ** )

MACRO combine   ( h,l => -,n )
( ** Kombiniere 2 Bytes zu einem Wort ** )
( l := lower Byte, h := higher Byte in n )
[ $88 $DC ]  ( mov ah,bl )  
; 

MACRO split     ( -,n => h,l )
( **   Teile Wort in 2 Bytes     ** )
( l := lower Byte, h := higher Byte )
[ $88 $E3 ]  ( mov bl,ah )
[ $30 $FF ]  ( xor bh,bh )
[ $88 $FC ]  ( mov ah,bh )
;
  

( ** Bitsteuerung: ** )

: 2^n  ( -,n => -,2^n )
( **    2 hoch n    ** )
( **  0 <= n <= 15  ** )
[ $89 $CA ]   ( mov  dx,cx )
[ $89 $C1 ]   ( mov  cx,ax )
[ $B8 1 0 ]   ( mov  ax,1  )
[ $D3 $E0 ]   ( shl  ax,cl )
[ $89 $D1 ]   ( mov  cx,dx )
;

MACRO clrbit ( i,n => -,n' )
( **  Setze i. Bit  auf 0  ** )
( **    0 <= pos <= 15     ** )
a<>b 2^n not and 
;

MACRO setbit ( i,n => ?,n )
( **  Setze i. Bit auf 1  ** )
( **   0 <= pos <= 15     ** )
a<>b 2^n or 
;

MACRO getbit   ( i,n => -,1|0 )
( **  Hole Wert vom i. Bit ** )
( **     0 <= pos <= 15    ** )
[ $87 $D9 ]   ( xchg cx,bx    )
[ $D3 $E8 ]   ( shr  ax,cl    )
[ $87 $D9 ]   ( xchg cx,bx    )
[ $25 1 0 ]   ( and  ax,#0001 ) 
;

MACRO log2    ( 2^n --> n )
( **  Integer[log2[n]]  ** )
( **    0 <= n <= 15    ** )
  [ $BA $FF $FF ]  (     mov dx,#-1 )
  [ $42 ]          ( $1: inc dx     )
  [ $D1 $E8 ]      (     shr ax,1   )
  [ $75 $FB ]      (     jnz $1     )
  [ $89 $D0 ]      (     mov ax,dx  )
;


( ** Interruptsteuerung ** )
( ** MS-DOS und intr    ** )


MACRO dos  ( h,l => $21,hl )
( ** Interrupt $21 aufrufen ** )
( Funktion h, Unterfunktion l  )
  [ $88 $DC ]   ( mov ah,bl    )
  [ $B3 $21 ]   ( mov bl,#$21  )
;


: ?doserr  ( - )
( * Fehlerabfrage nach intr * )
  [ $72 1 ]       ( jc 1 : Fehler ? )
  [ $C3 ]         ( ret  : nein     )
  a>d             (      : ja       )
  [ $A1 D.AX ]    ( mov ax,d.ax     )
  doserr
;

MACRO ds>a    ( => -,dataseg )
  [ $8C $D8 ]    ( mov ax,ds )
;

MACRO cs>a    ( => -,codeseg )
  [ $8C $C8 ]    ( mov ax,cs )
;

: getint  ( i,- => ? )
	  ( => seg,offs )
	  ( - )
( ** i. Interruptvektor holen ** )
  [ $88 $D8 ] ( mov al,bl  )
  [ $B4 $35 ] ( mov ah,#35 )
  [ $CD $21 ] ( int 21     )
  [ $89 $DF ] ( mov di,bx  ) 
;

: setint  ( i,? )
	  ( seg,offs )
	  ( - )
( ** Setze Interrupt Nummer i ** )
  [ $1E ]     ( push ds    )
  [ $8C $C0 ] ( mov ax,es  )
  [ $8E $D8 ] ( mov ds,ax  )
  [ $89 $FA ] ( mov dx,di  )
  [ $88 $D8 ] ( mov al,bl  )
  [ $B4 $25 ] ( mov ah,#25 )
  [ $CD $21 ] ( int 21     )
  [ $1F ]     ( pop ds     )
;



( **  Zeichen-Ein- und Ausgabe ** )


proc read ( handle,count => handle,count' ) ( f )
	  ( => -,count )
	  ( adr )
( ** Zeichen aus Datei nach DS lesen  ** ) 
( ** Wenn Handlefehler, Doserr rufen  ** )
( **    f <> 0 wenn erfolgreich       ** )
( **  f=0 wenn weniger Zeichen (EOF)  ** )
( ** AX enthlt Zahl gelesene Zeichen ** )
( ** DI enthlt Zahl geforderter Zeichen )
  [ $89 $CF ]  ( mov  di,cx  )   ( cx retten )
  [ $89 $C1 ]  ( mov  cx,ax  )   ( count )
  [ $89 $F2 ]  ( mov  dx,si  )   ( Bufadr )
  [ $B4 $3F ]  ( mov  ah,#3F )   ( read )
  [ $CD $21 ]  ( int  21     )
  [ $87 $CF ]  ( xchg cx,di  )   ( cx restaur. )
  [ $72 $03 ]  ( jc   03     )   ( Fehler )
  [ $39 $F8 ]  ( cmp  ax,di  )   ( Flag setzen )
  [ $F5 $C3 ]  ( cmc ret     )
  $21 d= $3F00 , -1
  doserr
;


proc write ( handle,count => -,count' )
	   ( => -,count )
	   ( adr )
( **  Zeichen aus DS in Datei schreiben   ** ) 
( **   Wenn Handlefehler, Doserr rufen    ** )
( **  Wenn weniger Zeichen, Doserr rufen  ** )
( ** AX enthlt Zahl geschriebene Zeichen ** )
( ** DI enthlt Zahl geforderter Zeichen  ** )
  [ $89 $CF ]     ( mov  di,cx  ) ( cx retten )
  [ $89 $C1 ]     ( mov  cx,ax  ) ( count )
  [ $89 $F2 ]     ( mov  dx,si  ) ( Bufadr )
  [ $B4 $40 ]     ( mov  ah,#40 ) ( write )
  [ $CD $21 ]     ( int  21     )
  [ $87 $CF ]     ( xchg cx,di  ) ( cx restaur. )
  [ $72 $08 ]     ( jc   doser  ) ( Fehler )
  [ $39 $F8 ]     ( cmp  ax,di  ) 
  [ $75 $01 ]     ( jc   01     ) ( Platte voll )
  [ $C3 ]         ( ret         ) 
  $21 d= $4000 , -2 
  doserr
;

: >con  ( - )
( ** Ausgabe an CONSOLE ** )
( ** - umleitbar -      ** )
[ $c6 $06 stdout# 01 ] ( mov stdout#,#1 )
;

: >prn  ( - )
( ** Ausgabe an PRINTER  ** )
( ** - nicht umleitbar - ** )
[ $c6 $06 stdout# 04 ] ( mov stdout#,#4 )
;

: >aux  ( - )
( ** Ausgabe an RS232    ** )
( ** - nicht umleitbar - ** )
[ $c6 $06 stdout# 03 ] ( mov stdout#,#3 )
;

: >file   ( - )
( ** Ausgabe auf handle #fout umleiten ** )
[ $8a $16 fout# ]   ( mov dl,fout#   )
[ $88 $16 stdout# ] ( mov stdout#,dl )
;

: errdev  ( - )
( ** Ausgabe an Schirm          ** )
( ** - nicht umleitbar -        ** )
( ** laufendes Handle speichern ** )
[ $8a $16 stdout# ]    ( mov dl,stdout# )
[ $88 $16 hold# ]      ( mov hold#,dl   )
[ $c6 $06 stdout# 02 ] ( mov stdout#,#2  )
;

: -errdev  ( - )
( ** Ausgabe an voriges Handle ** )
[ $8a $16 hold# ]   ( mov dl,hold#   )
[ $88 $16 stdout# ] ( mov stdout#,dl )
;

proc (emit)  ( c,- )
	     ( - )
	     ( - ) 
( ** Zeichen c auf Schirm ausgeben ** )
 [ $50 ]     ( push ax    )
 [ $88 $DA ] ( mov dl,bl  )
 [ $B4 $02 ] ( mov ah,#02 )
 [ $CD $21 ] ( int 21     )
 [ $58 ]     ( pop ax     )
;

proc (pemit)  ( n- )
	      ( - )
	      ( - ) 
( ** Zeichen c auf PRN ausgeben ** )
 [ $50 ]     ( push ax    )
 [ $88 $DA ] ( mov dl,bl  )
 [ $B4 $05 ] ( mov ah,#05 )
 [ $CD $21 ] ( int 21     )
 [ $58 ]     ( pop ax     )
;

proc type      ( -,count )
	       ( - )              
	       ( adr => ? )
( ** Zeichenkette auf Schirm ausgeben ** ) 
  a>b
  FOR
    B/val>b adr+ emit 
  NEXT
;

MACRO count  ( => -,n )
  	     ( - )
	     ( adr => adr+1 )
( ** n := Stringlnge ** )
B/val>a ( Count-Byte holen )
adr+    ( Adresse erhhen  )
;


proc (stdemit)  ( hl,- )
		( - )
		( - )
( ** Zeichen l in laufendes Handle ausgeben ** )
adrpush apush word b!
stdout# val>b 
, 1  word write apop word val>b
adrpop
;

proc (stdtype)  ( -,count )
		( ? )
		( adr )
( ** String an Handle senden ** )
adr>d b>e stdout# val>b d>adr write e>b
;


: space  ( - )
( ** Leerzeichen ausgeben ** )
bpush
bl emit
bpop 
;


: spaces  ( n,- => ? )
( ** n Leerzeichen ausgeben ** )
 FOR space NEXT
;

: cr  ( - )
( ** CRLF ausgeben ** )
bpush
$A emit $D emit
bpop 
;

proc (key)  ( => -,c )
	    ( - )
	    ( - )
( ** Taste  holen ** )
( Sondertasten 256 erhht  )             
  [ $B4 $01 ] ( mov ah,#01 )
  [ $CD $21 ] ( int 21     )
  [ $3C $00 ] ( cmp al,#00 )
  [ $74 $05 ] ( jz  05     )
  [ $B4 $00 ] ( mov ah,#00 )
  [ $C3 ]     ( ret        )
  [ $CD $21 ] ( int 21     )
;

proc (stdkey)  ( => -,c )
               ( - )
               ( - )
( ** Tastatureingabe ** )
( ** Sondertasten 256 erhht ** )
bpush
0 D.ax b!
$16 intr
d.ax val>a
bpop  
[ $3C $00 ]      ( cmp al,#0   )
[ $74 $03 ]      ( jz ew       )
[ $30 $E4 ]      ( xor ah,ah   )
[ $C3 ]          ( ret         )
[ $86 $C4 ]      ( xchg al,ah  )
[ $05 $FF $00 ]  ( add ax,#256 )
;

proc .?key.  ( => -,? ) ( f )
             ( - )
             ( - )
( ** f:=1 : Zeichen vorhanden ** )
[ $B4 $0B ] ( mov ah,#$B )
[ $CD $21 ] ( int 21h    )
[ $3C $01 ] ( cmp al,1   ) 
;

: wait     ( ? )
           ( ? )
           ( ? )
( **  Warte auf Taste mit Nachricht  ** )
errdev
."  -Mit jeder Taste weiter..!" 
key -errdev
;

proc expect    ( count,- => ? )
               ( - )
	       ( adr )
( ** String von Keybord erwarten ** )
( ** und bei adr ablegen         ** )
b>a
adrpush       ( adr retten )
adr-          ( Eingabelnge setzen )
1+            ( fr CR )
[ $8A $1C ]   ( mov bl,[si] : max holen )
[ $43 ]       ( inc bx      )
[ $38 $C3 ]   ( cmp bl,al   )
[ $73 $02 ]   ( jnb 02      )
[ $88 $D8 ]   ( mov al,bl   )
[ $88 $04 ]   ( mov [si],al )
[ $89 $F2 ]   ( mov dx,si   )
[ $B4 $0A ]   ( mov ah,#10  )
[ $CD $21 ]   ( int 21h     )
[ $4B ]       ( dec bx      )
[ $88 $1C ]   ( mov [si],bl : altes max setzen )
adr+ 
[ $8A $04 ]   ( mov al,[si]  : count holen )
[ $30 $E4 ]   ( xor ah,ah )
adrn+ adr+
[ $C6 4 0 ]   ( mov b/[si],#0 : terminator )
adrpop
;

: >default  ( - )
( ** Ausgabe an Console ** )
     [ $c6 $06 stdout# 01 ] ( mov stdout#,#1 )  
     make emit   (emit)
     make key    (key)
     make ?key   .?key.
;


( ** Zahlenausgabe ** )

: nib.h  ( -,n )
	 ( - )
	 ( - )
( ** Gib unteres Nibble als Hex aus  ** )
( Trick conversion aus DOS-UNDOCUMENTED )
( Schulman: Addison-Wesley 1991         )              
[ $24 $0F ]  ( and al,#0F )
[ $04 $90 ]  ( add al,#90 )
[ $27 ]      ( daa        )
[ $14 $40 ]  ( adc al,#40 )
[ $27 ]      ( daa        )
a<>b emit a>b
;

: byte.h  ( -,n )
	  ( - )
	  ( - )
( ** Gib unteres Byte in Hex aus ** )
apush
u16/  nib.h
apop apush
nib.h 
apop
;

: u.h  ( -,u )
       ( - )
       ( - )
( ** AX als Hexzahl ausgeben ** )
apush
[ $88 $e0 ]  ( mov al,ah )
byte.h
apop
byte.h
;

: (.d)  ( -,n )
        ( - )
        ( n )
( ** AX decimal ausgeben ** )
bpush
dpush
[ $51 ]         ( push cx      )
D= $0A
[ $31 $c9 ]     ( xor  cx,cx   )
BEGIN
[ $29 $d2 ]     ( sub  dx,dx   )
[ $f7 $f7 ]     ( div  di      )
[ $83 $c2 $30 ] ( add  di,#'0' )
[ $52 ]         ( push dx      )
[ $41 ]         ( inc  cx      )
.0=.
UNTIL
b>a
( $1: )
bpop
emit
[ $e2 $f8 ]     ( loop $1 )
[ $59 ]         ( pop cx  )
dpop bpop adr>a
;

: u.d  ( -,u )
       ( - )
       ( => u )
( ** AX ohne Vorzeichen decimal ausgeben ** )
bpush a>b a>adr
.0=.
IF '0' emit bpop exit ENDIF
bpop
(.d)
;

: .d  ( -,n )
      ( - )
      ( => n )
( ** AX mit Vorzeichen decimal ausgeben ** )
bpush a>b a>adr
.0=.
IF bl emit '0' emit bpop exit ENDIF
.0<. if '-' emit neg else bl emit endif
bpop
(.d)
;

(long)
: decin# ( => -,n )
         ( -,? )
         ( - )
( **  Dezimalzahl eingeben  ** )
( ** Kein Check auf berlauf** )
D= 0
byte B/off
BEGIN
key 13 .=. .not. 
WHILE
case
   45  of byte B/on ;;          ( minus char )
    8  of bl emit bs emit       ( backspace  )
          d>a 10 / a>d ;;
  '0' <of 7 emit bs emit bl emit bs emit ;;
  '9' >of 7 emit bs emit bl emit bs emit ;;
else  '0' - a>b d>a 10* + a>d   ( Ziffer )
ENDCASE
REPEAT
d>a
byte B/@if neg endif
; 
(short)

: .hexdigit.  ( -,c => -,n ) ( f )
	      ( - )
	      ( - )
( ** Convert Hex Digit in Zahl   ** )
( c := Digit, n := Zahl             )
( f:=.T. wenn c Hexdigit,klein|gro )
[ $2C $30 ]  ( sub al#,30 )
[ $72 $10 ]  ( jc ex      )
[ $3C $0A ]  ( cmp al,#0A )
[ $F5 ]      ( cmc        )
[ $73 $0B ]  ( jnc ex     )
[ $24 $5F ]  ( and al,#5F )
[ $2C $07 ]  ( sub al,#07 )
[ $3C $0A ]  ( cmp al,#0A )
[ $72 $03 ]  ( jc ex      )
[ $3C $10 ]  ( cmp al,#10 )
[ $F5 ]      ( cmc        )
[ $F5 ]      ( ex: cmc    )
;

(long)
: hexin# ( => -,n )
         ( -,? )
         ( - )
( **    Hexzahl eingeben     ** )
( ** Kein Check auf berlauf ** )
D= 0
BEGIN
key 13 .=. .not. 
WHILE
case
    8  of bl emit bs emit       ( backspace  )
          d>a u16/ a>d ;;
else  .hexdigit.
       if  a>b d>a 16* + a>d    ( Ziffer )
       else 7 emit bs emit bl emit bs emit endif
ENDCASE
REPEAT
d>a
; 
(short)


( *** verschiedene Funktionen *** )

: min  ( n1,n2 => ?,min )
( ** Minimum der Zahlen ** )
  .>.
  if a<>b endif
;

: umin  ( u1,u2 => ?,min )
( ** Minimum der vorzeichenlosen Zahlen** )
  .u>.
  if a<>b endif
;


: max  ( n1,n2 --> ?,max )
( ** Maximum der Zahlen ** )
  .<.
  if a<>b endif
;


: umax  ( u1,u2 => ?,max )
( ** Maximum der vorzeichenlosen Zahlen ** )
  .u<.
  if a<>b endif
;




( *** Initialisierung und Fehlerbehandlung *** )

MACRO v-restor  ( => -,? )
                ( - )
                ( - )
[ $B0 $1A ]    ( mov al,#1A )
[ $B4 $00 ]    ( mov ah,#00 )
[ $CD $10 ]    ( int 10     )
;

MACRO ds! ( - )
( ** Datensegment restaurieren ** )
;

MACRO ss! ( - )
( ** Stacksegment restaurieren ** )
[ $FA ]	              ( cli )
[ $2E $8E $16 $010E ] ( mov ss, cs:010E )
[ $FB ]		      ( sti )
;

: exno!  ( -,c => )
         ( - )
         ( - ) 
( ** c wird an Vaterprogramm gegeben ** )
  [ $a2 $18 0 ] ( mov 0018,al )
;

: halt  ( -,n => )
( ** Programmabbruch ** )
( ** n = 0 mit cls   ** )
 .0=. if v-restor endif
 exitcode
 [ $FF $E6 ]    ( jmp si )
;

 
: halt"  ( -,n => )
  ( Programmabbruch mit Meldung )
  ( n = 0 mit cls               )
  errdev
  cr ." Programmabbruch" cr wait
  halt
;

( ** Fehlermeldungen MSDOS ** )

(long)
: dosmsg  ( i,n => ? ) ( f )
	  ( -,hl )
	  ( ? )
( ** DOS Fehlermeldungen ** )
( i := Intr# h := Funktion# l := Unterfkn )
apush ." Int#" b>a byte.h  ."  Fkt#" d>a byte.h
."  Ufkt#" d>a u2/ u2/ u2/ byte.h space apop 
     case
     -2 of  ." : Datentrger voll........" ;;
     -1 of  ." : Dateiende erreicht(EOF)." ;;
     02 of  ." : Datei nicht gefunden...." ;;
     03 of  ." : Pfad nicht gefunden....." ;;
     04 of  ." : Zuviele Dateien geffnet" ;;
     05 of  ." : Zugriff verweigert......" ;;
     06 of  ." : Ungltige Dateinummer..." ;;
     11 of  ." : Ungltiges Format......." ;;
     12 of  ." : Ungltiger Zugriffscode." ;;
     13 of  ." : Ungltige Daten........." ;;
     15 of  ." : Ungltiges Laufwerk....." ;;
     17 of  ." : Nicht das gleiche Gert." ;;
     18 of  ." : Keine weiteren Dateien.." ;;
    $50 of  ." : Datei bereits vorhanden." ;;
     else apush  ." : Fehler " apop byte.h  
     endcase .F.
;
(short)


proc (doserrex)  ( i,n => ? )
		 ( -,hl => ? )
		 ( ? )
( ** Behandlung von Laufzeit-Fehlern ** )
( ** mit Programmabbruch             ** )
( ** n := DOS-Fehlernummer           ** )
( i := Intr# h := Fktn# l := Unterfkn#  )
  apush make emit (emit)
  errdev 7 emit
  apop dosmsg  
  0 halt"
;

proc (int0ex)  ( - )
( ** Division durch Null ** )
( Programmabbruch     )
  ds!
  errdev
  ." Division durch Null"  
  129 halt"
;

proc (breakex) ( - )
( ** Break-Handler fr ^C mit EXIT ** )
  ds!
  errdev
  cr ." ** USER BREAK" cr
  128 halt"
;

proc (break)  ( - )
( ** Setze Flag bei ds:$19 ** )
[ $C6 6 $19 0 $FF ] ( mov 0019,#-1 )
[ $CF ]             ( iret        )
;

: break?  ( - ) ( f )
( ** f := .T. bei breaktaste ** )
[ $D0 6 $19 0 ]    ( rol 0019,1 )
[ $C6 6 5 $19 0 ]  ( mov 0019,0 )
;

: setbreak ( - )
( ** Leite Break-routine ber Flag ** )
   make break (break)
;


MACRO nxparas   ( => -,n )
( ** n := Anzahl Paragraphen des Gesamtprogramms ** )
[ $A1 $22 0 ] ( mov ax,0022  : heapseg )
[ $8C $CA ]   ( mov dx,cs    : codeseg )
[ $29 $D0 ]   ( sub ax,dx    : minus   )
;

: memrelease  ( => -,? )
	      ( - )
	      ( ? )
( ** Gib Memory oberhalb von SP0 an DOS zurck ** )
  nxparas D.bx ! cs>a D.es !
  $4A dos intr ?doserr  ( Segmentgre ndern )
;

: iret ( - )
( register restore, Interrupt Return )
( ausser Flagregister )
[ $8C $CA ]             ( mov dx,cs )
[ $8E $DA ]             ( mov ds,dx )
[ $2E $A1 $10 $01 ]     ( mov ax,CS:[$110] ) 
[ $2E $8B $0E $12 $01 ] ( mov cx,CS:[$112] )
[ $2E $8B $16 $14 $01 ] ( mov dx,CS:[$114] ) 
[ $2E $8B $1E $16 $01 ] ( mov bx,CS:[$116] )
[ $2E $8B $2E $1A $01 ] ( mov bp,CS:[$11A] ) 
[ $2E $8B $36 $1C $01 ] ( mov si,CS:[$11C] )
[ $2E $8B $3E $1E $01 ] ( mov di,CS:[$11E] ) 
[ $2E $8E $06 $24 $01 ] ( mov es,CS:[$124] )
[ $FA ]                 ( cli )
[ $2E $8B $26 $18 $01 ] ( mov sp,CS:[$118] ) 
[ $2E $8E $16 $26 $01 ] ( mov ss,CS:[$126] )
[ $2E $8E $1E $22 $01 ] ( mov ds,CS:[$122] ) 
[ $FB ]                 ( sti )
[ $CF ]                 ( iret ) 
;

: resident  ( - )
( ** Exit and stay resident ** )
nxparas
[ $89 $C2 ]      ( mov dx,ax   )  
[ $B8 $00 $31 ]  ( mov ax,3100 )
[ $CD $21 ]      ( int 21      )
;


: initint  ( ? )
           ( ? )
	   ( ? ) 
( ** Setze Interrupt-Vectoren ** )
  make doserr (doserrex)
  make break (breakex)
  make int0 (int0ex)  
  $23 cs>e      ( Segment )
  d= break    ( Break-vec )
  setint 
  0 cs>e        ( Segment )
  d= int0     ( Int0-vec  )
  setint
;


: init  ( ? )
        ( ? )
        ( ? )
( ** Initialisieren ** )
  >default initint 
;

: clrscr ( ?,- )
         ( - )
         ( ? )
( Bildschirm mittels ANSI-Sequenz lschen )
  27 emit '[' emit '2' emit 'J' emit
;

dictionary
memsizes( 8 0 )
: main
  init
  ." NAXOS V2.02 Kern (C) 1992 by K.Peper & A.Zissis " cr
;