(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
        *           simple and double ARITHMETICS                  *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B 25.08.93                   *
        *                                                          *
        ************************************************************
)

	( *** simple arithmetic *** )


		  MACRO + 
	( ****  add BX to AX  ***** )
	( ************************* )
	( arg: AX = n1              )
	(      BX = n2              )
	( out: AX:= n1+n2           )
	( chg: AX                   )
	( ************************* )
	[ $01 $D8 ]    ( add  ax,bx )
	;


		  MACRO - 
	( ***  reduce AX by BX  *** )
	( ************************* )
	( arg: AX = n1              )
	(      BX = n2              )
	( out: AX:= n1-n2           )
	( chg: AX                   )
	( ************************* )
	[ $29 $D8 ]    ( sub  ax,bx )
	;


		 MACRO 2* 
	( ** multiplication by 2 ** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= n*2             )
	( chg: AX                   )
	( ************************* )
	[ $01 $C0 ]    ( add  ax,ax )
	;


		 : 10* 
	( *  multiplication by 10 * )
	( ************************* )
	( arg: AX = n               )
	( out: AX:= n*10            )
	( chg: AX                   )
	( ************************* )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $89 $C2 ]    ( mov  dx,ax )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $01 $D0 ]    ( add  ax,dx )
	;

		MACRO 16* 
	( *  multiplication by 16 * )
	( ************************* )
	( arg: AX = n               )
	( out: AX:= n*16            )
	( chg: AX                   )
	( ************************* )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	;

		  MACRO / 
	( divide AX by BX with rest )
	( ***  signed division  *** )
	( ************************* )
	( arg: AX = n               )
	(      BX = n1              )
	( out: AX:= n/n1            )
	(      BX:= rest            )
	( chg: AX                   )
	( ************************* )
	[ $99 ]        ( cwd        )
	[ $F7 $FB ]    ( idiv bx    )
	[ $89 $D3 ]    ( mov  bx,dx )
	;

		  MACRO u/ 
	( divide AX by BX with rest )
	( ***  unsigned division ** )
	( ************************* )
	( arg: AX = n               )
	(      BX = n1              )
	( out: AX:= n/n1            )
	(      BX:= rest            )
	( chg: AX                   )
	( ************************* )
	[ $99 ]        ( cwd        )
	[ $F7 $F3 ]    ( div bx    )
	[ $89 $D3 ]    ( mov  bx,dx )
	;


		 MACRO u/2 
	( * unsigned division by 2  )
	( ************************* )
	( arg: AX = i               )
	( out: AX:= i/2             )
	( chg: AX                   )
	( ************************* )
	[ $D1 $E8 ]     ( shr  ax,1 )
	;


		 MACRO u/16 
	(  unsigned division by 16  )
	( ************************* )
	( arg: AX = i               )
	( out: AX:= i/16            )
	( chg: AX                   )
	( ************************* )
	[ $D1 $E8 ]     ( shr  ax,1 )
	[ $D1 $E8 ]     ( shr  ax,1 )
	[ $D1 $E8 ]     ( shr  ax,1 )
	[ $D1 $E8 ]     ( shr  ax,1 )
	;


	( ** mixed arithmetic ** )
	
		 MACRO * 
	( **  multiply AX by BX  ** )
	( * signed multiplication * )
	( ************************* )
	( arg: AX = n1              )
	(      BX = n2              )
	( out: BX:AX:= n1*n2        )
	( chg: AX,BX                )
	( ************************* )
	[ $F7 $EB ]    ( imul bx    )
	[ $89 $D3 ]    ( mov  bx,dx )
	;

		 MACRO u* 
	( **  multiply AX by BX  ** )
	( * unsigned multiplicat. * )
	( ************************* )
	( arg: AX = n1              )
	(      BX = n2              )
	( out: BX:AX:= n1*n2        )
	( chg: AX,BX                )
	( ************************* )
	[ $F7 $E3 ]    ( mul bx     )
	[ $89 $D3 ]    ( mov  bx,dx )
	;

		 MACRO a*b/d 
	(   signed:  AX * BX / DI   )
	( ************************* )
	( arg: AX = n1              )
	(      BX = n2              )
	(      DI = n3              )
	( out: AX:= n1*n2/n3        )
	(      DI:= rest            )
	( chg: AX,BX                )
	( ************************* )      
	[ $F7 $EB ]    ( imul bx    )
	[ $F7 $FF ]    ( idiv di    )
	[ $89 $D7 ]    ( mov  di,dx )
	;




		 MACRO a+adr 
	( ****  add SI to AX  ***** )
	( ************************* )
	( arg: AX = value n         )
	(      SI = value adr       )
	( out: AX:= n+adr           )
	( chg: AX                   )
	( ************************* )
	[ $01 $F0 ]    ( add  ax,si )
	;

		 MACRO 1+ 
	( ****  increment AX  ***** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= n+1             )
	( chg: AX                   )
	( ************************* )
	[ $40 ]           ( inc  ax )
	;

		MACRO 2+ 
	( *** increment AX by 2 *** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= n+2             )
	( chg: AX                   )
	( ************************* )
	[ $40 $40 ] ( inc ax inc ax )
	;

		 MACRO b+ 
	( ****  Increment BX  ***** )
	( ************************* )
	( arg: BX = value n         )
	( out: BX:= n+1             )
	( chg: BX                   )
	( ************************* )
	[ $43 ]           ( inc  bx )
	;

		 MACRO i+ 
	( ****  Increment CX  ***** )
	( ************************* )
	( arg: -                    )
	( out: -                    )
	( chg: -                    )
	( ************************* )
	[ $41 ]           ( inc  cx )
	;
		 MACRO d+ 
	( ****  increment DI  ***** )
	( ************************* )
	( arg: DI = value n         )
	( out: DI:= n+1             )
	( chg: DI                   )
	( ************************* )
	[ $47 ]           ( inc  di )
	;


		 MACRO 1- 
	( ****  decrement AX  ***** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= n-1             )
	( chg: AX                   )
	( ************************* )
	[ $48 ]           ( dec  ax )
	;

		 MACRO 2- 
	( **  decrement AX by 2  ** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= n-2             )
	( chg: AX                   )
	( ************************* )
	[ $48 $48 ] ( dec ax dec ax )
	;

		  MACRO b- 
	( ****  decrement BX  ***** )
	( ************************* )
	( arg: BX = value n         )
	( out: BX:= n-1             )
	( chg: BX                   )
	( ************************* )
	[ $4B ]           ( dec  bx )
	;

		  MACRO i- 
	( ****  decrement CX  ***** )
	( ************************* )
	( arg: CX = value n         )
	( out: CX:= n-1             )
	( chg: CX                   )
	( ************************* )
	[ $49 ]           ( dec  bx )
	;

		  MACRO d- 
	( ****  decrement DI  ***** )
	( ************************* )
	( arg: DI = value n         )
	( out: DI:= n-1             )
	( chg: DI                   )
	( ************************* )
	[ $4F ]           ( dec  di )
	;

	
	( ** double arithmetic ** )


		 : ba/d 
	( unsigned division BX:AX/DI )
	( ************************* )
	( arg: BX:AX = dividend d   )
	(      DI = divisor i       )
	( out: BX:AX:= d/i          )
	(      DI:= rest            )
	( chg: AX,BX,DI             )
	( ************************* )
	[ $83 $FF $01 ] ( cmp di,01 )
	IF- NE
	[ $93 ]      ( xchg ax,bx   ) 
	[ $31 $D2 ]  ( xor  dx,dx   ) 
	[ $F7 $F7 ]  ( div  di      ) ( (0:high)/i )
	[ $93 ]      ( xchg ax,bx   )
	[ $F7 $F7 ]  ( div  di      ) ( (rest:low)/i )
	[ $89 $D7 ]  ( mov  di,dx   ) ( rest )
	ENDIF
	;


		  : ba*d 
	(  unsigned multiply d * i  )
	( ** overflow may happen ** )
	( ************************* )
	( arg: BX:AX = ud           )
	(      DI = i               )
	( out: BX:AX:= d*i          )
	( chg: AX,BX                )
	( ************************* ) 
	[ $51 ]       ( push cx     )
	[ $F7 $E7 ]   ( mul  di     ) ( low*u )
	[ $89 $D1 ]   ( mov  cx,dx  ) ( bertrag retten )
	[ $93 ]       ( xchg ax,bx  ) 
	[ $F7 $E7 ]   ( mul  di     ) ( high*u )
	[ $93 ]       ( xchg ax,bx  )
	[ $01 $CB ]   ( add  bx,cx  ) ( +bertrag )
	[ $59 ]       ( pop  cx     ) 
	;
		  : ba*ed 
	(  unsigned multiply ud * ui )
	( ** overflow may happen ** )
	( ************************* )
	( arg: BX:AX = ud           )
	(      es:DI = ui           )
	( out: BX:AX:= d*i          )
	( chg: All regs changed     )
	( ************************* ) 
 [ $89 $DA           ( MOV    DX,BX )
   $8C $C3           ( MOV    BX,ES )
   $89 $F9           ( MOV    CX,DI )
   $8B $F0           ( MOV    SI,AX )
   $8B $FA           ( MOV    DI,DX )
   $F7 $E1           ( MUL    CX )
   $50               ( PUSH   AX )
   $52               ( PUSH   DX )
   $8B $C6           ( MOV    AX,SI )
   $F7 $E3           ( MUL    BX )
   $8B $D8           ( MOV    BX,AX )
   $8B $C7           ( MOV    AX,DI )
   $F7 $E1           ( MUL    CX )
   $8B $C8           ( MOV    CX,AX )
   $5A               ( POP    DX )
   $58               ( POP    AX )
   $03 $D3           ( ADD    DX,BX )
   $03 $D1           ( ADD    DX,CX )
   $89 $D3 ]	     ( MOV    BX,DX )		
  ;

		 : ba*10 
	( ****  double * 10  ****** )
	( ************************* )
	( arg: BX:AX = d            )
	( out: BX:AX:= d*10         )
	( chg: AX,BX                )
	( ************************* ) 
	[ $51 ]        ( push cx    )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $D1 $D3 ]    ( rcl  bx,1  )
	[ $89 $C1 ]    ( mov  cx,ax )
	[ $89 $DA ]    ( mov  dx,bx )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $D1 $D3 ]    ( rcl  bx,1  )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $D1 $D3 ]    ( rcl  bx,1  )
	[ $01 $C8 ]    ( add  ax,cx )
	[ $11 $D3 ]    ( adc  bx,dx )
	[ $59 ]        ( pop  cx    )
	;

		 : ba*16 
	( ****  double * 16  ****** )
	( ************************* )
	( arg: BX:AX = d            )
	( out: BX:AX:= d*16         )
	( chg: AX,BX                )
	( ************************* ) 
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $D3 ]     ( rcl  bx,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $D3 ]     ( rcl  bx,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $D3 ]     ( rcl  bx,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $D3 ]     ( rcl  bx,1 )
	;


( *** Flagoperators *** )

	    MACRO .T. 
	( ** Flag true ** )
	( *************** )
	( arg: -          )
	( out: CF:=1      )
	( chg: CF         )
	( *************** )
	[ $F9 ]     ( stc )
	;

	    MACRO .F. 
	( ** Flag false ** )
	( **************** )
	( arg: -           )
	( out: CF:=0       )
	( chg: CF          )
	( **************** )
	[ $F8 ]      ( clc )
	;

	    MACRO .not. 
	( Flag complement )
	( *************** )
	( arg: CF         )
	( out: CF:=CF-    )
	( chg: CF         )
	( *************** )
	[ $F5 ]     ( cmc )
	;

	    MACRO flag> 
	( flag to con_stack )
	( ***************** )
	( arg: CF           )
	( out: -            )
	( chg: -            )
	( ***************** )
	[ $D1 $16 $16 0 ]  ( rcl [16],1 )
	;

	      MACRO .odd. 
	( *  CF:=1 if AX odd * )
	( ******************** )
	( arg: AX = value n    )
	( out: CF:=1 if n=odd  )
	(      CF:=0 if n=even )
	( chg: CF              )
	( ******************** )
	[ $D1 $D8 ] ( rcr ax,1 )
	[ $D1 $D0 ] ( rcl ax,1 )
	;

	MACRO .even. 
	( * CF:=1 if AX even * )
	( ******************** )
	( arg: AX = value n    )
	( out: CF:=1 if n=even )
	(      CF:=0 if n=odd  )
	( chg: CF              )
	( ******************** )
	[ $D1 $D8 ] ( rcr ax,1 )
	[ $D1 $D0 ] ( rcl ax,1 )
	[ $F5 ]     ( cmc      )
	; 

	       MACRO .0=. 
	( ** CF:=1 if AX zero ** )
	( ********************** )
	( arg: AX = value n      )
	( out: CF:=1 if n=zero   )
	( chg: CF                )
	( ********************** )
	[ $3D 0 0 ] ( test ax,ax )
	IF- Z
	  [ $F5 ]   ( cmc        )
	ENDIF
	;

	MACRO .FALSE=. .0=. ;

	       MACRO .1=.
	( ********************* )
	( arg: AX= value n      )
	( out: CF:=1 if n=1     )
	(      CF:=0 if n<>1    )
	( chg: CF               )
	( ********************* )
	[ $3D 1 0 ] ( cmp  ax,1 )
	[ $F8 ]     ( clc       )
	IF- Z
	    [ $F5 ] ( cmc       )
	ENDIF
	;

	MACRO .TRUE=. .1=. ;
	
	       MACRO .-1=. 
	( *  CF:=1 if AX =-1 * )
	( ******************** )
	( arg: AX = value n    )
	( out: CF:=1 if n=-1   )
	( chg: CF              )
	( ******************** )
	[ $3D $FF $FF ] ( cmp ax,-1  )
	[ $F8 ]         ( clc        )
	[ $75 1 ]       ( jnz  +1    )
	[ $F5 ]         ( cmc        )
	;


	     MACRO .0<. 
	( **  CF:=1 if AX neg ** )
	( ********************** )
	( arg: AX = value n      )
	( out: CF:=1 if n=neg    )
	( chg: CF                )
	( ********************** )
	[ $3D 0 0 ] ( cmp  ax,#0 )
	[ $F8 ]     ( clc        )
	[ $7D 1 ]   ( jge  +1    )
	[ $F5 ]     ( cmc        )
	;
	
	macro .neg. .0<. ;


	      MACRO .0>. 
	( ** CF:=1 if AX odd ** )
	( ********************* )
	( arg: AX = value n     )
	( out: CF:=1 if n>0     )
	( chg: CF               )
	( ********************* )
	[ $3D 0 0 ] ( cmp  ax,0 )
	[ $F8 ]     ( clc       )
	[ $7E 1 ]   ( jle  +1   )
	[ $F5 ]     ( cmc       )
	;

  
	      MACRO .0<>. 
	(  CF:=1 if AX not zero  )
	( ********************** )
	( arg: AX = value n      )
	( out: CF:=1 if n<>0     )
	( chg: CF                )
	( ********************** )
	.0=. .not. ( cmc )
	;

		MACRO .=. 
	( **  CF:=1 if AX=BX  ** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1=n2    )
	( chg: CF                )
	( ********************** )
	[ $39 $D8 ] ( cmp  ax,bx )
	[ $F8 ]     ( clc        )
	[ $75 1 ]   ( jnz  +1    )
	[ $F5 ]     ( cmc        )
	;

		MACRO .>.
	( *** CF:=1 if AX>BX *** )
	( *** signed compare *** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1>n2    )
	( chg: CF                )
	( ********************** )
	[ $39 $C3 ]  ( cmp bx,ax )
	[ $F8 ]      ( clc       )
	[ $7D $01 ]  ( jge +1    )
	[ $F5 ]      ( cmc       )
	;


		MACRO .<. 
	( *** CF:=1 if AX<BX *** )
	( *** signed compare *** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1<n2    )
	( chg: CF                )
	( ********************** )
	[ $39 $C3 ]  ( cmp bx,ax )
	[ $F8 ]      ( clc       )
	[ $7E $01 ]  ( jle +1    )
	[ $F5 ]      ( cmc       ) 
	;

		MACRO .<>. 
	( *** CF:=1 if AX<>BX ** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1<>n2   )
	( chg: CF                )
	( ********************** )
	.=. .not.
	;


		MACRO .u>. 
	( *** CF:=1 if AX>BX *** )
	( ** unsigned compare ** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1>n2    )
	( chg: CF                )
	( ********************** )
	[ $39 $C3 ] ( cmp  bx,ax )
	;

	       MACRO .u<. 
	( *** CF:=1 if AX<BX *** )
	( ** unsigned compare ** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1<n2    )
	( chg: CF                )
	( ********************** )
	[ $39 $D8 ] ( cmp  ax,bx )
	;


	      MACRO .ba0=. 
	( ** CF:=1 if BX:AX=0 ** )
	( ********************** )
	( arg: BX:AX = double d  )
	( out: CF:=1 if d=0      )
	( chg: CF                )
	( ********************** )
	[ $89 $DA ]  ( mov dx,bx )
	[ $09 $C2 ]  ( or  dx,ax )
	[ $F8 ]      ( clc       )
	[ $75 $01 ]  ( jnz +1    )
	[ $F9 ]      ( stc       )
	;





	( *** Flag- und Vergleichs- operatoren *** )

		  : .>and.
	( *** 'AND' two carryflags *** ) 
	(  only possible after 'flag>' )
	( pops one flag from con_stack )
	( **************************** )
	( arg: CF                      )
	( out: CF:= CF AND con_stack   )
	( chg: CF                      )
	( **************************** )
	[ $D0 $D6 ]       ( rcl dh,1   )
	[ $D1 $0E $16 0 ] ( ror [16],1 )
	[ $D0 $D2 ]       ( rcl dl,1   )
	[ $20 $F2 ]       ( and dl,dh  )
	[ $D0 $CA ]       ( ror dl,1   )
	;

		   : .>or.
	( *** 'OR' two carryflags **** ) 
	(  only possible after 'flag>' )
	( pops one flag from con_stack )        
	( **************************** )
	( arg: CF                      )
	( out: CF:= CF OR con_stack    )
	( chg: CF                      )
	( **************************** )
	[ $D0 $D6 ]       ( rcl dh,1   )
	[ $D1 $0E $16 0 ] ( ror [16],1 )
	[ $D0 $D2 ]       ( rcl dl,1   )
	[ $08 $F2 ]       ( or  dl,dh  )
	[ $D0 $CA ]       ( ror dl,1   )
	;

		   : .>xor. 
	( *** 'XOR' two carryflags *** ) 
	( only possible after 'flag>'  )
	( pops one flag from con_stack )
	( **************************** )
	( arg: CF                      )
	( out: CF:= CF XOR con-stack   )
	( chg: CF                      )
	( **************************** )
	[ $D0 $D6 ]       ( rcl dh,1   )
	[ $D1 $0E $16 0 ] ( ror [16],1 )
	[ $D0 $D2 ]       ( rcl dl,1   )
	[ $30 $F2 ]       ( xor  dl,dh )
	[ $D0 $CA ]       ( ror dl,1   )
	;


		   : .>?<. 
	( check wether n is in limits )
	( SYNTAX:     5 to 9 .>?<.    )
	( *************************** )
	( arg: AX = value n           )
	(      BX = lower limit       )
	(      DI = upper limit       )
	( out: CF:= 0 if lo>=n>=hi    )
	( chg: CF                     )
	( *************************** )
	[ $31 $D2 ]       ( xor dx,dx )
	[ $39 $F8 ]       ( cmp ax,di )
	IF- NA
	   [ $39 $D8 ]    ( cmp ax,bx )
	   IF- NB
	     [ $42 ]      ( inc dx    )
	   ENDIF
	ENDIF
	[ $D1 $DA ]       ( rcr dx,1  )
	;


	( *** Funktionen *** )

		 : d/abs 
	( * absolut value of double  )
	( ************************** )
	( arg: BX:AX = double d      )
	( out: BX:AX:= abs(d)        )
	( chg: BX,AX                 )
	( ************************** )
	[ $80 $C7 0 ]   ( add bh,#00 )
	IF- S
	[ $F7 $D0 ]     ( not ax     )
	[ $F7 $D3 ]     ( not bx     )
	[ $05 $01 0 ]   ( add ax,1   )
	[ $83 $D3 0 ]   ( adc bx,0   )
	ENDIF
	;


		  : .ba>a. 
	( converts signed double to word )
	( ****************************** )
	( arg: BX:AX = double d          )
	( out: CF:= 0 if no error        )
	( chg: CF                        )
	( ****************************** )
	.neg.  flag> xab    ( ax<0 ?      )
	.-1=. .>and. flag> ( and bx=-1 ? )
	.0=.  xab  flag>   ( or bx=0 ?   )
	.neg. .not. .>and.  ( and ax>=0 ? ) 
	.>or. 
	;
  
		MACRO .uba>a. 
	( converts unsigned double to word )
	( ******************************** )
	( arg: BX:AX = double d            )
	( out: CF:= 0 if no error          )
	( chg: CF                          )
	( ******************************** )
	[ $83 $FB 0 ]       ( cmp bx,#0000 )
	.T.
	IF- Z
	    [ $F5 ]         ( cmc          )
	ENDIF
	;

		 MACRO n>d 
	(  convert word to double   )
	( ************************* )
	( arg: AX = n               )
	( out: BX:AX:= d            )
	( chg: BX                   )
	( ************************* ) 
	[ $99 ]     ( cwd  )
	[ $89 $D3 ] ( mov bx,dx )
	;


		: d/neg 
	( * change sign of double * )
	( ************************* )
	( arg: BX:AX =  d           )
	( out: BX:AX:= -d           )
	( chg: AX,BX                )
	( ************************* ) 
	[ $F7 $D0 ]     ( not  ax   )
	[ $F7 $D3 ]     ( not  bx   )
	[ $05 1 0 ]     ( add  ax,1 )
	[ $83 $D3 0 ]   ( adc  bx,0 )
	;

		MACRO d/+ 
	( **** summ of doubles **** )
	( ************************* )
	( arg: BX:AX = d1           )
	(      ES:DI = d2           )
	( out: BX:AX:= d1+d2        )
	( chg: AX,BX                )
	( ************************* ) 
	[ $8C $C2 ]    ( mov  dx,es )
	[ $01 $F8 ]    ( add  ax,di ) 
	[ $11 $D3 ]    ( adc  bx,dx ) 
	;

		MACRO d/-
	( **** diff of doubles **** )
	( ************************* )
	( arg: BX:AX = d1           )
	(      ES:DI = d2           )
	( out: BX:AX:= d1-d2        )
	( chg: AX,BX                )
	( ************************* ) 
	[ $8C $C2 ]    ( mov  dx,es )
	[ $29 $F8 ]    ( sub  ax,di ) 
	[ $19 $D3 ]    ( sbb  bx,dx ) 
	;

		 MACRO d/2* 
	( **  shift double left  ** )
	( ************************* )
	( arg: BX:AX = d            )
	( out: BX:AX:= d*2          )
	( chg: AX,BX                )
	( ************************* ) 
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $D3 ]     ( rcl  bx,1 )
	;



		 MACRO d/2 
	( * unsigned double division by 2  )
	( ************************* )
	( arg: BX:AX = i            )
	( out: BX:AX:= i/2          )
	( chg: BX AX                )
	( ************************* )
        
	[ $D1 $EB ]     ( shr  bx,1 )
	[ $D1 $D8 ]     ( rcr  ax,1 )  
	;


	( *** functions *** )

		MACRO and 
	( ****  AND AX with BX **** )
	( ************************* )
	( arg: AX = n               )
	(      BX = n1              )
	( out: AX:= n and n1        )
	( chg: AX                   )
	( ************************* ) 
	[ $21 $D8 ]    ( and  ax,bx )
	;

		  MACRO or 
	( ****  OR AX with BX  **** )
	( ************************* )
	( arg: AX = n               )
	(      BX = n1              )
	( out: AX:= n or n1         )
	( chg: AX                   )
	( ************************* ) 
	[ $09 $D8 ]    ( or   ax,bx )
	;

		 MACRO xor 
	( ****  XOR AX with BX **** )
	( ************************* )
	( arg: AX = n               )
	(      BX = n1              )
	( out: AX:= n xor n1        )
	( chg: AX                   )
	( ************************* ) 
	[ $31 $D8 ]    ( xor  ax,bx )
	;


		MACRO neg 
	( **  change sign of AX  ** )
	( ************************* )
	( arg: AX =  n              )
	( out: AX:= -n              )
	( chg: AX                   )
	( ************************* ) 
	[ $F7 $D8 ]       ( neg  ax )
	;


		 MACRO not 
	( ****  complement AX  **** )
	( ************************* )
	( arg: AX = n               )
	( out: AX:= n'              )
	( chg: AX                   )
	( ************************* ) 
	[ $F7 $D0 ]       ( not  ax )
	;


	       MACRO abs 
	( **** AX = abs(AX) **** )
	( ********************** )
	( arg: AX = value n      )
	( out: AX = abs(n)       )
	( chg: AX                )
	( ********************** )
	[ $3D 0 0 ]  ( cmp ax,#0 )
	[ $7d 2   ]  ( jge +2    )
	[ $F7 $D8 ]  ( minus ax  )
	;

	       MACRO shr
	( *** shift AX right *** )
	( ********************** )
	( arg: AX = value n      )
	(      BX = 0<=i<=15     )
	( out: AX = shr ax,i     )
	( chg: AX                )
	( ********************** )
	[ $89 $CA ]  ( mov dx,cx )
	[ $89 $D9 ]  ( mov cx,bx )
	[ $D3 $E8 ]  ( shr ax,cl )
	[ $89 $D1 ]  ( mov cx,dx )
	;

		MACRO shl 
	( *** shift AX left  *** )
	( ********************** )
	( arg: AX = value n      )
	(      BX = 0<=i<=15     )
	( out: AX = shl ax,i     )
	( chg: AX                )
	( ********************** )
	[ $89 $CA ]  ( mov dx,cx )
	[ $89 $D9 ]  ( mov cx,bx )
	[ $D3 $E0 ]  ( shl ax,cl )
	[ $89 $D1 ]  ( mov cx,dx )
	;


	     MACRO combine 
	( ** combine AX=BLAL ** )
	( ********************* )
	( arg: AL = value c1    )
	(      BL = value c2    )
	( out: AX:= c2*256+c1   )
	( chg: AH               )
	( ********************* )
	[ $88 $DC ] ( mov ah,bl )  
	; 

	      MACRO split 
	( ***   split AX    *** )
	( ********************* )
	( arg: AX = value n     )
	( out: AH:= 0           )
	(      BH:=0 BL:=AH     )
	( chg: AH,BX            )
	( ********************* )
	[ $88 $E3 ] ( mov bl,ah )
	[ $30 $FF ] ( xor bh,bh )
	[ $88 $FC ] ( mov ah,bh )
	;
  


		 : log2 
	( ***    AX:=log2(AX)   *** )
	( ***    discard rest   *** )
	( ** EXAMPLE: 1024 -> 10 ** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= log2(n)         )
	( chg: AX                   )
	( ************************* )
	[ $BA $FF $FF ] ( mov dx,-1 )
	BEGIN
	[ $42 ]         ( inc dx    )
	[ $D1 $E8 ]     ( shr ax,1  )
	UNTIL- Z
	[ $89 $D0 ]     ( mov ax,dx )
	;




	( ** Bitsteuerung: ** )

		 : 2^n 
	( ** 2 to the power of n * )
	( ************************ )
	( arg: AX = 0<=i<=15       )
	( out: AX:= 2^n            )
	( chg: AX                  )
	( ************************ ) 
	[ $89 $CA ]   ( mov  dx,cx )
	[ $89 $C1 ]   ( mov  cx,ax )
	[ $B8 1 0 ]   ( mov  ax,1  )
	[ $D3 $E0 ]   ( shl  ax,cl )
	[ $89 $D1 ]   ( mov  cx,dx )
	;

	       : clrbit 
	( ** clear bit i in AX *** )
	( ************************ )
	( arg: AX = value n        )
	(      BX = 0<=i<=15       )
	( out: AX:= n'             )
	( chg: AX,BX               )
	( ************************ ) 
	xab 2^n not and 
	;

	       MACRO setbit 
	( * set bit i in AX to 1 * )
	( ************************ )
	( arg: AX = value n        )
	(      BX = 0<=i<=15       )
	( out: AX:= n'             )
	( chg: AX,BX               )
	( ************************ ) 
	xab 2^n or 
	;

	( *** verschiedene Funktionen *** )

		 : min 
	( ** AX := minimum of...   )
	(    signed numbers     ** )
	( ************************ )
	( arg: AX = n1             )
	(      BX = n2             )
	( out  AX:= min(n1,n2)     )
	( chg: AX                  )
	( ************************ )
	[ $39 $D8 ]    ( cmp ax,bx )
	IF- G
	  [ $89 $D8 ]  ( mov ax,bx )
	ENDIF
	;

	: umin 
	( ** AX := minimum of...   )
	(    unsigned numbers   ** )
	( ************************ )
	( arg: AX = i1             )
	(      BX = i2             )
	( out  AX:= min(i1,i2)     )
	( chg: AX                  )
	( ************************ )
	[ $39 $D8 ]    ( cmp ax,bx )
	IF- A
	  [ $89 $D8 ]  ( mov ax,bx )
	ENDIF
	;


		  : max 
	( ** Maximum der Zahlen ** )
	( ** AX := maximum of...   )
	(    signed numbers     ** )
	( ************************ )
	( arg: AX = n1             )
	(      BX = n2             )
	( out  AX:= max(n1,n2)     )
	( chg: AX                  )
	( ************************ )
	[ $39 $D8 ]    ( cmp ax,bx )
	IF- L
	  [ $89 $D8 ]  ( mov ax,bx )
	ENDIF
	;


	       : Umax 
	( ** AX := maximum of...   )
	(    unsigned numbers   ** )
	( ************************ )
	( arg: AX = i1             )
	(      BX = i2             )
	( out  AX:= max(i1,i2)     )
	( chg: AX                  )
	( ************************ )
	[ $39 $D8 ]    ( cmp ax,bx )
	IF- B
	  [ $89 $D8 ]  ( mov ax,bx )
	ENDIF
	;



	       : .getbit. 
	( * get bitvalue in AX * )
	( ********************** )
	( arg: AX = value n      )
	(      BX = 0<=pos<=15   )
	( out: CF:= 0|1          )
	( chg: AX,BX             )
	( ********************** )
	[ $87 $D9 ] ( xchg cx,bx )
	[ $D3 $E8 ] ( shr  ax,cl )
	[ $87 $D9 ] ( xchg cx,bx )
	[ $24 $01 ]   ( and  al,1  ) 
	[ $D1 $D8 ] ( rcr ax,1   )	
	;
