(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
        *         INPUT/OUTPUT routines  V1.02                     *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B  25.08.93                  *
        *                                                          *
        ************************************************************
)

var BASE    [ 10 ]       ( Base ) ;
var HLD     word         ( Pointer to Number processed ) ;
var DPL     word         ( Pointer to Decimalpoint ) ;
var LEADING [ *$20 ]     ( Leading Zero oder Space ) ;
var NUMBUF  byte 64      ( Conversion buffer for . d. etc. ) ;
var FBUF    byte 12 ;
var SGN     word         ( Sign ) ;


		   : $.
	( **** output string **** )
	( *********************** )
	( arg: SI = stringadr     )
	( out: -                  )
	( chg: SI                 )
	( *********************** )

	  [ $AC		( lodsb )
	    $C008	( or al,al )
	    $0974 ]	( jz +09 )
	    a>b
	    emit
	  [ $F2EB ]	( jmp -12 )  
  	;
	

	: space  ( - )
	( ** Leerzeichen ausgeben ** )
	bpush
	bl emit
	bpop 
	;


	: spaces  ( n,- => ? )
	( ** n Leerzeichen ausgeben ** )
	 FOR space NEXT
	;

	: cr  ( - )
	( ** CRLF ausgeben ** )
	bpush
	$A emit $D emit
	bpop 
	;


        proc expect
	( ** expect string from keybord ** )
	( ******************************** )
	( arg: BX = maximum of input chars )
	(      SI = buffer_adr             )
	( out: -                           )
	( chg: AX                          )
	( ******************************** )
	b>e
	adr>d
	begin
	  key 
	  case
	    08 of adr- bl emit bs emit ;;
	    13 of , 13 ;;
	    else al>m adr+ 
	  endcase  
	  13 .=. flag> adr>a d>b - e>b .<. .not. .>or.
	until
	0 bl>m d>adr
	;


	: wait     ( ? )
		   ( ? )
		   ( ? )
	( **  Warte auf Taste mit Nachricht  ** )
	"  Hit any key to continue..."  $.
	key 
	;


		 : >default 
	( *** output to console *** )
	( ************************* )
	( arg: -                    )
	( out: -                    )
	( chg: ?                    )
	( ************************* )
	[ $c6 $06 stdout# 01 ] ( mov stdout#,1 )  
	make emit  (emit)
	make key   (key)
	make ?key  .?key.
	video-byte m>al
	 case
	 7 OF *$B000 ;;
	 else *$B800
	 endcase
	vseg b>m
	;


	( ** output numbers ** )

		      : nib.h 
	( **  hex output lower nibble of AL   ** )
	( Trick conversion from DOS-UNDOCUMENTED )
	(      Schulman: Addison-Wesley 1991     )
	( ************************************** )
	( arg: AL = value c                      )
	( out: -                                 )
	( chg: -                                 )
	( ************************************** )              
	[ $24 $0F ]                 ( and al,#0F )
	[ $04 $90 ]                 ( add al,#90 )
	[ $27 ]                     ( daa        )
	[ $14 $40 ]                 ( adc al,#40 )
	[ $27 ]                     ( daa        )
	xab emit a>b
	;

		 : byte.h 
	( ** hex output of AL ** )
	( ********************** )
	( arg: AL = value c      )
	( out: -                 )
	( chg: -                 )
	( ********************** ) 
	apush
	u/16  nib.h
	apop apush
	nib.h 
	apop
	;

		 : u.h 
	( ** hex output of AX ** )
	( ********************** )
	( arg: AX = value u      )
	( out: -                 )
	( chg: -                 )
	( ********************** ) 
	apush
	[ $88 $e0 ]  ( mov al,ah )
	byte.h
	apop
	byte.h
;

		 : (.d) 
	( ** dec output of AX ** )
	( ********************** )
	( arg: AX = value n      )
	( out: -                 )
	( chg: SI                )
	( ********************** ) 
	bpush
	dpush
	[ $51 ]         ( push cx      )
	D= $0A
	[ $31 $c9 ]     ( xor  cx,cx   )
	BEGIN
	[ $29 $d2 ]     ( sub  dx,dx   )
	[ $f7 $f7 ]     ( div  di      )
	[ $83 $c2 $30 ] ( add  di,#'0' )
	[ $52 ]         ( push dx      )
	[ $41 ]         ( inc  cx      )
	.0=.
	UNTIL
	b>a
	FOR-
	  bpop
	  emit
	NEXT-
	[ $59 ]         ( pop cx  )
	dpop bpop adr>a
	;

		: u.d 
	( ** dec output of AX ** )
	(      without sign      )
	( ********************** )
	( arg: AX = value u      )
	( out: -                 )
	( chg: SI                )
	( ********************** ) 
	bpush a>b a>adr
	.0=.
	IF '0' emit bpop [ $C3 ] ENDIF
	bpop
	(.d)
	;

		   : .d 
	( ** dec output of AX ** )
	(      with sign         )
	( ********************** )
	( arg: AX = value n      )
	( out: -                 )
	( chg: SI                )
	( ********************** ) 
	bpush a>b a>adr
	.0=.
	IF bl emit '0' emit bpop [ $C3 ] ENDIF
	.neg. if '-' emit neg else bl emit endif
	bpop
	(.d)
	;


		  : decin# 
	( **  input decnumber    ** )
	( * no check for overflow * )
	( ************************* )
	( arg: -                    )
	( out: AX:= value n         )
	( chg: ?                    )
	( ************************* )
	(long)
	D= 0
	byte m-off
	BEGIN
	  key 13 .=. .not. 
	WHILE
	  CASE
	    45   of byte m-on ;;       ( minus char )
	     8   of bl emit bs emit    ( backspace  )
		    d>a 10 / a>d ;;
	    '0' <of 7 emit bs emit bl emit bs emit ;;
	   '9' >of 7 emit bs emit bl emit bs emit ;;
	  ELSE  '0' - a>b d>a 10* + a>d    ( Ziffer )
	  ENDCASE
	REPEAT
	d>a
	byte IF- on neg ENDIF
	(short)
	; 


		  : .hexdigit.
	( ** convert hexchar in number ** )
	( ******************************* )
	( arg: AL=  hexcharacter          )
	( out: AL:= hexdigit              )
	(      CF:=1 if valid hexchar     )
	(      CF:=0 if not valid         )
	( chg: AL CF                      )
	( ******************************* )
	[ $2C $30 ]          ( sub al#,30 )
	IF- NC
	  [ $3C $0A ]        ( cmp al,#0A )
	  [ $F5 ]            ( cmc        )
	  IF- C
	    [ $24 $5F ]      ( and al,#5F )
	    [ $2C $07 ]      ( sub al,#07 )
	    [ $3C $0A ]      ( cmp al,#0A )
	    IF- NC
	      [ $3C $10 ]    ( cmp al,#10 )
	      [ $F5 ]        ( cmc        )
	    ENDIF
	  ENDIF
	ENDIF
	[ $F5 ]              ( cmc        )
	;

		   : hexin# 
	( ****  input i hexdigits  **** )
	( ***************************** )
	( arg: BL = i <= 4              )
	( out: AX:= number              )
	( chg: ?                        )
	( ***************************** )
	D= 0
	FOR
	[ $b4 $00 ]         ( mov ah,00 )
	[ $CD $16 ]         ( int 16    ) ( get key )
	[ $b4 $00 ]         ( mov ah,00 )  
	.hexdigit. 
	 if                  ( Ziffer )
	    [ $d1 $e7 ]      ( shl di,1 )
	    [ $d1 $e7 ]      ( shl di,1 )
	    [ $d1 $e7 ]      ( shl di,1 )
	    [ $d1 $e7 ]      ( shl di,1 ) ( 16* )        
	    [ $01 $c7 ]      ( add di,ax )
	    emit
	 else 
	    7 emit
	    [ $41 ]            ( inc cx )
	 endif
	NEXT
	d>a       
	; 


( ***  formatted output of BX:AX   *** )
( conversion according to current base )
( The complete series of <# ....... #> )
( has the following register effect:   )
( ************************************ )
( arg: BX:AX = double                  )
( out: SI:= string_adr                 )
( chg: CF?                             )
( ************************************ )


	   : hold 
( ** store char in numbuf ** )
( ************************** )
( arg: BX = char c           )
( out: SI:=SI-1              )
( chg: -                     )
( ************************** ) 
hld mem-     ( dekrement hld )
m>adr        ( get adress    )
bl>m         ( store char    )
;

	    : <# 
( ** start formatted output ** )
( **************************** )
( arg: BX:AX = unsigned double )
( out: ES:DI:= unsigned double )
( chg: -                       )
( **************************** )
fbuf ba>m 
[ $83 $C6 $04 ]    ( add si,04 )
ed>m
ba>ed          ( copy to ES:DI )
[ $BA numbuf ] ( mov dx,numbuf )
[ $81 $C2 *63 ]    ( add dx,63 )
[ $89 $16 hld ] ( mov [hld],dx )
;

: # 
 ( => ? )
     ( ud => ud' )
     ( => ? )
( ** eine Ziffer ablegen ** )
ed>ba 
.ba0=.                 ( auf Null prfen )
IF- NC
    base m>dl         ( Basis nach DI )
	( ba/d: Ziffer berechnen )
	[ $93 ]      ( xchg ax,bx   ) 
	[ $31 $D2 ]  ( xor  dx,dx   ) 
	[ $F7 $F7 ]  ( div  di      ) ( (0:high)/i )
	[ $93 ]      ( xchg ax,bx   )
	[ $F7 $F7 ]  ( div  di      ) ( (rest:low)/i )
	[ $89 $D7 ]  ( mov  di,dx   ) ( rest )
    b>e xad            ( Zahl in es:di, Rest in ax )
    [ $05 $30 0 ]      ( add ax,30 : in ASCII-Format bringen )
    [ $3D $39 0 ]      ( cmp ax,39 : Zahlenbasis grer 10 ? )
    IF- NG
      [ $05 7 0 ]      ( add ax,07 : ja )
    ENDIF
ELSE
    leading m>a        ( Leerzeichen oder Null ausgeben )
ENDIF
a>b hold               ( Ziffer ablegen )
;


: #s  ( ud --> ud' )
( ** restliche Ziffern ablegen ** )
  begin
    ed>ba .ba0=.  ( Solange Zahl ungleich Null ... )
  while- NC
    #             ( ... Ziffer ausgeben )
  repeat
;


	    : #> 
( *** ends formatted output *** )
( ** string is ready to print * )
( ***************************** )
( arg: ES:DI double             )
( out: SI:= string_adr          )
( chg: SI,AX,BX                 )
( ***************************** )
adrpush
numbuf          
[ $81 $C6 *62 ] ( add si,62     )
[ $80 $3C $20 ] ( cmp [si],$20  )
IF- Z
[ $C6 $04 $30 ] ( mov b/[si],$30 )
ENDIF
fbuf m>ba
[ $83 $C6 $04 ]     ( add si,04 )
m>ed
adrpop
;


	    : sign 
( **** insert sign if n neg *** )
( ***************************** )
( arg: -                        )
( out: -                        )
( chg: BX,?                     )
( ***************************** )
  sgn 
  [ $D0 $64 1 ]  ( sal b/[si+1],1 : Vorzeichen negativ ? )
  if
    '-'   ( ja, dann Minuszeichen )
  else
    $20   ( nein, dann Leerzeichen )
  endif
  hold    ( Zeichen ausgeben )
;

	  : d. 
( **** type double **** )
( ********************* )
( arg: BX:AX = double d )
( out: -                )
( chg: ?                )
( ********************* )
sgn b>m   ( save sign   )
d/abs     ( get absolut ) 
<# # #s   ( type double )
sign #>   ( add sign    )
adrpush
  sgn 
  [ $D0 $64 1 ]  ( sal b/[si+1],1 : Vorzeichen negativ ? )
  IF D/neg ENDIF
  adrpop
$.        ( and type    )
;

	 : ud. 
( type unsigned double  )
( ********************* )
( arg: BX:AX = double d )
( out: -                )
( chg: ?                )
( ********************* )
<# # #s #>
$.
;

	 : d.r 
( ****   type double   **** )
( r least signifdigits only )
( ************************* )
( arg: BX:AX = double d     )
(      DI = digits r        )
( out: -                    )
( chg: SI                   )
( ************************* )
  sgn b>m        ( save sign )
  d/abs          ( Absolutwert bilden )
  [ $51 ]        ( push cx )
  [ $89 $F9 ]    ( mov cx,di )
  <#             ( Start Ausgabe )
   FOR-
     #           ( Ausgabe entsprechend Feldbreite )
   NEXT-
  sign #>        ( Vorzeichen anfgen )
  adrpush
    sgn 
  [ $D0 $64 1 ]  ( sal b/[si+1],1 : Vorzeichen negativ ? )
  IF D/neg ENDIF
  adrpop
  [ $59 ]        ( pop cx )
  $.             ( ... und drucken )
;


	 : ud.r 
( ** type unsigned double * )
( r least signifdigits only )
( ************************* )
( arg: BX:AX = double d     )
(      DI = digits r        )
( out: -                    )
( chg: SI                   )
( ************************* )
  [ $51 ]        ( push cx )
  [ $89 $F9 ]    ( mov cx,di )
  <#             ( Start Ausgabe )
   FOR-
     #           ( Ausgabe entsprechend Feldbreite )
   NEXT-
  #>
  [ $59 ]        ( pop cx )
  $.             ( ... und drucken )
;



	   MACRO . 
( ***  type word in AX *** )
( ************************ )
( arg: AX = value n        )
( out: -                   )
( chg: BX                  )
( ************************ )
n>d   ( in doppelt genaue Zahl konvertieren )
d.    ( ... und ausgeben )
;


	   : .r 
( ***  type word in AX *** )
( r least sign.digits only )
( ************************ )
( arg: AX = value n        )
(      BX = digits r       )
( out: -                   )
( chg: -                   )
( ************************ )
bpush
b>d n>d   ( in doppelt genaue Zahl konvertieren )
d.r       ( ... und ausgeben )
bpop
;


	   : u. 
( type value in AX w/o sign )
( ************************* )
( arg: AX = value u         )
( out: -                    )
( chg: ?                    )
( ************************* )
 0       ( auf doppelte Genauigkeit erweitern )
<# # #s #> ( Konvertierung ohne Vorzeichen )
$.       ( ... und ausgeben )
;


	  : u.r 
( type value in AX w/o sign )
( r least sign.digits only  )
( ************************* )
( arg: AX = value u         )
(      BX = digits r        )
( out: -                    )
( chg: ?                    )
( ************************* )
[ $51 ]        ( push cx )
[ $89 $D9 ]    ( mov cx,bx )  
0              ( Absolutwert bilden )
<#             ( Start Ausgabe )
   FOR-
     #         ( Ausgabe entsprechend Feldbreite )
   NEXT-
#>             ( End         )
[ $59 ]        ( pop cx      )
$.             ( ... und drucken )
;

: .bit 
( ** type msb of AX ** )
( ******************** )
( arg: AX = value n    )
( out: AX = 2*n        )
( chg: AX              )
( ******************** )
[ $D1 $E0 ] ( shl ax,1 )
IF '1' else '0' endif
emit
;

	: u.b 
( ** type AX binary ** )
( ******************** )
( arg: AX = value n    )
( out: -               )
( chg: -               )
( ******************** )
apush bpush
.bit .bit .bit .bit space
.bit .bit .bit .bit space
.bit .bit .bit .bit space
.bit .bit .bit .bit space
bpop  apop
;

      macro lead0
( lead form. out by '0' )
( ********************* )
( arg: -                )
( out: -                )
( chg: -                )
( ********************* )
[ $C6 $06 leading $30 ] ( mov [leading],$30 )
;

      macro -lead0
( lead form. out by ' ' )
( ********************* )
( arg: -                )
( out: -                )
( chg: -                )
( ********************* )
[ $C6 $06 leading $20 ] ( mov [leading],$20 )
;


	 MACRO hex 
( ** set base to hex ** )
( ********************* )
( arg: -                )
( out: -                )
( chg: -                )
( ********************* )
[ $C6 $06 base $10 ] ( mov [si],16 )
;


	MACRO decimal 
( ** set base to decimal ** )
( ************************* )
( arg: -                    )
( out: -                    )
( chg: -                    )
( ************************* )
[ $C6 $06 base $0A ] ( mov [si],10 )
;

     : .decdigit. 
( convert decdigit to number )
( ************************** )
( arg: AL = decdigit         )
( out: AL:= number           )
(      CF:=1 if digit valid  )
( chg: AL                    )
( ************************** ) 
[ $2C $30 ]      ( sub al,30 )
[ $72 $05 ]      ( jc ex     )
[ $3C $0A ]      ( cmp al,0A )
[ $73 $02 ]      ( jnc ex+1  )
[ $F5 ]          ( cmc       )
[ $F5 ]          ( ex: cmc   )
;

       proc .digit. 
( * convert digit to number  )
( valid_digit according base )
( ************************** )
( arg: AL = digit            )
( out: AL:= number           )
(      CF:=1 if digit valid  )
( chg: AL                    )
( ************************** ) 
   dpush
    '0' -
    16 .>.
   if
      7 -
   endif
    41 .>.
   if
      32 -
   endif
    base m>dl d- 0 .>?<.
   dpop
;


var (base) [ 0 ]  ;
var (in)   [ *0 ]  ;

	: (number)
( * subroutine of number * ) 
( ************************ )
( arg: BP = string_adr     )
(      BX:AX = double      )
( out: BX:AX:= double'     )
( chg: ?                   )
( ************************ )
  begin
    [ $3E $8A $46 0 ]     ( mov al,ds:[bp+0] )
    [ $B4 0 ]             ( mov ah,0 : Zeichen holen )
    (in) b/mem-           ( Eingabe-Zhler dekrementieren )
    .digit.               ( prfen )
  while                   ( solange Ziffer )
    [ $45 ]               ( inc bp : adr +1  )
    apush
    ed>ba
    base m>dl 
    ba*d                  ( Word mit Base multiplizieren )
    dpop
    E= 0 d/+            ( Ziffer aufaddieren )
    ba>ed
  repeat
;

	: number 
( convert string to double )
( var dpl counts digits... )
( after decimal point      )
( ************************ )
( arg: SI = string_adr     )
( out: BX:AX:= double      )
( chg: ?                   )
( ************************ )
  [ $55 ]               ( push bp )

   ipush adrpush
   xadrd
   xeds , 0

 [ $B9 $FFFF 	( mov cx,FFFF )
   $F2 $AE	( repnz scasb )
   $F7 $D9	( neg cx )
   $49		( dec cx )
   $49		( dec cx )
   $89 $C8 ]	( mov ax,cx )
   xeds
   xadrd
   adrpop ipop
   1+
  [ $89 $F5 ]           ( mov bp,si )
  (in)  al>m            ( count speichern )
  base to (base) b/m>m    ( Zahlenbasis retten )
  [ $3E $8A $46 0 ]     ( mov al,ds:[bp] )
  [ $B4 0 ]             ( mov ah,0 : 1.Zeichen )
  sgn a>m               ( merken ) 
  case
   '-' of               ( negative Zahl ? )
       (in) b/mem- [ $45 ]     ( dec (in) inc bp )
	;;
   '$' of
       (in) b/mem-            ( dec (in) )
       hex [ $45 ]            ( inc BP )
  endcase
  
  E= 0 D= 0 
  dpl d>m              ( Dezimalpunkt lschen )
  (number)             ( konvertieren )
  [ $3E $8A $46 0 ]    ( mov al,ds:[bp+0] )
  [ $B4 0 ]            ( mov ah,0 : Zeichen holen )
  case
   '.' of              ( Dezimalpunkt ? )
    (in) m>al
    1- dpl al>m        ( Position merken )
    [ $45 ]            ( inc bp : nchste Adresse )
    (number) ;;        ( weiter konvertieren )
  endcase
  ed>ba  
  (base) to base b/m>m  ( Basis wiedereinsetzen )
  sgn
  [ $8A $14 ]          ( mov dx,[si] : Vorzeichen holen )
  [ $80 $FA $2D ]      ( cmp dl,'-' )
  [ $F8 ]              ( clc )
  [ $75 $01 ]          ( jne +1 )
  [ $F5 ]              ( cmc )
   if d/neg endif      ( evtl. Vorzeichenwechsel )
  [ $5D ]              ( pop bp )
;


	: .number. 
( convert string to double )
(   with errorcode in CF   )
( var dpl counts digits... )
(   after decimal point    )
( ************************ )
( arg: SI = string_adr     )
( out: BX:AX:= double      )
(      CF:=1 if valid      )
( chg: ?                   )
( ************************ )
  number 
  (in) m>d
  [ $85 $FF ] ( test di,di )
  [ $F8 ]     ( clc )
  [ $75 $01 ] ( jnz 01     )
  [ $F5 ]     ( cmc        )
;

var (#in) "                                              " ;

	  proc #in 
( * input double         ** )
( **   to current base   ** )
( ************************* )
( arg: BX = digitcountmax   )
(      ES:DI = Default	    )
( out: BX:AX:= double|def   )
( chg: ?                    )
( ************************* )

   (#in) expect
   (#in) .number.
   IF
   ELSE
   7 emit
   ed>ba
   ENDIF
;

	( cursorposition )

	       : c-xy?
	( ** cursorposition? ** )
	( arg: -                )
	( out: BX column (x)    )
	(      AX row (y)       ) 
	( chg: ES               )
	( ********************* )
	epush
	[ $31 $D2 ]           ( xor dx,dx       )
	[ $8E $C2 ]           ( mov es,dx       )
	[ $26 $8b $16 $50 4 ] ( mov dx,es:[450] )
	[ $88 $D3 ]           ( mov bl,dl       )
	[ $b7 $00 ]           ( mov bh,0        )
	[ $88 $f0 ]           ( mov al,dh       )
	[ $b4 $00 ]           ( mov ah,0        )
	epop
	;

		: c-xy
	( ** pos the cursor  ** )
	( arg: BX column (x)    )
	(      AX row (y)       )
	( out: -                ) 
	( chg: AH               )
	( ********************* )
	epush
	[ $31 $D2 ]           ( xor dx,dx       )
	[ $8E $C2 ]           ( mov es,dx       )
	[ $88 $Da ]           ( mov dl,bl       )
	[ $88 $c6 ]           ( mov dh,al       )
	[ $26 $89 $16 $50 4 ] ( mov es:[450],dx )
	[ $b4 $02 ]           ( mov ah,2        )
	[ $cd $10 ]           ( int 10          )
	epop
	;

		 : tab
	( ****  tabcursor  **** )
	( arg: BX column (x)    )
	( out: -                )
	( chg: -                )
	( ********************* )
	epush
	[ $31 $D2 ]           ( xor dx,dx       )
	[ $8E $C2 ]           ( mov es,dx       )
	[ $26 $8b $16 $50 4 ] ( mov dx,es:[450] )
	[ $88 $DA ]           ( mov dl,bl       )
	[ $26 $89 $16 $50 4 ] ( mov es:[450],dx )
	[ $b4 $02 ]           ( mov ah,2        )
	[ $cd $10 ]           ( int 10          )
	epop
	;

	: clrscr 
	( **************** )
        ( * Clear screen * )  
	( **************** )
	  (OS-CLS)
	;

