(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
        *                    MEMORY routines V1.0                  *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B 25.08.93                   *
        *                                                          *
        ************************************************************
)

const NIL &0 ;

var HeapBase  fptr ;   ( Heap Start SEG:OFS )
var HeapPtr   fptr ;   ( 1st Free location on Heap Seg:ofs )
var HeapEndptr fptr ;  ( End of heap seg:ofs )
var HeapBeg   double ; ( Heap Start 32Bit linear Address )
var HeapAct   double ; ( 1st Free loc. 32Bit lin. Addr. )
var HeapSize  double ; ( Heap size in Bytes 32 Bit ) 
var HeapEnd   double ; ( End of heap lin Addr. 32Bit )


	( *** Speicher-Befehle  *** )

: memcpy
( copy contents of one pointer to another )
( arg:  si := Source ptr )
(	di := Dest. ptr  )
(	ax := byte count )
( chg:  ax,si,di         )

    ipush
    a>i
  [ $06 		( push es )
    $1E	    		( push ds ) 
    $C4 $3D		( les di,[di] )
    $C5 $34		( lds si,[si] )
    $91 	        ( xchg ax,cx  )
    $D1 $E9 ]		( shr cx,1 ; Loop # of bytes div 2 )
    IF [		( IF uneven number then xfer 1 Byte )
         $41      ( inc cx      )
         $A4 ]    ( movsb       )
    ENDIF
  [ $F3 $A5		( rep movsw ; transfer words )	
    $89 $C1		( mov cx,ax   )
    $1F			( pop ds )
    $07 ]       	( pop es )
  ipop 
;


		  : i/copy 
	( copy i bytes from mem to .. )
	( .. mem in datasegment DS ** )
	( smart: regions may overlap! )
	(   Syntax: a to b  i/copy    )
	( *************************** )
	( arg: AX = bytes_to_copy i   )
	(      SI = sourceadr a       )
	(      DI = dest_adr  b       )
	( out: -                      )
	( chg: AX,ES,SI,DI            )
	( *************************** )
	[ $91 ]          ( xchg ax,cx )
	[ $8C $DA ]      ( mov  dx,ds )
	[ $8E $C2 ]      ( mov  es,dx )
	[ $89 $F2 ]      ( mov  dx,si )
	[ $39 $F7 ]      ( cmp  di,si )
	 IF- NG
	   [ $03 $F1 ]   ( add  si,cx )
	   [ $03 $F9 ]   ( add  di,cx )
	   [ $4E ]       ( dec  si    )
	   [ $4F ]       ( dec  di    )
	   [ $FD ]       ( std        )
	 ENDIF
	[ $F3 $A4 ]      ( rep  movsb )
	[ $FC ]          ( cld        )
	[ $89 $D6 ]      ( mov  si,dx )
	[ $89 $C1 ]      ( mov cx,ax  )  
	;


		 : b/fill 
	( fill i bytes in mem with c )
	( ************************** )
	( arg: SI = mem_adr          )
	(      BL = char c           )
	(      AX = count i          )
	( out: -                     )
	( chg: ES,DI,BX,AX           )
	( ************************** )
	[ $91 ]        ( xchg cx,ax  )
	[ $93 ]        ( xchg ax,bx  )
	[ $8C $DA ]    ( mov  dx,ds  )
	[ $8E $C2 ]    ( mov  es,dx  )
	[ $89 $F7 ]    ( mov  di,si  )
	[ $F3 $AA ]    ( rep  stosb  )
	[ $89 $D9 ]    ( mov  cx,bx  )
	;

		  : fill 
	( fill i words in mem with n )
	( ************************** )
	( arg: SI = mem_adr          )
	(      BL = value n          )
	(      AX = count i <32000   )
	( out: -                     )
	( chg: ES,DI,BX,AX           )
	( ************************** )
	[ $91 ]         ( xchg cx,ax )
	[ $93 ]         ( xchg ax,bx )
	[ $8C $DA ]     ( mov  dx,ds )
	[ $8E $C2 ]     ( mov  es,dx )
	[ $89 $F7 ]     ( mov  di,si )
	[ $F3 $AB ]     ( rep  stosw )
	[ $89 $D9 ]     ( mov  cx,bx )
	;

		 MACRO erase 
	( fill i bytes in mem with 0 )
	( ************************** )
	( arg: SI = mem_adr          )
	(      AX = count i          )
	( out: -                     )
	( chg: ES,DI,BX,AX           )
	( ************************** )
	0  b/fill 
	;

		 MACRO blank 
	( fill i bytes in mem with 32 )
	( *************************** )
	( arg: SI = mem_adr           )
	(      AX = count i           )
	( out: -                      )
	( chg: ES,DI,BX,AX            )
	( *************************** )
	bl b/fill 
	;


		 MACRO im>a 
	( word from indexed mem to AX )
	( *************************** )
	( arg: SI = adr               )
	(      BX = index i           )
	( out: AX:= n from DS:[SI+BX] )
	( chg: AX                     )
	( *************************** ) 
	[ $D1 $E3 ]  ( shl bx,1       )
	[ $8B $00 ]  ( mov ax,[si+bx] )
	;

		 MACRO im>al 
	( byte from indexed mem to AL )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = base_adr          )
	(      BX = index i           )
	( out: AL:= c from XS:[SI+BX] )
	(           default XS: DS    )
	( chg: AL,AH                  )
	( *************************** ) 
	[ $8A $00 ]  ( mov al,[si+bx] )
	[ $B4 $00 ]  ( mov ah,00      )
	;

		 MACRO a>im 
	( **  store AX with index   ** )
	( ** at adr = base_adr+2*i  ** )
	( **************************** )
	( arg: AX = value n to store   )
	(      BX = index              )
	(      SI = base_adr           )
	( out: -                       )
	( chg: BX                      )
	( **************************** )
	[ $D1 $E3 ]  ( shl bx,1        )
	[ $89 $00 ]  ( mov [si+bx],ax  )
	;

		MACRO al>im 
	( **  store AL with index   ** )
	( **  at adr = base_adr+i   ** )
	( **************************** )
	( arg: AX = value n to store   )
	(      BX = index              )
	(      SI = base_adr           )
	( out: -                       )
	( chg: BX                      )
	( **************************** )
	[ $88 $00 ]  ( mov [si+bx],al  )
	;

	: nxparas 
	( ************************************* )
        ( * arg:   - 			      * )
        ( * out: AX := pgm size in paragraphs * )
     	( ************************************* )
	[ $A1 HEAPSEG ] 		( mov ax,[heapseg]	)
	[ $8C $CB ]     		( mov bx,cs        	)
	[ $29 $D8 ]     		( sub ax,bx             )
	[ $2E $03 $06 HEAPPARA ] 	( add ax,cs:[heappara]  )
	;

	   : normptr 
( **  normalize pointer  ** )
( ************************* )
( arg: SI = pointer_adr     )
( out: -                    )
( chg: -                    )
( ************************* )
  [ $8B $14 ]       ( mov  dx,[si]   )
  [ $81 $24 *$000F ] ( and  [si],15   )
  [ $D1 $EA ]       ( shr  dx,1      )
  [ $D1 $EA ]       ( shr  dx,1      )
  [ $D1 $EA ]       ( shr  dx,1      )
  [ $D1 $EA ]       ( shr  dx,1      )
  [ $01 $54 2 ]     ( add  [si+2],dx )
;

   : ptr2lin

( ** seg:ofs pointer to linear 32Bit address ** )
( ****************************** )
( arg: SI = pointer_adr          )
(      DI = lin_ptr_adr          )
( out: BX:AX lin_ptr             )   
( ****************************** )
  dpush m>ba
  apush b>a
  16 * ba>ed
  apop 0 d/+
  adrpop
  ba>m
;

   : lin2ptr
( * linear 32Bit address to seg:ofs pointer ** )
( ****************************** )
( arg: SI = lin_ptr_adr          )
(      DI = pointer_adr          )
( out: ES:DI pointer             )   
( chg: ax bx es                  )
( ****************************** )
  dpush
  m>ba $000F and apush
  m>ba d/2 d/2 d/2 d/2
  a>e dpop 
  adrpop ed>m
;      


: b/memfill 
(  pointerset i bytes to c  )
( ************************* )
( arg: SI = ptr_adr         )
(      BX = char c          )
(      AX = Bytes to fill i )
( out: -                    )
( chg: ES,DI                )
( ************************* )
[ $89 $C2 ]  ( mov  dx,ax   )
[ $89 $D8 ]  ( mov  ax,bx   )
[ $87 $CA ]  ( xchg cx,dx   ) 
[ $C4 $3C ]  ( les  di,[si] ) ( Target adr in es:di )
[ $F3 $AA ]  ( rep  stosb   ) ( ... and here we go )
[ $89 $D1 ]  ( mov  cx,dx   )
;

	  : memfill 
(  pointerset i words to n  )
( ************************* )
( arg: SI = ptr_adr         )
(      BX = value n         )
(      AX = words to fill i )
( out: -                    )
( chg: ES,DI                )
( ************************* )
[ $89 $C2 ]  ( mov  dx,ax   )
[ $89 $D8 ]  ( mov  ax,bx   )
[ $87 $CA ]  ( xchg cx,dx   ) 
[ $C4 $3C ]  ( les  di,[si] )
[ $F3 $AB ]  ( rep  stosw   )
[ $89 $D1 ]  ( mov  cx,dx   )
;


: incptr
( ** add n to pointer    ** )
( ************************* )
( arg: SI = ptr_adr         )
(      BX = value n         )
( out: -                    )
( chg: ES,DI                )
( ************************* )
  normptr memn+ normptr  ( add offset and normalize pointer )
;


	 : .nil=. 
( ** Pointer = Nil ?      ** )
( ************************** )
( arg: SI = ptr_adr          )
( out: CF:=1 if seg=ofs=0    )
( chg: CF                    )
( ************************** )
[ $8B $14 ]    ( mov dx,[si]   )
[ $0B $54 $02 ] ( or  dx,[si+2] )
[ $F8 ]      ( clc           )
[ $75 $01 ]  ( jnz +1        )
[ $F9 ]      ( stc           )
;




( ***** memory management ***** )


: meminit
  HeapSeg m>a HeapBase adr2+ a>m
  HEAPPARA CS: m>a 16 u*
  HeapSize ba>m
  HeapBase m>ba HeapPtr ba>m 
  heapbase to heapbeg ptr2lin
  heapptr to heapact ptr2lin
  Heapbeg m>ba Heapsize m>ed d/+ Heapend ba>m
  heapend to heapendptr lin2ptr
;         



: memalloc
( **  Allocate memory from heap       ** )
( ** a first quite primitive approach ** )
( ** doesn't look for free mem adr adr<heapptr ** )
( ************************* )
( arg: SI = ptr_adr         )
(      BX:AX = Bytes req.   )
( out: -                    )
( chg: AX                   )
( ************************* )
  bapush
  adrpush       ( save pointer )

  heapptr m>ed d>adr es: a>m adr2+ es: b>m  ( put Size in [ptr-6] )
  adr2+ apop apush es: a>m                  ( put owner in [ptr-2] )
  heapact m>ed &6 d/+ bapush
  heapact to heapptr lin2ptr
  bapop heapact ba>m
  heapptr m>ba 2+ 2+ 2+ ba>m
  adrpop ba>m
  heapact m>ed bapop d/+ ba>m 
  heapact to heapptr lin2ptr
  heapend m>ba heapact m>ed d/- b>a $8000 and .0<>. IF
    apop 4 - 201 errorptr
  ENDIF
;

var (buf) fptr ;
var (buf1) double ;

: memdispose  
( ** Dispose allocated memory ** )
( ** arg :  SI = pointer adr  ** )
( ** out :  -                 ** )
( ** chg : ax bx es di        ** )
( ****************************** )
   adrpush
   .nil=. IF
     apop apop 4 - 202 errorptr
   ENDIF
   m>ed
   d>adr adr2- adr2- adr2-
   es: m>a adr2+ es: m>b adr2+ ( Size in BX:AX ) 
   epush dpush
   d/+ (buf) ba>m to (buf1) ptr2lin
   heapact m>ed d/- .0=. IF dpop epop adrpop adrpush epush dpush
     normptr m>ba heapptr ba>m to heapact ptr2lin  
     heapact m>ba d= &6 d/- ba>m to heapptr lin2ptr 
   ENDIF 
   dpop epop
   d= 0 es: d>m   ( Set MCB-Owner to NIL )
   adrpop d>m adr2+ d>m ( Set Ptr to NIL )
;


: MemAvail  
( ** Free heap left **  )
( arg : -               )
( out : bx:ax bytes Heap )
  heapend m>ba 
  heapact m>ed d/-
;


var auxptr fptr ;

: new 
  adrpush
  adr2+ adr2+
  m>ba bapush 
  0 adr2- adr2- 
  apush
  adrpush       ( save pointer )
  heapptr m>ba adrpop ba>m
  heapact m>ed apop 0 d/+ ba>m 
  heapact to heapptr lin2ptr
  heapend m>ba heapact m>ed d/- b>a $8000 and .0<>. IF
    apop 4 - 201 errorptr
  ENDIF
  bapop
  auxptr b>m a>b ds>a adr2+ a>m
  b>a
  auxptr dpop memcpy
;

: dispose

   adrpush
   .nil=. IF
     apop apop 4 - 202 errorptr
   ENDIF
   m>ed 
   adr2+ adr2+ m>a 0
   d/+ (buf) ba>m to (buf1) ptr2lin
   heapact m>ed d/- .0=. IF 
   adrpop adrpush normptr m>ba heapptr ba>m to heapact ptr2lin  
   ENDIF 
   d= 0 adrpop d>m adr2+ d>m ( Set Ptr to NIL )

;


var (ptr) [ &0 &0 ] ;
: ptr 
( convert DS:SI to pointer )
( arg:	SI := Address )
( out:  SI : Address of pointer )
( chg: SI )
  bapush
  adr>b ds>a xab (ptr) ba>m
  bapop
;

: edptr
( convert ES:DI to pointer )
( arg:	ES:DI := FarAddress )
( out:  SI : Address of pointer )
( chg: SI )
   (ptr) ed>m
;

: edptr2
( convert ES:DI to pointer )
( arg:	ES:DI := FarAddress )
( out:  DI : Address of pointer )
( chg: DI )
  adrpush
  [ $F289 ] ( mov dx,si )
   (ptr) ed>m
   adr>d
  [ $D689 ] ( mov si,dx ) 
  adrpop
;

: m>l/cpy ( arg: SI=source ,DI=target, AX=count )
[ $0651 $C189 $EF01 $D28C $C28E $A4F3 $5907 ]
;

: l>m/cpy ( arg: SI=source ,DI=target, AX=count )
[ $1E51 $06 $C189 $DA8C $C28E $EE01 $D28C $DA8E $A4F3 $1F07 $59 ]
;

: xpush ( adr in SI , words to push in AX )
  [ $89 $CA	( mov dx,cx )
    $89 $C1	( mov cx,ax )
    $FF $34     ( push [si] )
    $46 $46	( inc si inc si )
    $E2 -6	( loop -6 )
    $89 $D1	( mov cx,dx )
  ]
;


: xpop ( adr in si , words to pop in ax )
  [ $89 $CA	( mov dx,cx )
    $89 $C1	( mov cx,ax )
    $01 $C6	( add si,ax )
    $01 $C6	( add si,ax )
    $8F $04     ( pop [si] )
    $4E $4E	( dec si dec si )
    $E2 -6	( loop -6 )
    $89 $D1	( mov cx,dx )
]
;
