(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
	*                SPRITES - for VGA-mode 13H		   *
        *                         V. 1.00                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B 25.08.93                   *
        *                                                          *
        ************************************************************
)

const sprsize 625 ;
const sprsize2 635 ; ( always sprsize+10 ) 
const sprsize3  1265 ; ( always sprsize * 2 +15 )

record spritetype
 var oldx [ *-1 ] ;
 var oldy word ;
 var x	  word ;
 var y	  word ;
 var w	  byte ;
 var h    byte ;
 var SpriteData byte sprsize ;
 var Buffer byte sprsize ;
 var active [ false ] ; 
 var ix	  [ *0 ] ;
 var iy   [ *0 ] ;
;

var virtual-screen [ *0 ] ;
var virtual-scr2   [ *$0 *65000 *0 ] ;

var sprfile file ;

const maxsprite 14 ;

var sprites nptr ;


: sprite-draw ( SI= Spriteadr )
[
 $1E $06 $8B $44 $04 $8B $5C $06 $89 $04 $89 $5C $02 $50 $53 $A1
 virtual-scr2 $8E $C0 $5B $B8 $40 $01 $F7 $E3 $5B $01 $D8 $89 $C7 $8A
 $54 $09 $30 $ED $8A $4C $08 $83 $C6 $0A $FC $57 $51 $8A $1C $08
 $DB $75 $06 $46 $47 $E2 $F6 $EB $03 $A4 $E2 $F1 $59 $5F $FE $CA
 $74 $06 $81 $C7 $40 $01 $EB $E3 $07 $1F 
]               
;  


function sprite-load [ ]  ( SI=File-name , BX = Sprite# )
var w word ;
var h word ;
begin
  bpush
  to sprfile fassign 
  sprfile fopen    
  sprfile fgetw w  a>local
  sprfile fgetw h  a>local
  h local>a w local>b * 
  spritetype_spritedata adr>d sprfile fget
  sprfile fclose
  w local>a spritetype_w  al>m
  h local>a spritetype_h  al>m
  0 spritetype_x b>m
  0 spritetype_y b>m
  sprites apop sprsize3 * adrn+ adr>d dpush
  spritetype , sprsize3 i/copy   
  adrpop , sprsize3 5 - adrn+ true bl>m
;

var screen [ *0 *$A000 ] ;

: sprite-show
  virtual-screen  to screen , 64000 memcpy
;  

: sprite-save
 ds>e
[
 $1E
 $06
 $89 $f7
 $26 $8B $45 $04
 $26 $8B $5D $06
 $50
 $53
 $A1 virtual-scr2
 $8E $D8
 $5B
 $B8 $40 $01
 $F7 $E3
 $5B
 $01 $D8
 $89 $C6
 $26 $8A $55 $09
 $30 $ED
 $26 $8A $4D $08
 $81 $C7 ( $7B $02 ) sprsize2 ( add di,sprsize2 )
 $FC
 $56
 $51
 $F3 $A4
 $59
 $5E
 $FE $CA
 $74 $06
 $81 $C6 $40 $01
 $EB $F0
 $07
 $1F
]
;

: sprite-restore

[
$1E $06 $8B $04 $8B $5C $02 $50 $53 $A1 virtual-scr2 $8E $C0
$5B $B8 $40 $01 $F7 $E3 $5B $01 $D8 $89 $C7 $8A $54 $09 $30 $ED
$8A $4C $08 $81 $C6 ( $7B $02 ) sprsize2 
$FC $57 $51 $F3 $A4 $59 $5F $FE $CA
$74 $06
$81 $C7 $40 $01 $EB $F0 $07 $1F
] 
;

: setgrmode ( switch to graphics mode specified in bl -> mode constants )
  b>a $10 intr
;


function drawsprites [ ]
var xadr word ;
begin
  maxsprite , 0 do
  ipush
    sprites i>a sprsize3 * adrn+ adr>a xadr a>local 
    xadr local>adr , sprsize3 5 - adrn+ m>al .true=. flag>
    xadr local>adr m>a *-1 .<>. .>and. IF
      xadr local>adr sprite-restore 
    ENDIF
   ipop 
  , 1 -loop 
  0 , maxsprite do
  ipush
    sprites i sprsize3 * adrn+ adr>a xadr a>local 
    xadr local>adr , sprsize3 5 - adrn+ m>al .true=. IF
      xadr local>adr sprite-save 
      xadr local>adr sprite-draw
    ENDIF
  ipop 
  loop
;

: sprite-hide ( bx= sprite# )
 bpush
 sprites , sprsize3 * adrn+ sprite-restore
 bpop sprites , sprsize3 * adrn+ *-1 b>m
;   


: sprite-xy ( bx= x, ax=y, di=sprite# )
 bapush d>b
 sprites , sprsize3 * adrn+ , 4 adrn+ bapop b>m adr2+ a>m
;   

: sprite-xy? ( arg:  di=sprite# )
	     ( ret: bx= x, ax=y )	
 d>b
 sprites , sprsize3 * adrn+ , 4 adrn+ m>b adr2+ m>a
;   


: sprite-motion ( bx= x, ax=y, di=sprite# )
 bapush d>b
 sprites , sprsize3 * adrn+ , sprsize3 4 - adrn+ bapop b>m adr2+ a>m
;   


function update [ ]
var xadr word ;
begin
(long)
  0 , maxsprite do
  ipush
    sprites i sprsize3 * adrn+ adr>a xadr a>local 
    xadr local>adr , sprsize3 5 - adrn+ m>al .true=. IF
      , sprsize3 4 - xadr local>adr  
      adrn+ m>a apush xadr local>adr , 4 adrn+ apop memn+
      , sprsize3 2- xadr local>adr  
      adrn+ m>a apush xadr local>adr , 6 adrn+ apop memn+
    ENDIF
  ipop
  loop
;

function .sprite-collision. [ ]
( ********************************** )
( * arg: sprite1# ax , sprite2# bx * )
( * res: CF set if collision       * )
( ********************************** )
var x1 word ; var w1 word ;
var y1 word ; var l1 word ;
var x2 word ; var w2 word ;
var y2 word ; var l2 word ;
begin
 apush
 sprites , sprsize3 * adrn+ adrpush , 4 adrn+ m>a adr2+ m>b x1 a>local y1 b>local
 adrpop , 8 adrn+ m>al adr+ m>bl w1 al>local l1 bl>local
 bpop
 sprites , sprsize3 * adrn+ adrpush , 4 adrn+ m>a adr2+ m>b x2 a>local y2 b>local
 adrpop , 8 adrn+ m>al adr+ m>bl w2 al>local l2 bl>local
 x2 local>b w2 local>al + a>d x1 local>a .>?<. flag>
 x1 local>b w1 local>al + a>d x2 local>a .>?<. .>or. flag>   
 y2 local>b l2 local>al + a>d y1 local>a .>?<. flag>
 y1 local>b l1 local>al + a>d y2 local>a .>?<. .>or. .>and.
 IF
   x2 local>a x1 local>b - apush
   y2 local>a y1 local>b - bpop
   .T.
 ELSE
  0 , 0 .F.
 ENDIF
;   

: sprite-alloc ( si : buf )
  adr>a adr sprites a>m 
;


record pcxheader 
  var id byte ;
  var ver byte ;
  var comp byte ;
  var bits byte ;
  var x1 word ; var y1 word ;
  var x2 word ; var y2 word ;
  var ax word ; var ay word ;
  var pal byte 48 ;
  var reserved byte ;
  var planes byte ;
  var bz word ;
  var pal2 word ;
  var reserved2 byte 58 ; 
;
var (loadpcx) [ &$A0000000 ] ;
var (pcx) file ;
function loadpcx [ ] 
( SI = FILENAME , DI = Target-ptr )
var count word ;
var color byte ;
begin
  dpush
  to (pcx) fassign
  adrpop m>ba (loadpcx) ba>m
  (pcx) fopen
  (pcx) to pcxheader , 128 fget  
  pcxheader_ay m>a pcxheader_ax m>b u* count a>local
  begin
    (pcx) fgetb apush $c0 and $c0 .<>. 
    IF
      apop color al>local  (loadpcx) al>^ (loadpcx) mem+ 
      count local>a 1- a>local
    ELSE
      (pcx) fgetb color al>local 
      apop $003f and 1 DO
        color local>al (loadpcx) al>^ (loadpcx) mem+ 
        count local>a 1- a>local .0=. IF LEAVE ENDIF
      LOOP
    ENDIF
  count local>a .0=.
  until 
  (pcx) fclose 
;

typ paltype byte 768 ;

: vert-retrace
  [ $FA $BA $DA $03 $EC $24 $08 $74 $FB $EC $24 $08 $75 $FB $FB ]
;


: .setpalette ( SI = 768 Byte buffer address )
  adr>a d.dx a>m
  ds>a d.es a>m
  0 d.bx b>m
  $FF d.cx b>m
  , $1012 $10 intr
;  

 : setpalette
   adr>e
   , 0 adr $3C8 al>p
   768 FOR
    e>adr i>a adr+ adr>e m>al adr $3C9 al>p
   NEXT
 ;
  
: getpalette ( SI = 768 Byte buffer address )
  adr>a d.dx a>m
  ds>a d.es a>m
  0 d.bx b>m
  $FF d.cx b>m
  , $1017 $10 intr
;


: FADEOUT
  paltype getpalette
  64 for ipush
    0 , 255 do
      paltype i a>b + + adrn+       m>al .0<>. IF 1- ENDIF al>m
      paltype i a>b + + adrn+ adr+  m>al .0<>. IF 1- ENDIF al>m
      paltype i a>b + + adrn+ adr2+ m>al .0<>. IF 1- ENDIF al>m
    loop 
    paltype setpalette 
  ipop next  
;

function fadein [ ] ( palette adr in SI )
var xpal paltype ;
begin
  to xpal , 768 m>l/cpy
  64 for ipush
    0 , 255 do
      xpal    i a>b + + adrn+       local>bl 
      paltype adrn+       m>al  .<. IF 1+ ENDIF al>m

      xpal    i a>b + + adrn+ adr+  local>bl
      paltype adrn+ adr+  m>al  .<. IF 1+ ENDIF al>m

      xpal    i a>b + + adrn+ adr2+  local>bl 
      paltype adrn+ adr2+ m>al .<. IF 1+ ENDIF al>m
    loop 
    paltype setpalette 
  ipop next  
  
;

