(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
        *              SYSTEM DEFINITIONS V1.00                    *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B 25.08.93                   *
        *                                                          *
        ************************************************************
)

	( ** Codesegment ** )

	aconst  entry    $102 ( Main           ) ;
 	aconst  HEAPPARA $10A ( Heapsize in paragraphs ) ;
	aconst  DSEG     $10C ( Datensegment   ) ;
	aconst  SSEG     $10E ( Stacksegment   ) ;
	aconst  exitcode $17A ( Exitcodeadr    ) ;
	( aconst  @SELF-PTR $182 ; )

	( ** Datensegment ** )

	aconst  D.AX  		$0000  ( Register AX  ) ;
	aconst  D.BX  		$0002  ( Register BX  ) ;
	aconst  D.CX  		$0004  ( Register CX  ) ;
	aconst  D.DX  		$0006  ( Register DX  ) ;
	aconst  D.BP  		$0008  ( Register BP  ) ;
	aconst  D.SI  		$000A  ( Register SI  ) ;
	aconst  D.DI  		$000C  ( Register DI  ) ;
	aconst  D.DS  		$000E  ( Register DS  ) ;
	aconst  D.ES  		$0010  ( Register ES  ) ;
	aconst  D.FL  		$0012  ( Flagregister ) ;
	aconst  UpperLoopLimit 	$0014 ;
	aconst  Conditionstack 	$0016 ;
	aconst  Exit-Byte      	$0018 ;    
	aconst  Break-Byte     	$0019 ;    
	aconst  Video-Byte     	$001A ;    
	aconst  Mouse-Byte     	$001B ;    
	( aconst Old-Int0-ofs  	$001C )
	( aconst Old-Int0-seg  	$001E )
	aconst  NPUStat        	$0020 ;     
	aconst  HEAPSEG        	$0022 ;    
	( frei 			$0026..$002F )
	( Start of Vars at 	$0030 )


	( *** System constants *** )

	const bl   32  ;   ( Leerzeichen )
	const bs   8   ;   ( Backspace )
	const TRUE  1 ;
	const FALSE 0 ;

	( *** Type definitions ** )

	typ  BYTE   [ 0 ]     ( Byte ) ;
	typ  BOOL   [ FALSE ] ( Byte 1=true 0=false ) ;
	typ  WORD   Byte 2    ( Word ) ;

	typ  FPTR   word 2    ( Farpointer ) ; 
	typ  DOUBLE word 2    ( Double ) ;
	typ  NPTR   word do:  ( Nearpointer )
	     [ $8B $34 ]      ( mov si,[si] ) ;
     
	  
	( *** System variables *** )

	var VPTR    word         ( Video-ptr ofs ) ;
	var VSEG    word         ( Video-ptr seg ) ;
	var HPTR    fptr         ( Heap-ptr ) ;
	var DPTR    fptr         ( Dataseg-ptr ) ;
	var FBUFSIZE [ &512 ]	 ( File buffer size ) ;

	( *** System vectors *** )

        vector errorptr ( Error vector for runtime errors ) ;
	vector doserr ( Fehlervektor fr DOS-Funktionen ) ;
	vector break  ( Control-C-Handler ) ;
	vector int0   ( Division durch Null ) ;
	vector emit   ( Zeichen ausgeben ) ;
	vector key    ( Zeichen eingeben ) ;
	vector ?key   ( Taste gedrckt ? ) ;


	var  stdout#   [ 2 ]    ( outhandle ) ;
	var  stdin#    [ 0 ]    ( inhandle ) ;
	var  hold#     [ 2 ]    ( temp. handle ) ;
	var  fin#      [ 0 ]    ( Eingabe-Textdatei ) ;
	var  fout#     [ 1 ]    ( Ausgabe-Textdatei ) ;
	var  fi/o#     [ 3 ]    ( Direktzugriffsdatei ) ;


	       MACRO ### 
	( **   Set breakpoint    ** )
	( BR-routine must be active )
	( ************************* )
	( arg: -                    )
	( out: -                    )
	( chg: -                    )
	( ************************* )
	[ $CC ]
	;

		    proc intr 
	( ** general interrupt interface  ** )
	( ** ignores arg given back in DS ** )
	( ********************************** )
	( arg: BL=  interrupt number         )
	(      AH=  function number          )
	(      AL=  subfunction number       )
	(      record d.xx = register args   )
	( out: CF:=0 if no error             )
	(      CF:=1 if error                )
	(      record d.xx:= register args   )
	(             except DS              )
	( chg: CF                            )
	( ********************************** )
	( push Register auf Returnstack )
	  [ $06 $57 $56 $55 $51 $53 $50 $1E  ] 
	  (  ES  DI  SI  BP  CX  BX  AX  DS  )
	( Interrupt patchen )  
	  [ $2E $88 $1E pc+ $24 ]
	( Register aus Dos-Interface laden )
	  [ $8B $1E *$02 ] ( mov  bx,[02]   )
	  [ $8B $0E *$04 ] ( mov  cx,[04]   )
	  [ $8B $16 *$06 ] ( mov  dx,[06]   )
	  [ $8B $2E *$08 ] ( mov  bp,[08]   )
	  [ $8B $36 *$0A ] ( mov  si,[0A]   )
	  [ $8B $3E *$0C ] ( mov  di,[0C]   )
	  [ $8E $06 *$10 ] ( mov  es,[10]   )
	  [ $FF $36 *$0E ] ( push [0E]      ) ( get DS .. )
	  [ $1F ]           ( pop  ds        ) ( and set )
	  [ $CD $00 ]       ( gepatchten Interrupt ausfhren )
	( Register in Dos-Interface retten )
	  [ $1F ]              ( pop ds      ) ( restor old DS )
	  [ $A3 *$00 ]        ( mov [00],ax )
	  [ $89 $1E *$02 ]    ( mov [02],bx )
	  [ $89 $0E *$04 ]    ( mov [04],cx )
	  [ $89 $16 *$06 ]    ( mov [06],dx )
	  [ $89 $2E *$08 ]    ( mov [08],bp )
	  [ $89 $36 *$0A ]    ( mov [0A],si )
	  [ $89 $3E *$0C ]    ( mov [0C],di )
	  [ $8C $06 *$10 ]    ( mov [10],es )
	( pop Register von Returnstack )
	  [ $58 $5B $59 $5D $5E $5F $07 ]
	  (  AX  BX  CX  BP  SI  DI  ES )
	  [ $FC ]              ( cld    )
	;

